c
c**********************************************************************************
C
C
      FUNCTION BONDCALC(IPH,ATOM1,ATOM2,SYM1,SYM2,DXYZ)
	INCLUDE 'param.inc'
	INTEGER ATOM1,ATOM2,SYM1,SYM2,IPH
      REAL X1(3),X2(3),XD2(3),XD1(3),DXYZ(3)
      REAL SM1(3,3),T1(3),SM2(3,3), T2(3), CELL(6)
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *AAA(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2)
	COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
	COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
	COMMON/DC/SAVE(NUPH,6),NSAVE
	PI = 3.141592654 
      DEG = PI/180.0
C
    
      DO J=1,3                                                        !UNPACK THE SYMMETRY MATRIXES
        IV=IVEC(IPH,SYM1)/32768/32**(3-J)
        IV=MOD(IV,32)
        SM1(J,1)=IV/9-1
        SM1(J,2)=MOD(IV/3,3)-1
        SM1(J,3)=MOD(IV,3)-1
        T1(J)=FLOAT(MOD(IVEC(IPH,SYM1)/32**(3-J),32)-16)/12.0
      ENDDO
C
      DO J=1,3                                                        !UNPACK THE SYMMETRY MATRIXES
        IV=IVEC(IPH,SYM2)/32768/32**(3-J)
        IV=MOD(IV,32)
        SM2(J,1)=IV/9-1
        SM2(J,2)=MOD(IV/3,3)-1
        SM2(J,3)=MOD(IV,3)-1
        T2(J)=FLOAT(MOD(IVEC(IPH,SYM2)/32**(3-J),32)-16)/12.0
      ENDDO
C
      IOF=0
      IF(IPH.GT.1) THEN
        DO 101 I=1,IPH-1
  101     IOF=IOF+ABS(NATOM(I))
      ENDIF               
C
      DO J=1,3            
          X1(J)=XL(ATOM1+IOF,J)                                               !XI,XL=X,Y,Z,B,N,B11,B22...
          IF (X1(J).LT.-0.5) X1(J) = X1(J)+1.0
          IF (X1(J).GE.0.5)  X1(J) = X1(J)-1.0
	ENDDO
	DO J=1,3            
          X2(J)=XL(ATOM2+IOF,J)                                                !XI,XL=X,Y,Z,B,N,B11,B22...
          IF (X2(J).LT.-0.5) X2(J) = X2(J)+1.0
          IF (X2(J).GE.0.5)  X2(J) = X2(J)-1.0
	ENDDO
C
      DO II=1,3
        YY=0.
        DO J=1,3
          YY=SM1(II,J)*X1(J)+YY
        ENDDO
        XD1(II)= YY + T1(II)
        IF (XD1(II).LT.-0.5) XD1(II) = 1.0 + XD1(II)                 !roll over into unit cell 1
        IF (XD1(II).GE.0.5) XD1(II) = -1.0 + XD1(II)
	ENDDO
c                                             !AND NUMBER
	DO II=1,3
        YY=0.
        DO J=1,3
          YY=SM2(II,J)*X2(J)+YY
        ENDDO
        XD2(II)= YY + T2(II)
        IF (XD2(II).LT.-0.5) XD2(II) = 1.0 + XD2(II)                 !roll over into unit cell 1
        IF (XD2(II).GE.0.5) XD2(II) = -1.0 + XD2(II)
	ENDDO
C
      DO I = 1,6
          CELL(I) = SAVE(IPH,I)
      ENDDO
C
      IF(CELL(4).LE.1.0) GOTO 11
      DO I=4,6
          CELL(I) = COS(CELL(I)*DEG)
      ENDDO
C
      DXYZ(1) = XD1(1)-XD2(1)
	DXYZ(2) = XD1(2)-XD2(2)
	DXYZ(3) = XD1(3)-XD2(3)
   11 BONDIST =(DXYZ(1)*CELL(1))**2+(DXYZ(2)*CELL(2))**2 
     * +(DXYZ(3)*CELL(3))**2 
     * + 2*DXYZ(1)*DXYZ(2)*cell(6)*CELL(1)*CELL(2)
     * + 2*DXYZ(1)*DXYZ(3)*cell(5)*CELL(1)*CELL(3)
     * + 2*DXYZ(2)*DXYZ(3)*cell(4)*CELL(2)*CELL(3)
      BONDCALC = SQRT(BONDIST)
      END
c
C
C         GENERATE BOND DISTANCES
      SUBROUTINE BONDGEN(IPH,RADMIN,DMAX)
      INCLUDE 'param.inc'
C         DECLARATIONS
      REAL RADMIN,DMAX,XYZ(MAXBAT,5),XYZTEMP(3)
      REAL XYZDIF(3),XYZSIG(MAXBAT,3),X(3) ,SM(3,3), T(3),CELSIG,PARSIG
      REAL BONDS(MAXBONDS,6),BONDIST,BONDERR,SCELL(6)
      REAL VALBOND(MAXBONDS,7),MINDIST,TEMPVAL
      REAL METRIC(3,3),DEG,Q,QQ,QQQ,CELSTR(6),CELL(6),DTEMP(3),UNITS
      REAL DQDPAR(6),DMTDCL(3,3,3),CELCOV(6,6),DCOV(6,6)
      INTEGER IPH,IOF,I,J,K,M,N,AM,BM,CM,II,JJ,IQ,IRL
      INTEGER NUMBONDS,NUMATOMS,FOUNDV,TEMPBOND,NMBONDS2,IND
      LOGICAL FOUNDB,FOUNDA,FOUNDIT
C         COMMONS
      COMMON/DC/SAVE(NUPH,6),NSAVE
      COMMON/F3/RJAC(MSZ,MSZ)
      COMMON/F2/SIGCEL(NUPH,6),SIGATOM(NATS,3)
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,11),LP(NATS,11),
     *AAA(NATS,11),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2)
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RAD1,RAD2,NMOLE,NRES,IMARQT,VMARQT
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
	COMMON/INTOTOF/ACELL(6),ACELCOV(6,6),ASIGCEL(NUPH,6)
	COMMON/PRSTU/TPAR(NUPH,6),TERR(NUPH,6),TPR(NUPH,NATS,2,5),
     *SOTHER(NUPH,NATS,2,11),THERS(MAXDS,4)
	COMMON/DRAG/NUMHIS
	COMMON/MOREBR/THEBRA(NUPH,MAXDS)
	REAL R0,Z1,Z2,Z3,Z4,Z5,Z6,Z7,Z8,Z9
	REAL Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8,Y9,Y10,Y11,Y12
	REAL X1,X2,X3,X4,X5,X6,X7,X8,X9,X10,X11,X12
	REAL V1,V2,V3,V4,V5,V6,V7,V8,V9,V10
     
C
C         Constants  
      PI = 3.141592654                                           
      DEG = PI/180.0    
      UNITS = 1.0
C             CELL CONSTANT DEFINITIONS      
      DO 1000 I = 1,6
          CELL(I) = SAVE(IPH,I)
	TPAR(IPH,I) = SAVE(IPH,I)
	TERR(IPH,I) = SIGCEL(IPH,I)
 1000     SCELL(I) = SIGCEL(IPH,I)
C
      IF(CELL(4).LE.1.0) GOTO 11
      DO 1010 I=4,6
          CELL(I) = COS(CELL(I)*DEG)
 1010     SCELL(I) = SCELL(I)*DEG*SQRT(1.0-CELL(I)*CELL(I))
C
   11 Q = SQRT(1.0-CELL(4)*CELL(4))
      QQ = SQRT(1.0-CELL(5)*CELL(5))
      QQQ = SQRT(1.0-CELL(6)*CELL(6))
      CELSTR(4) = (CELL(5)*CELL(6)-CELL(4))/(QQ*QQQ)
      CELSTR(5) = (CELL(4)*CELL(6)-CELL(5))/(Q*QQQ)
      CELSTR(6) = (CELL(4)*CELL(5)-CELL(6))/(Q*QQ)
      Q4 = SQRT(1.0+2.0*CELL(4)*CELL(5)*CELL(6) - CELL(4)*CELL(4)
     1   - CELL(5)*CELL(5) - CELL(6)*CELL(6) )
      CELSTR(1) =   Q/(Q4*CELL(1))
      CELSTR(2) =  QQ/(Q4*CELL(2))
      CELSTR(3) = QQQ/(Q4*CELL(3))
      AM = IFIX(DMAX/CELL(1)+1)
      BM = IFIX(DMAX/CELL(2)+1)
      CM = IFIX(DMAX/CELL(3)+1)
      DO 12 I=1,3                                                         !METRIC = (  a^2        ab cos(gam)  ac cos(bet) )
      DO 12 J=1,3                                                         !         (ab cos(gam)     b^2       bc cos(alp) )
      K = 9 - I - J                                                       !         (ac cos(bet)  bc cos(alp)      c^2     )
      IF(I.EQ.J) METRIC(I,J) = CELL(I)*CELL(I)
      IF(I.NE.J) METRIC(I,J) = CELL(I)*CELL(J)*CELL(K)
   12 CONTINUE
c      WRITE(10,'(3(3F8.3,/))') ((METRIC(I,J),I=1,3),J=1,3)
      DO 17 K=1,3                                                           
      Q = CELL(K)
      DO 17 I=1,3
      DO 17 J=1,3
          IF(I.EQ.K.OR.J.EQ.K) DMTDCL(I,J,K) = METRIC(I,J)/Q
          IF(I.NE.K.AND.J.NE.K) DMTDCL(I,J,K) = 0.0
   17 CONTINUE
      DO 18 I=1,3
   18 DMTDCL(I,I,I) = 2.0*DMTDCL(I,I,I)
      DO 1020 I=1,6
          DO 1020 J=1,6                       
              KI = LPAR(IPH,I+5)
              KJ = LPAR(IPH,J+5)
              IF ((KI.NE.0).AND.(KJ.NE.0).AND.(KI.LE.MAXS).AND.
     *            (KJ.LE.MAXS)) THEN
                 CELCOV(I,J) = RJAC(KI,KJ)/SQRT(RJAC(KI,KI)*RJAC(KJ,KJ))
     *                    *SCELL(I)*SCELL(J)
              ELSE
                  CELCOV(I,J) = 0.0
              ENDIF
 1020 CONTINUE
      IRL=MLT(IPH)                                                        !SPACE GROUP MULTIPLICITY OF PHASE

C
      IOF=0
      IF(IPH.GT.1) THEN
        DO 101 I=1,IPH-1
  101     IOF=IOF+ABS(NATOM(I))
      ENDIF               
      NUMBONDS = 0
      BONDS(1,1) =0.0
C         GENERATE ALL THE ATOMS IN THE UNIT CELL
      NUMATOMS = 0
    3 DO 8 I=1,ABS(NATOM(IPH))                                                 !NUM OF ATOMS IN PHASE
      NUMATOMS = NUMATOMS + 1                                             !FOR THE INITIAL X,Y,Z FROM THE INP FILE
      DO 1080 J=1,3            
          X(J)=XL(I+IOF,J)                                                !XI,XL=X,Y,Z,B,N,B11,B22...
          IF (X(J).LT.0) X(J) = X(J)+1.0
          IF (X(J).GE.1) X(J) = X(J)-1.0
          XYZ(NUMATOMS,J) = X(J)
 1080     XYZSIG(NUMATOMS,J) = SIGATOM(I+IOF,J)
      XYZ(NUMATOMS,4) = FLOAT(I+IOF)

      DO 8 IR=1,IRL                                                       !IRL= NUMBER OF SPACE GROUP OPERATIONS
      DO 301 J=1,3                                                        !UNPACK THE SYMMETRY MATRIXES
        IV=IVEC(IPH,IR)/32768/32**(3-J)
        IV=MOD(IV,32)
        SM(J,1)=IV/9-1
        SM(J,2)=MOD(IV/3,3)-1
        SM(J,3)=MOD(IV,3)-1
  301   T(J)=FLOAT(MOD(IVEC(IPH,IR)/32**(3-J),32)-16)/12.0

      DO 6 II=1,3
        YY=0.
        DO 7 J=1,3
    7     YY=SM(II,J)*X(J)+YY
        XYZTEMP(II)= YY + T(II)
        IF (XYZTEMP(II).LT.0.) XYZTEMP(II) = INT(ABS(XYZTEMP(II))+1)+
     *                                        XYZTEMP(II)                 !roll over into unit cell 1
    6   IF (XYZTEMP(II).GE.1.) XYZTEMP(II) = -INT(ABS(XYZTEMP(II)))+
     *                                        XYZTEMP(II)
c    6 continue
      FOUNDA = .FALSE.
      DO 1030 JJ=1,NUMATOMS                                               !MAKE SURE WE ONLY COUNT THEM ONCE
          IF ((XYZTEMP(1).eq.XYZ(JJ,1)).AND.                        
     &        (XYZTEMP(2).eq.XYZ(JJ,2)).AND.
     &        (XYZTEMP(3).eq.XYZ(JJ,3)).AND.
     &        ((I+IOF).EQ.INT(XYZ(JJ,4)))) THEN
                  FOUNDA = .TRUE.
                  XYZ(JJ,5) = XYZ(JJ,5) + 1
          ENDIF
 1030 CONTINUE
      IF (.NOT.FOUNDA) THEN    
        NUMATOMS = NUMATOMS + 1         
        DO 1090 JJ=1,3
          XYZ(NUMATOMS,JJ) = XYZTEMP(JJ)
 1090     XYZSIG(NUMATOMS,JJ) = SIGATOM(I+IOF,JJ)
        XYZ(NUMATOMS,4) = FLOAT(I+IOF)                                    !KEEP A RECORD OF THE ATOM TYPE
        XYZ(NUMATOMS,5) = 1.0                                             !AND NUMBER
C          WRITE(10,*) I,(XYZ(NUMATOMS,JJ),JJ=1,3)
C          WRITE(10,*) I,(XYZSIG(NUMATOMS,JJ),JJ=1,3)
      ENDIF
    8 CONTINUE
C
C               loop over all possible atom-atom pairs
      DO 30 M=1,NUMATOMS
      DO 30 N=M,NUMATOMS
C            loop over all the possible unit cells for a particular atom pair
      DO 20 I=-AM,AM
      DO 20 J=-BM,BM
      DO 20 K=-CM,CM 
c              bond length
      XYZDIF(1) = (XYZ(M,1)-XYZ(N,1)+I)*cell(1)
      XYZDIF(2) = (XYZ(M,2)-XYZ(N,2)+J)*cell(2)
      XYZDIF(3) = (XYZ(M,3)-XYZ(N,3)+K)*cell(3)
c      CALL MATMULT(BONDIST,XYZDIF,METRIC,XYZDIF,1,3,3,1)
      BONDIST = xyzdif(1)**2 + xyzdif(2)**2 + xyzdif(3)**2 
     * + 2*xyzdif(1)*xyzdif(2)*cell(6)
     * + 2*xyzdif(1)*xyzdif(3)*cell(5)
     * + 2*xyzdif(2)*xyzdif(3)*cell(4)
      BONDIST = SQRT(BONDIST)
      XYZDIF(1) = (XYZ(M,1)-XYZ(N,1)+I)
      XYZDIF(2) = (XYZ(M,2)-XYZ(N,2)+J)
      XYZDIF(3) = (XYZ(M,3)-XYZ(N,3)+K)
      IF ((BONDIST.GT.DMAX).OR.(BONDIST.LE.(RADMIN+0.0001))) GOTO 20                     
c      calculate lattice parameter error contribution
      DO 1040 II=1,3
 1040      CALL MATMULT(DQDPAR(II),XYZDIF,DMTDCL(1,1,II),XYZDIF,1,3,3,1)
      DQDPAR(4) = 2.0*CELL(2)*CELL(3)*XYZDIF(2)*XYZDIF(3)
      DQDPAR(5) = 2.0*CELL(1)*CELL(3)*XYZDIF(1)*XYZDIF(3)
      DQDPAR(6) = 2.0*CELL(1)*CELL(2)*XYZDIF(1)*XYZDIF(2)
      CALL MATMULT(CELSIG,DQDPAR,CELCOV,DQDPAR,1,6,6,1)
      if (celsig.lt.0.0) then
c          write(*,*) 'celsig negative',celsig
          celsig = 0.0
      endif
c      calculate positional error contribution
      CALL MATMULT(DTEMP,METRIC,XYZDIF,UNITS,3,3,1,1)
      DO 50 IJ=1,3
          DQDPAR(IJ) = -2.0*DTEMP(IJ)
   50     DQDPAR(IJ+3) = 2.0*DTEMP(IJ)
      DO 1050 IJ = 1,3
C      DO JI = 1,6
C          DCOV(JI,IJ) = RJAC(KI,KJ)/SQRT(RJAC(KI,KI)*RJAC(KJ,KJ))
C     *                    *XYZSIG(JI)*XYZSIG(IJ)
          DCOV(IJ,IJ) = XYZSIG(M,IJ)**2
 1050     DCOV(IJ+3,IJ+3) = XYZSIG(N,IJ)**2
      CALL MATMULT(PARSIG,DQDPAR,DCOV,DQDPAR,1,6,6,1)
      if (parsig.lt.0.0) then
c          write(*,*) 'parsig negative',parsig
          parsig = 0.0
      endif
C      PARSIG = 0.0
C        Check to see if the bond is current in the list for this atom pair
      FOUNDB = .FALSE.
      DO 1060 IQ = 1,NUMBONDS
        IF (ABS(BONDIST-BONDS(IQ,1)).LT.0.00005) THEN
          FOUNDB = .TRUE.
          FOUNDV = IQ
        ENDIF
 1060 CONTINUE                             
c        store information if this bond has not been found before.  If it has then increment the counter
      IF (.NOT.FOUNDB) THEN              
          BONDERR = SQRT(PARSIG + CELSIG)/(2.0*BONDIST)
C          WRITE(*,*) BONDIST, PARSIG,CELSIG
          NUMBONDS = NUMBONDS + 1
          BONDS(NUMBONDS,1) = BONDIST                                     !BONDIST
          BONDS(NUMBONDS,2) = BONDERR                                     !ERROR    
          BONDS(NUMBONDS,3) = XYZ(M,4)                                    !ATOM 1
          BONDS(NUMBONDS,4) = XYZ(N,4)                                    !ATOM 2
          BONDS(NUMBONDS,5) = 1                                           !trying to do COORDINATION
      ELSE
          IF (((BONDS(FOUNDV,3).EQ.XYZ(M,4)).AND.(BONDS(FOUNDV,4).EQ.
     *    XYZ(N,4))).OR.((BONDS(FOUNDV,4).EQ.XYZ(M,4)).AND.
     *    (BONDS(FOUNDV,3).EQ.XYZ(N,4)) )) 
     *                           BONDS(FOUNDV,5) = BONDS(FOUNDV,5) + 1
      ENDIF
   20 CONTINUE
   30 CONTINUE
C	 Modified down
C		This should be my bond valence bit!
C
C               loop over all possible atom-atom pairs
      MINDIST = RADMIN
      IF (MINDIST .LT. 0.1) THEN
        MINDIST = 0.1
      ENDIF 
      DO 130 M=1,NUMATOMS
      DO 130 N=M,NUMATOMS
C            loop over all the possible unit cells for a particular atom pair
c      DO 120 I=-1,1
c      DO 120 J=-1,1
c      DO 120 K=-1,1 
      DO 120 I=-AM,AM
      DO 120 J=-BM,BM
      DO 120 K=-CM,CM 
c              bond length
      XYZDIF(1) = (XYZ(M,1)-XYZ(N,1)+I)*cell(1)
      XYZDIF(2) = (XYZ(M,2)-XYZ(N,2)+J)*cell(2)
      XYZDIF(3) = (XYZ(M,3)-XYZ(N,3)+K)*cell(3)
c      CALL MATMULT(BONDIST,XYZDIF,METRIC,XYZDIF,1,3,3,1)
      BONDIST = xyzdif(1)**2 + xyzdif(2)**2 + xyzdif(3)**2 
     * + 2*xyzdif(1)*xyzdif(2)*cell(6)
     * + 2*xyzdif(1)*xyzdif(3)*cell(5)
     * + 2*xyzdif(2)*xyzdif(3)*cell(4)
      BONDIST = SQRT(BONDIST)
C      XYZDIF(1) = (XYZ(M,1)-XYZ(N,1)+I)
C      XYZDIF(2) = (XYZ(M,2)-XYZ(N,2)+J)
C      XYZDIF(3) = (XYZ(M,3)-XYZ(N,3)+K)
      BONDVALE = 0
      IF ((BONDIST.LE.DMAX).AND.(BONDIST.GE.MINDIST)) THEN
         CALL GETR0(R0,NTYP(INT(XYZ(M,4)+0.01)),NTYP(INT(XYZ(N,4)+0.01))
     *,BONDIST)
         IF (R0 .NE. 0) THEN
            BONDVALE = EXP(((R0)-BONDIST)/0.37)
         ENDIF
         IF (BONDVALE .NE. 0) THEN
C   13			FORMAT('BONDVALENCE',F8.4 ' ',F8.4 ' ',F8.4)
C			WRITE(10,13)  BONDVALE,XYZ(M,4),XYZ(N,4)
            FOUNDIT = .FALSE.
            DO 88 IND=1, NMBONDS2
c	IF (((VALBOND(IND,3).EQ.XYZ(M,4)).AND.(VALBOND(IND,4).EQ.XYZ(N,4))
c	*).or.((VALBOND(IND,3).EQ.XYZ(N,4)).AND.(VALBOND(IND,4).EQ.XYZ(M,4)	
c     *))) then
      IF ((VALBOND(IND,3).EQ.XYZ(M,4)).AND.(VALBOND(IND,4).EQ.XYZ(N,4))
     * ) then
                      TEMPBOND = IND
                      FOUNDIT = .TRUE.
                ENDIF
   88       CONTINUE
            IF (.NOT. FOUNDIT) THEN
            NMBONDS2 = NMBONDS2 + 1
            VALBOND(NMBONDS2,1) = BONDVALE
            VALBOND(NMBONDS2,3) = XYZ(M,4)
            VALBOND(NMBONDS2,4) = XYZ(N,4)
            VALBOND(NMBONDS2,5) = M
            VALBOND(NMBONDS2,6) = 1
            VALBOND(NMBONDS2,7) = 1
            ELSE
              VALBOND(TEMPBOND,1) = VALBOND(TEMPBOND,1) + BONDVALE
              VALBOND(TEMPBOND,7) = VALBOND(TEMPBOND,7) + 1
              IF (VALBOND(TEMPBOND,5).NE.M) THEN
                  VALBOND(TEMPBOND,5) = M
                  TEMPVAL = VALBOND(TEMPBOND,6)
                  VALBOND(TEMPBOND,6) = TEMPVAL + 1
C	                PRINT *,  VALBOND(TEMPBOND,6)
              ENDIF
            ENDIF 
          ENDIF
      ENDIF
      IF ((BONDIST.GT.DMAX).OR.(BONDIST.LE.(RADMIN+0.0001))) GOTO 120
  120 CONTINUE
  130 CONTINUE
C	  Now Output
  	DO ILL = 1,NATOM(IPH)
		If (TPR(IPH,ILL,1,4) .EQ. 0) THEN
			IF (SOTHER(IPH,ILL,1,6) .NE. 0) THEN
				IF (ITHER .EQ. 0) THEN
				 W1 = SOTHER(IPH,ILL+IOF,1,6)*TPAR(IPH,1)*TPAR(IPH,1)
				 W2 = SOTHER(IPH,ILL+IOF,1,7)*TPAR(IPH,2)*TPAR(IPH,2) 
				 W3 = SOTHER(IPH,ILL+IOF,1,8)*TPAR(IPH,3)*TPAR(IPH,3) 
				 W4 =2*SOTHER(IPH,ILL+IOF,1,9)*TPAR(IPH,1)*TPAR(IPH,2)
				 W5=2*SOTHER(IPH,ILL+IOF,1,10)*TPAR(IPH,2)*TPAR(IPH,3)
				 W6=2*SOTHER(IPH,ILL+IOF,1,11)*TPAR(IPH,1)*TPAR(IPH,3)
				 TPR(IPH,ILL+IOF,1,4) = W1 + W2 + W3 - W4 - W5 - W6
				 Z1 = TERR(IPH,1)*TERR(IPH,1)
				 IF	(Z1 .EQ. 0) Z1 = 0.000001	 
				 Z2 = TERR(IPH,2)*TERR(IPH,2)
				 IF	(Z2 .EQ. 0) Z2 = 0.000001
				 Z3 = TERR(IPH,3)*TERR(IPH,3)
				 IF	(Z3 .EQ. 0) Z3 = 0.000001
				 Z4 = TPAR(IPH,1)*TPAR(IPH,1)
				 Z5 = TPAR(IPH,2)*TPAR(IPH,2)
				 Z6 = TPAR(IPH,3)*TPAR(IPH,3)
				 Z7 = TPAR(IPH,1)*TPAR(IPH,2)
				 Z8 = TPAR(IPH,2)*TPAR(IPH,3)
				 Z9 = TPAR(IPH,1)*TPAR(IPH,3)
				 Y1 = SOTHER(IPH,ILL+IOF,1,6)*SOTHER(IPH,ILL+IOF,1,6)
				 IF	(Y1 .EQ. 0) Y1 = 0.000001
				 Y2 = SOTHER(IPH,ILL+IOF,1,7)*SOTHER(IPH,ILL+IOF,1,7)
				 IF	(Y2 .EQ. 0) Y2 = 0.000001
				 Y3 = SOTHER(IPH,ILL+IOF,1,8)*SOTHER(IPH,ILL+IOF,1,8)
				 IF	(Y3 .EQ. 0) Y3 = 0.000001
				 Y4 = SOTHER(IPH,ILL+IOF,1,9)*SOTHER(IPH,ILL+IOF,1,9)
				 IF	(Y4 .EQ. 0) Y4 = 0.000001
				 Y5= SOTHER(IPH,ILL+IOF,1,10)*SOTHER(IPH,ILL+IOF,1,10)
				 IF	(Y5 .EQ. 0) Y5 = 0.000001
				 Y6= SOTHER(IPH,ILL+IOF,1,11)*SOTHER(IPH,ILL+IOF,1,11)
				 IF	(Y6 .EQ. 0) Y6 = 0.000001
				 Y7 = SOTHER(IPH,ILL+IOF,2,6)*SOTHER(IPH,ILL+IOF,2,6)
				 IF	(Y7 .EQ. 0) Y7 = 0.00000000001
				 Y8 = SOTHER(IPH,ILL+IOF,2,7)*SOTHER(IPH,ILL+IOF,2,7)
				 IF	(Y8 .EQ. 0) Y8 = 0.0000000001
				 Y9 = SOTHER(IPH,ILL+IOF,2,8)*SOTHER(IPH,ILL+IOF,2,8)
				 IF	(Y9 .EQ. 0) Y9 = 0.0000000001
				 Y10= SOTHER(IPH,ILL+IOF,2,9)*SOTHER(IPH,ILL+IOF,2,9)
				 IF	(Y10 .EQ. 0) Y10 = 0.0000000001
				 Y11=SOTHER(IPH,ILL+IOF,2,10)*SOTHER(IPH,ILL+IOF,2,10)
				 IF	(Y11 .EQ. 0) Y11 = 0.0000000001
				 Y12=SOTHER(IPH,ILL+IOF,2,11)*SOTHER(IPH,ILL+IOF,2,11)
				 IF	(Y12 .EQ. 0) Y12 = 0.0000000001
				 X1 = SQRT(Z1/Z4+Z1/Z4)*SQRT(Z1/Z4+Z1/Z4)
				 X2 = SQRT(Z2/Z5+Z2/Z5)*SQRT(Z2/Z5+Z2/Z5)
				 X3 = SQRT(Z3/Z6+Z3/Z6)*SQRT(Z3/Z6+Z3/Z6)
				 X4 = SQRT(Z1/Z4+Z2/Z5)*SQRT(Z1/Z4+Z3/Z5)
				 X5 = SQRT(Z2/Z5+Z3/Z6)*SQRT(Z2/Z5+Z3/Z6)
				 X6 = SQRT(Z1/Z4+Z3/Z6)*SQRT(Z1/Z4+Z3/Z6)
				 X7 = SQRT(Y7/Y1+X1/(Z4*Z4))*SQRT(Y7/Y1+X1/(Z4*Z4))
	             X8 = SQRT(Y8/Y2+X2/(Z5*Z5))*SQRT(Y8/Y2+X2/(Z5*Z5))
				 X9 = SQRT(Y9/Y3+X3/(Z6*Z6))*SQRT(Y9/Y3+X3/(Z6*Z6))
				 X10 = SQRT(Y10/Y4+X4/(Z7*Z7))*SQRT(Y10/Y4+X4/(Z7*Z7))
				 X11 = SQRT(Y11/Y5+X5/(Z8*Z8))*SQRT(Y11/Y5+X5/(Z8*Z8))
				 X12 = SQRT(Y12/Y6+X6/(Z9*Z9))*SQRT(Y12/Y6+X6/(Z9*Z9))
				 V1 = SQRT(X1 + X2)*SQRT(X1 + X2)
				 V2 = SQRT(X3 + X4)*SQRT(X3 + X4)
				 V3 = SQRT(X5 + X6)*SQRT(X5 + X6)
				 V4 = SQRT(X7 + X8)*SQRT(X7 + X8)
				 V5 = SQRT(X9 + X10)*SQRT(X9 + X10)
				 V6 = SQRT(X11 + X12)*SQRT(X11 + X12)
				 V7 = SQRT(V1 + V2)*SQRT(V1 + V2)
				 V8 = SQRT(V3 + V4)*SQRT(V3 + V4)
				 V9 = SQRT(V5 + V6)*SQRT(V5 + V6)
				 V10 = SQRT(V7 + V8)*SQRT(V7 + V8)
				 TPR(IPH,ILL+IOF,2,4) = SQRT(V10 + V9)
				else
				 w1 = SOTHER(IPH,ILL+IOF,1,6)
				 w2 = SOTHER(IPH,ILL+IOF,1,7)
				 w3 = SOTHER(IPH,ILL+IOF,1,8)
				 TPR(IPH,ILL+IOF,1,4) = (PI*PI/3)*8*(w1+w2+w3)
				 v1 = SOTHER(IPH,ILL+IOF,2,6)*SOTHER(IPH,ILL+IOF,2,6)
				 v2 = SOTHER(IPH,ILL+IOF,2,7)*SOTHER(IPH,ILL+IOF,2,7)
				 v3 = SOTHER(IPH,ILL+IOF,2,8)*SOTHER(IPH,ILL+IOF,2,8)
				 v4 = SQRT(v1 + v2)
				 v5 = SQRT(v3 + v4*v4)
				 TPR(IPH,ILL+IOF,2,4) = v5 	
				ENDIF		
			ENDIF
		ELSE
			IF (SOTHER(IPH,ILL+IOF,1,1) .NE. 0) THEN
				WRITE(10,68)
			ENDIF
		ENDIF 
	ENDDO
  	WRITE(10,56) IPH
	WRITE(10,57) (TPAR(IPH,I),NINT(TERR(IPH,I)*10000),I=1,3)
	WRITE(10,58) (TPAR(IPH,I),NINT(TERR(IPH,I)*10000),I=4,6)
	WRITE(10,66)
      DO ILL = 1,NUMHIS
		WRITE(10,67) ILL,(THERS(ILL,ILK),ILK=1,4),
     *                 THEBRA(IPH,ILL)
      ENDDO 
	WRITE(10,59)
	Do	ILL = 1,NATOM(IPH)
		WRITE(10,61) ATEXT(ILL+IOF),(TPR(IPH,ILL+IOF,1,ILK),
     *		NINT(TPR(IPH,ILL+IOF,2,ILK)*10000),ILK=1,3),
     *		TPR(IPH,ILL+IOF,1,4),NINT(TPR(IPH,ILL+IOF,2,4)*100),
     *		TPR(IPH,ILL+IOF,1,5),NINT(TPR(IPH,ILL+IOF,2,5)*1000)  
	ENDDO
	IF (ITHER .EQ. 0) THEN 
		WRITE(10,62)
	ELSE
		WRITE(10,64)
	ENDIF
	DO ILL = 1,NATOM(IPH)
		WRITE(10,63) ATEXT(ILL+IOF),(SOTHER(IPH,ILL+IOF,1,ILK),
     *		NINT(SOTHER(IPH,ILL+IOF,2,ILK)*10000),ILK=6,11)
	ENDDO
   56 FORMAT(/,60(1H*),/,' Lattice Parameters for Phase',i3)
   57	FORMAT('a  ',F11.4,'(',I4,')',2x,'b  ',F11.4,'(',I4,')',2x,
     *'c  ',F11.4,'(',I4,')')
   58	FORMAT('alpha  ',F8.4,'(',I4')',2x,'beta   ',F8.4,'(',I4,
     *')',2x,'gamma  ',F8.4,'(',I4,')')
   59	FORMAT(/,'ATOM',10x,'x',13x,'y',11x,'z',10x,'Biso',10x,'N')
   61	FORMAT(A4,2x,3(F8.4,'(',I4,')'),F5.2,'(',I3,')',F7.3,'(',I3,')')
   62 FORMAT(/,'ATOM',10x,'B11',14x,'B22',14x,'B33',14x,'B12',14x,
     * 'B13',14x,'B23')
   63 FORMAT(A4,6(2x,F9.4,'(',I4,')'))
   64	FORMAT(/,'ATOM',10x,'U11',14x,'U22',14x,'U33',14x,'U12',14x,
     * 'U13',14x,'U23')
   66 FORMAT(/,' HISTOGRAM     Rp       Rwp       Rexp       GOF    ',
     * 'RBRAGG')
   67 FORMAT(2x,I2,5x,4(4x,F6.2),x,F8.2)
   68 FORMAT('ERROR TRYING TO REFINE ANISOMETRIC AND ',
     *				'ISOMETRIC THERMAL PARAMETERS.')
C
C
C    Modified up
c     Print out bonds
    1 FORMAT(/,' Bond Distances for Phase ',I3,/,
C     *' Lattice Parameters =',6(1X,F8.4),/,
     *' Number of atoms in unit cell = ',I5)
   41 FORMAT(/,5x,'ATOM1    ATOM2     DISTANCE   ERROR')
   40 FORMAT(5X,A4,'  -  ',A4,5X,2F8.4)
      WRITE(10,1) IPH, NUMATOMS !(SAVE(IPH,I),I=1,6),NUMATOMS 
      WRITE(10,41)
      DO 1070 I = 1,NUMBONDS        
          IF(I.GT.2) THEN
          IF( (INT(BONDS(I,3)+0.1).NE.INT(BONDS(I-1,3)+0.1)).OR.
     *      (INT(BONDS(I,4)+0.1).NE.INT(BONDS(I-1,4)+0.1))) WRITE(10,41)
          ENDIF
      WRITE(10,40) ATEXT(INT(BONDS(I,3)+0.1)),ATEXT(INT(BONDS(I,4)+0.1))
     *            ,BONDS(I,1),BONDS(I,2)
 1070 CONTINUE
C	Printout bondvalences
   52 FORMAT(/,5x,'ATOM1    ATOM2     BONDVALENCE    COORD')
   53 FORMAT(5X,A4,'  -  ',A4,7X,F4.2,5X,I8)
      WRITE(10,52)
      DO 87 I=1, NMBONDS2
           TEMPVAL = (VALBOND(I,1)/VALBOND(I,6))
           WRITE(10,53) ATEXT(INT(VALBOND(I,3)+0.1))
     *   ,ATEXT(INT(VALBOND(I,4)+0.1)),TEMPVAL
     *   ,INT(VALBOND(I,7)/VALBOND(I,6))
   87 CONTINUE

C      Code for Bond angles
C
      DO I=1,6
          DO J=1,6                       
              KI = LPAR(IPH,I+5)
              KJ = LPAR(IPH,J+5)
              IF ((KI.NE.0).AND.(KJ.NE.0).AND.(KI.LE.MAXS).AND.
     *            (KJ.LE.MAXS)) THEN
                 CELCOV(I,J) = RJAC(KI,KJ)/SQRT(RJAC(KI,KI)*RJAC(KJ,KJ))
              ELSE
                  CELCOV(I,J) = 0.0
                  IF (I.EQ.J) CELCOV(I,J) = 1.0
              ENDIF
          ENDDO
      ENDDO

      DO 125 I= 1,6
          ACELL(I)=CELL(I)
  125 CONTINUE
      DO 126 I= 1,6
          DO 127 J= 1,6
              ACELCOV(I,J)=CELCOV(I,J)
  127     CONTINUE
  126 CONTINUE
      DO 128 I= 1,NUPH
          DO 129 J= 1,6
              ASIGCEL(I,J)=SIGCEL(I,J)
  129     CONTINUE
  128 CONTINUE
c
      DO I=1,ABS(NATOM(IPH))                                                 !NUM OF ATOMS IN PHASE
        DO J=1,3            
          X(J)=XL(I+IOF,J)                                                !XI,XL=X,Y,Z,B,N,B11,B22...
          IF (X(J).LT.0) X(J) = X(J)+1.0
          IF (X(J).GE.1) X(J) = X(J)-1.0
          XYZ(I,J) = X(J)
          XYZSIG(I,J) = SIGATOM(I+IOF,J)
        ENDDO
        XYZ(I,4) = FLOAT(I+IOF)
      ENDDO
      CALL ANGLES(IPH,DMAX,XYZ,XYZSIG)
      RETURN
      END
c
c**********************************************************************************
c
      SUBROUTINE MATMULT(ANS,A1,A2,A3,II,JJ,KK,LL)
      DIMENSION ANS(II,LL),A1(II,JJ),A2(JJ,KK),A3(LL,KK)
      DO 10 I=1,II
      DO 10 L=1,LL
      ANS(I,L) = 0.0
      DO 10 J=1,JJ
      DO 10 K=1,KK
      ANS(I,L) = ANS(I,L) + A1(I,J)*A2(J,K)*A3(L,K)
   10 CONTINUE
      RETURN
      END  
C      
C	*****************************************************************
C	GETR0
      SUBROUTINE GETR0(R0now,char1,char2,bondlen)
C	INCLUDE 'param.inc'
      COMMON/BONDVAL/BONDVO(109),BONDVF(109),BONDVCL(109),IONRAD(109)
     *,BONDC
      CHARACTER*4 BONDC(109)
      REAL R0NOW
C
      CHARACTER*4 char1,char2,char3,char4,char5,char6
      integer ind1,ind2,i1,i2,index
C	print *, 'Were in'
      R0now = 0
      char4 = 'O-2 '
      char5 = 'F-1 '
      char6 = 'CL-1'
      DO 10, ind1 = 1, 4
          if (char1(ind1:ind1) .EQ. ' ') then
              i1 = ind1 - 1
              goto 15
          endif
          i1 = ind1 
   10 CONTINUE
   15 DO 20, ind2 = 1, 4
          if (char2(ind2:ind2) .EQ. ' ') then
              i2 = ind2 - 1
              goto 25
          endif
          i2 = ind2 
   20 CONTINUE
   25 IF ((CHAR1.NE.'O   ').AND.(CHAR1.NE.'CL  ').AND.
     *        (CHAR1.NE.'F   ')) THEN
         IF (char2(:i2) .EQ. char4(:i2)) THEN 
              Do 40, index = 1, 109
                  char3 = BONDC(index)
C				print *, char3(:i1),'-', char1(:i1)
                  if (char1(:i1) .EQ. char3(:i1)) then
C					print *, 'R0 equals', BONDVO(index)
                  if (bondlen .LE. ((IONRAD(index)+1.42)*1.5)) then
                      R0now = BONDVO(index)
                  endif
                  goto 45
              endif
   40         CONTINUE
          ENDIF
   45     IF (char2(:i2) .EQ. char5(:i2)) THEN 
              Do 50, index = 1, 109
                  char3 = BONDC(index)
C				print *, char3(:i2),'-', char2(:i2)
                  if (char1(:i1) .EQ. char3(:i1)) then
c					print *, 'R0 equals', BONDVF(index)
                      R0now = BONDVF(index)
                      goto 55
                  endif
   50         CONTINUE
          ENDIF
   55     IF (char2(:i2) .EQ. char6(:i2)) THEN 
              Do 60, index = 1, 109
                  char3 = BONDC(index)
C				print *, char3(:i2),'-', char2(:i2)
                  if (char1(:i1) .EQ. char3(:i1))then
c					print *, 'R0 equals', BONDVCL(index)
                      R0now = BONDVCL(index) 
                      goto 65
                  endif
   60         CONTINUE
          ENDIF
   65 ENDIF
      RETURN  
      END                          