c
c**********************************************************************************
c
c     This file contains routines to calculate:
c     1) Absorption correction
c     2) Preferred Orientation
c     3) Extinction         
c     4) Sample Displacement
c
c
C     FUNCTION TO CALCULATE THE COS(ANGLE)^2 BETWEEN HKL AND A VECTOR
      REAL FUNCTION ANGLE(IPH,HKL,VEC)                                        !note: returns COS^2 not the actual angle
      INCLUDE 'param.inc'
      REAL HKL(3),VEC(3),PAK
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      REAL AL(3,3),SS,TT
	INTEGER IPH
C     
      DO 1000 I=1,3
 1000    AL(I,I)=PAR(IPH,I+5)                                             !a,b,c,alpha...
      AL(1,2)=PAR(IPH,11)                                                 !AL = (a    gam  bet)
      AL(1,3)=PAR(IPH,10)                                                 !     (0    b    alp)
      AL(2,1)=0.0                                                         !     (0    0    c  )
      AL(2,3)=PAR(IPH,9)                                                  
      AL(3,1)=0.0
      AL(3,2)=0.0
C
      SS=0.0
      DO 10 I=1,3
      DO 10 J=I,3
   10   SS=AL(I,J)*HKL(I)*HKL(J)+SS                                       !SS= a*H^2 ..+ c*L^2 + 
C
      TT=0.
      DO 20 I=1,3
      DO 20 J=I,3
   20     TT=TT+AL(I,J)*VEC(I)*VEC(J)
      PAK=0.
      DO 30 I=1,3
      DO 30 J=I,3
   30     PAK=AL(I,J)*(VEC(I)*HKL(J)+VEC(J)*HKL(I))/2.+PAK
      
      IF((TT.NE.0).AND.(SS.NE.0)) THEN
          ANGLE=PAK*PAK/(TT*SS)
      ELSE
          ANGLE = 0.0
      ENDIF
      RETURN
      END                                             
c
c**********************************************************************************
c
c
c         Absorption Correction
c
C
C                 THE FOLLOWING SECTION IS THE NEW T.M. Sabine/WRS ABSORPTION CORRECTION
C         FRED      
      SUBROUTINE FRED(Z,F1,D1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      PARAMETER (MAXK = 40)                                               !LESS ITERACTIONS ARE NEEDED FOR SMALLER MU*R
      INTEGER K                                                           !BUT 40 DOES THE LOT (SAME WITH THE 20 IN THE
      F1 = 0.0                                                            !OTHER FUNCTIONS
      D1 = 0.0
      DO 10 K = 0,MAXK
   10     F1 = F1 + DEXP(2.0*K*DLOG(Z*0.5)-2.0*GAMMLN(DBLE(K+1.)))
      DO 20 K = 1,MAXK
   20     D1 = D1 + DEXP(DLOG(DBLE(2*K))+(2.0*K-1)*DLOG(Z*0.5)- 
     &                2.0*GAMMLN(DBLE(K+1.)))
      D1 = D1*0.5
      RETURN   
      END
C          ULLA
      SUBROUTINE ULLA(Z,U1,D1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      PARAMETER (MAXK = 40)
      INTEGER K                  
      U1 = 0.0        
      D1 = 0.0
      DO 10 K = 0,MAXK
          U1 = U1 + DEXP(2.0*K*DLOG(Z*0.5) - 2.0*GAMMLN(DBLE(K+1.5)))
   10     D1 = D1 + DEXP(DLOG(DBLE(2*K+1)) + 2.0*K*DLOG(Z*0.5) - 
     &                   2.0*GAMMLN(DBLE(K+1.5)))
      D1 = D1*0.5
      U1 = U1*Z*0.5
      RETURN   
      END
      
C         FRED1      
      SUBROUTINE FRED1(Z,F1,D1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      PARAMETER (MAXK = 40)
      INTEGER K                 
      F1 = 0.0                     
      D1 = 0.0
      DO 10 K = 0,MAXK
          F1 = F1 + DEXP(2*K*DLOG(Z*0.5) - GAMMLN(DBLE(K+1.)) 
     &                                  - GAMMLN(DBLE(K+2.)))
   10     D1 = D1 + DEXP(DLOG(DBLE(2*K+1)) + 2.0*K*DLOG(Z*0.5) - 
     &            GAMMLN(DBLE(K+1)) - GAMMLN(DBLE(K+2)))
      D1 = D1*0.5
      F1 = F1*Z*0.5
      RETURN   
      END
C          ULLA1
      SUBROUTINE ULLA1(Z,U1,D1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      PARAMETER (MAXK = 40)
      INTEGER K                  
      U1 = 0.0                
      D1 = 0.0
      DO 10 K = 0,MAXK
   10     U1 = U1 + DEXP( 2*K*DLOG(Z*0.5) - GAMMLN(DBLE(K+1.5)) 
     &                                  - GAMMLN(DBLE(K+2.5)))
      DO 20 K = 0,MAXK
   20     D1 = D1 + DEXP( DLOG(DBLE(2*K+2)) + (2.0*K+1)*DLOG(Z*0.5) - 
     &                GAMMLN(DBLE(K+1.5)) - GAMMLN(DBLE(K+2.5)))
      D1 = D1*0.5 
      U1 = U1*(Z*0.5)**2
      RETURN   
      END
C      
                             
      SUBROUTINE DIFF0(Z, F1, D1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      PARAMETER (MAXM = 20)
      RF(M)=(-1)**(M)*DEXP(GAMMLN(DBLE(M+0.5)))**2/3.141592654
      D1 = 0.0
      F1 = 0.0
                                      
      DO 10 I=0,MAXM
          T1 = (-1)**(I+1)*RF(I)/(0.5*Z)**(2*I+1)
          F1 = F1 + T1
   10     D1 = D1 + T1*(-2*I-1)/(0.5*Z)
      F1 = F1/3.141592654
      D1 = D1/3.141592654
      RETURN
      END
C

      SUBROUTINE DIFF1(Z, F1, D1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      PARAMETER (MAXM = 20)
      RF(M)=(-1)**(M)*DEXP(GAMMLN(DBLE(M+0.5)))**2/3.141592654D0
      RG(M) = RF(M)/(0.5-M)
      F1 = 0.0         
      D1 = 0.0
      DO 10 I=0,MAXM                                   
          T1 = (-1)**(I+1)*RG(I)/(0.5*Z)**(2*I)
          F1 = F1 + T1
   10     D1 = D1 + T1*2*I/(0.5*Z)
      F1 = F1/3.141592654         
      D1 = D1/3.141592654
      RETURN
      END
C      
      SUBROUTINE ALM(Z, ZV1, ZD1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      REAL Z, ZV1, ZD1      
      Z1 = DBLE(Z)
      CALL DIFF0(Z1,F1,D1)
      CALL DIFF1(Z1,F11,D11)
      ZV1 = SNGL(2.0*(-F1 + F11/Z1))
      ZD1 = SNGL(2.0*(-D1 - F11/(Z1*Z1) + D11/Z1))
      RETURN
      END     
C
      SUBROUTINE ABM(Z, ZV1, ZD1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      REAL Z, ZV1, ZD1
      Z1 = DBLE(Z)
      CALL DIFF1(2.0*Z1,F11,D11)
      ZV1 = SNGL(-F11/Z1)
      ZD1 = SNGL(F11/(Z1*Z1) - 2.0*D11/Z1)
      RETURN
      END     
C     
      SUBROUTINE ALK(Z,ZV1,ZD1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      REAL Z,ZV1,ZD1
      Z1 = DBLE(Z)
      CALL FRED(Z1,F1,FD1)
      CALL ULLA(Z1,U1,UD1)
      CALL FRED1(Z1,F11,FD11)
      CALL ULLA1(Z1,U11,UD11)
      ZV1 = SNGL(2.0*(F1 - U1 - (F11 - U11)/Z1))
      ZD1 = SNGL(2.0*(FD1 - UD1 - (FD11 - UD11)/Z1 + (F11-U11)/(Z1*Z1)))
      RETURN
      END     
C
      SUBROUTINE ABK(Z,ZV1,ZD1)
      IMPLICIT DOUBLE PRECISION (A-Z)
      REAL Z,ZV1,ZD1
      Z1 = DBLE(Z)
      CALL FRED1(2.0*Z1,F11,FD11)
      CALL ULLA1(2.0*Z1,U11,UD11)
      ZV1 = SNGL((F11 - U11)/Z1)
      ZD1 = SNGL(-(F11 - U11)/(Z1*Z1) + 2.0*(FD11 - UD11)/Z1)
      RETURN
      END     
C            Courtesy of Numerical Recipes
      REAL*8 FUNCTION GAMMLN(XX)      
      IMPLICIT DOUBLE PRECISION (A-Z)
      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER,XX
      INTEGER J
      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*DLOG(TMP)-TMP
      SER=ONE
      DO 11 J=1,6
        X=X+ONE
        SER=SER+COF(J)/X
11    CONTINUE
      GAMMLN=TMP+DLOG(STP*SER)
      RETURN
      END
C                                        
      SUBROUTINE ALSCAT(Z, V, VD)
      REAL Z,V,VD
      IF (Z.GT.24) THEN
          CALL ALM(Z, V, VD)
      ELSE                          
          CALL ALK(Z, V, VD)
      ENDIF
      RETURN
      END
C
      SUBROUTINE ABSCAT(Z, V, VD)
      REAL Z,V,VD
      IF (Z.GT.16) THEN
          CALL ABM(Z,V,VD)
      ELSE
          CALL ABK(Z,V,VD)
      ENDIF
      RETURN
      END                  
c
c**********************************************************************************
c
C             CALC PEAK SHIFT DUE TO ABSORPTION
      REAL FUNCTION PEAKSHFT(RVAL,MU,THETA)
      REAL RVAL,THETA,MU,CVAL
      CVAL = 1.0
      PEAKSHFT = PSHIFT(THETA,MU*RVAL)*RVAL*CVAL
      RETURN
      END 
c      
      REAL FUNCTION PSHIFT(THETA,MUR)
      REAL AV,BV,CV,MUR,THETA
      AV = 0.000033*MUR
      BV = 1.168 - 0.22*MUR + 0.0168*MUR*MUR
      CV = 1.155 + 0.2054*MUR -0.0224*MUR*MUR
      PSHIFT = AV*(THETA**BV)*(90.0-THETA)**CV      
      RETURN
      END                                 
c
c**********************************************************************************
c
C
C         Flat Plate Absorption Correction
C                                         
      FUNCTION FPLATE(A1,A2,A3,ANGLE)                                            !angle = 2theta
      REAL TORSIN,A1,A2,A3,ANGLE
      TORSIN = A3/SIN(ANGLE*0.5)            
      FPLATE = A1 + A2*TORSIN*(1-TORSIN)
      IF (FPLATE.EQ.0) FPLATE = 1.0
      RETURN
      END
C
C     TOF Absorption
C                   
      FUNCTION TOFABS(ABSVAL,D)
      REAL ABSVAL,D
      TOFABS = EXP(-ABSVAL*D)
      RETURN
      END
c
c**********************************************************************************
c
C
C     Functions/Procedures associated with Preferred Orientation
c
c
C
c         Generates a table of equivalent HKL values using SMTRY2
c
      SUBROUTINE GETEQUIV(IPH,HNN,HALL,NEQUIV)
      INCLUDE 'param.inc'
      INTEGER IPH,ILAST,ILAST2,ILAST3,KTEMP(3,48)
      INTEGER HNN(3),HALL(3,48),NEQUIV
      LOGICAL FOUND
      COMMON/SPGKEEP/NSPACE(NUPH),NC1(NUPH),NCNT(10,7,NUPH),N11(NUPH),
     *IC1(NUPH)
      COMMON /HKLCTL/K(3,24),A(24),NCONT(10,7),IC,N1,IER
     1 ,HM
      COMMON /SPG/NSP(12),NC,FILL(2)
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
C         REINSTALL VALUES
      NSP(1) = NSPACE(IPH)
      NC = NC1(IPH)
      DO 110 II=1,10
      DO 110 JJ=1,7
  110     NCONT(II,JJ) = NCNT(II,JJ,IPH)
      N1 = N11(IPH)
      IC = IC1(IPH)
C
      K(1,1) = HNN(1)
      K(2,1) = HNN(2)
      K(3,1) = HNN(3)
      DO 120 II=2,23
          K(1,II) = 0
          K(2,II) = 0
  120     K(3,II) = 0
      NEQUIV = 0
C
      CALL SMTRY2
      ILAST = 0
      DO 10 II=1,24
      IF(K(1,II).EQ.0.AND.K(2,II).EQ.0.AND.K(3,II).EQ.0.AND.ILAST.EQ.0)
     *     ILAST = II-1
   10 CONTINUE
      IF (ILAST.EQ.0) ILAST=24
      ILAST2=1
      DO 11 II =1,3
   11     KTEMP(II,1) = K(II,1)
      IF (ILAST.GT.1) THEN
          DO 20 II=1,ILAST
              FOUND = .FALSE.
              DO 30 JJ=1,ILAST2
   30         IF ((KTEMP(1,JJ).EQ.K(1,II)).AND.(KTEMP(2,JJ).EQ.K(2,II)).
     *            AND.(KTEMP(3,JJ).EQ.K(3,II))) FOUND = .TRUE.
              IF (.NOT.FOUND) THEN
                  ILAST2 = ILAST2 + 1
                  KTEMP(1,ILAST2) = K(1,II)
                  KTEMP(2,ILAST2) = K(2,II)
                  KTEMP(3,ILAST2) = K(3,II)
              ENDIF                  
   20     CONTINUE
      ENDIF
      ILAST3 = ILAST2     
      IF (ICET(IPH).NE.1) THEN
          DO 40 II=1,ILAST2
             FOUND = .FALSE.
             DO 50 KK=1,ILAST3
   50         IF ((-KTEMP(1,II).EQ.KTEMP(1,KK)).AND.
     *            (-KTEMP(2,II).EQ.KTEMP(2,KK)).AND.
     *            (-KTEMP(3,II).EQ.KTEMP(3,KK))) FOUND = .TRUE.
             IF (.NOT.FOUND) THEN
                  ILAST3 = ILAST3 + 1
                  KTEMP(1,ILAST3) = -K(1,II)
                  KTEMP(2,ILAST3) = -K(2,II)
                  KTEMP(3,ILAST3) = -K(3,II)
             ENDIF
   40     CONTINUE
      ENDIF
      NEQUIV = ILAST3
      DO 100 I=1,ILAST3
      DO 100 J=1,3    
  100     HALL(J,I) = KTEMP(J,I)
      RETURN
      END
c
c**********************************************************************************
c
C
C         THIS SUBROUTINE NOW CALCULATES EVERYTHING TO DO WITH PREFERRED ORIENTATION
C
C         IPREF = TYPE OF P.ORIENTATION FUNCTION, IPH = PHASE NUMBER, PV = PREF.ORIENTATION VALUE ARRAY
C         HKL = HKL OF REFLECTION, VEC = P.ORIENTATION DIRECTION,
C         POR = RETURNED PREF. ORIENTATION VALUE, DPOR = DERIVATIVE
      SUBROUTINE PREFOR(IPREF,IPH,PV,HKL,VEC,POR,DPOR)
      INTEGER IPREF,I,K,IPH, HALL(3,48),NITER,HNN(3)
      REAL POR,DPOR,HKL(3),VEC(3),PV
      REAL PTEMP,DPTEMP,CANGLE
      LOGICAL SUMEQUIVS
C
      HNN(1) = INT(HKL(1))
      HNN(2) = INT(HKL(2))
      HNN(3) = INT(HKL(3))
      POR = 0.0
      DPOR = 0.0
      SUMEQUIVS = MOD(IPREF,2).EQ.1                                           !ONLY SUM EQUIVELANTS IF
      IF (SUMEQUIVS) THEN
          CALL GETEQUIV(IPH,HNN,HALL,NITER)
      ELSE
          NITER = 1
      ENDIF                                      
      DO 10 K = 1,NITER
          IF (K.NE.1) THEN
              DO 20 I=1,3
   20             HKL(I) = HALL(I,K)
          ENDIF    
          CANGLE = ANGLE(IPH,HKL,VEC)
          CALL MARCHDIST(CANGLE,PV,PTEMP,DPTEMP)
          POR = POR + PTEMP
          DPOR = DPOR + DPTEMP
   10 CONTINUE
      POR = POR/NITER
      DPOR = DPOR/NITER
      RETURN
      END      
c
c         March Model
c
C         RETURNS THE MARCH POLE DISTRIBUTION FUNCTION VALUE AND ITS
C         DERIVATIVE:    NOTE:  CANGLE IS COSINE(ANGLE)^2
      SUBROUTINE MARCHDIST(CANGLE,P1,PVAL,DPVAL)
      REAL CANGLE,P1,PVAL,DPVAL,SANGLE,PTEMP
      SANGLE = 1-CANGLE
      PTEMP = P1*P1*CANGLE + SANGLE/P1 
      PVAL=PTEMP**(-1.5)
      DPVAL = -1.5*PTEMP**(-2.5) * (2*P1*CANGLE - SANGLE/P1**2)
      RETURN
      END                     
c
c**********************************************************************************
c
c
C         Extinction Correction for constant wavelength
C
      FUNCTION EXTCW(EXTPAR,LAMDA,FSQ,SINTH)
      REAL EXTPAR,LAMDA,FSQ,SINTH,EXT
      REAL X,EL,EB
      EXT = 1.0                                                        
      IF (EXTPAR.NE.0) THEN                                               
          X=EXTPAR*LAMDA*LAMDA*FSQ
          IF(X.LE.-1.0) X=-0.9
          IF(X.LE.1.0) THEN
              EL=1.0-0.5*X+0.25*X*X-0.104167*X*X*X+0.036458*X*X*X*X
          ELSE
              EL=0.797885*(1.0-0.125/X-0.023438/(X*X)-0.014648/(X*X*X))
     *           /SQRT(X)
          ENDIF
          EB=1.0/SQRT(1.0+X)
          EXT= EL*(1-SINTH) + EB*SINTH
      ENDIF                       
      EXTCW = EXT
      RETURN
      END
c
c**********************************************************************************
c
C         Derivative of constant wavelength absorption
C
      FUNCTION DEXTCW(EXTPAR,LAMDA,FSQ,SINTH)
      REAL EXTPAR,LAMDA,FSQ,SINTH
      REAL X,DELDX,DEBDX
      X=EXTPAR*LAMDA*LAMDA*FSQ
      IF(X.LE.-1.0) X=-0.9
      IF(X.LE.1) THEN
          DELDX=-0.5+0.5*X-0.3125*X*X+0.145833*X*X*X
      ELSE
          DELDX=-0.398942*(1.0-0.375/X-0.117188/(X*X)-0.102539/
     &            (X*X*X))/X**1.5
      ENDIF
      DEBDX=-0.5/(1.0+X)**1.5
      DEXTCW = LAMDA*LAMDA*FSQ*(DELDX*(1-SINTH)+DEBDX*SINTH)
      RETURN
      END
c
c**********************************************************************************
c
c
C         Extinction Correction TOF (not implemented)
C
      FUNCTION EXTTOF(EXTPAR,D,FSQ)
      REAL EXTPAR,D,FSQ,EXT
      EXT = 1.0                                                        
      EXTTOF = (1.0 - EXTPAR*FSQ*(D**4))
      RETURN
      END
C
C         Derivative of TOF extiniction (not implemented)
C
      FUNCTION DEXTTOF(EXTPAR,D,FSQ)
      REAL EXTPAR,D,FSQ
      DEXTTOF = -FSQ*(D**4)
	EXTPAR = EXTPAR
      RETURN
      END
c
c***********************************************************************************
c
C		Sample Displacement        
      FUNCTION SDISP(THETA2,SD)
	REAL THETA2,SD
	SDISP = -0.5*SD*COS(THETA2*0.5)
	RETURN
	END
C
C
      FUNCTION DERSDISP(THETA2)
	REAL THETA2
	DERSDISP = -0.5*COS(THETA2*0.5)
	RETURN
	END
c

