c       common parameter file
      PARAMETER (IIDSZ=8000,IIRS=2000)
      PARAMETER (NATS=500,NIPOI=1500,NUPH=8)
      PARAMETER (MAXIPAR = 26, MAXIGL = 17, MAXEXCL = 30, MAXBK = 50)
      PARAMETER (MAXDS=100, MAXGP = MAXIGL*MAXDS, MAXAP = MAXIPAR*MAXDS)
      PARAMETER (MSZ=200,MSZ2 = ((MSZ+1)*MSZ)/2,MSZM = MAXAP)
      PARAMETER (MAXFF = 16, MFCO = 50)
      PARAMETER (MAXBONDS = 1000, MAXBAT = 1000)
      PARAMETER (MAXMOLE = 1,MAXAM = 10,MAXRES=100)
      PARAMETER (VERSION = 6.63)
      PARAMETER (GMIN = 0.0001,FFMIN=0.00001,ABSMIN = 0.00001)
	  PARAMETER (ASMALLNO = 0.0001)                                      
C
C     IDSZ = DEFAULT NUMBER OF DATA POINTS PER HISTOGRAM (can be changed using environment variable)
C     IRS  = DEFUALT NUMBER OF REFLECTIONS PER PHASE (can be changed using environment variable)
C     NATS = NUMBER OF ATOMS PER PHASE
C     MSZ  = NUMBER OF VARYING PARAMETERS (ATOMS + SCALE + UVW + ....)
C     MSZM = MAXIMUM ARRAY SIZE FOR PARAMETER OUTPUT (COULD BE HARDWIRED IN SUB. OUTPTR )   [AUTOMATICALLY CALCULATED]
C     MSZ2 = CONDENSED ARRAY SIZE (UPPER TRIANGULAR) [AUTOMATICALLY UPDATED]
C     NIPOI= NUMBER OF REFLECTIONS PER DATA POINT BEFORE IT ABORTS (EXCESSIVE PEAK OVERLAP)
C     NUPH = NUMBER OF PHASES
C     MAXIPAR = NUMBER OF HISTOGRAM PARAMETERS PER HISTOGRAM (PHASE.SCALE + UVW + PREF + .., see table below)
C     MAXIGL  = NUMBER OF GLOBAL PARAMETERS PER HISTOGRAM (HIST.SCALE + BACKGROUND + ZERO + WAVELENGTH, see below)
C     MAXDS= TOTAL NUMBER OF HISTOGRAMS
C     MAXGP= TOTAL NUMBER OF GLOBAL PARAMETERS [AUTOMATICALLY CALCULATED]
C     MAXAP= TOTAL NUMBER OF PHASE/HISTOGRAM PARAMETERS [AUTOMATICALLY CALCULATED] 
C     MAXEXCL = MAXIMUM NUMBER OF EXCLUDED REGIONS PER HISTOGRAM
C     MAXBK = MAXIMUM NUMBER OF BACKGROUND INTERPOLATING POINTS PER HISTOGRAM
C     MAXFF = MAXIMUM NUMBER OF USER FORM FACTORS (there can up up to MAXFF for each histogram if
c                 the AC coefficients are given explicitly, but if given in sin(theta)/lamda
c                 form there can only be a total of MAXFF sets for all histograms combined)
c     MFCO = MAXIMUM NUMBER OF FORM FACTOR VALUES IN SIN(THETA)/LAMDA FORMAT PER FORM FACTOR  
C     MAXBONDS = MAXIMUM NUMBER OF BONDS
C     MAXBAT = MAXIMUM NUMBER OF ATOMS IN BOND CALCULATIONS
C     MAXMOLE = MAXIMUM NUMBER OF MOLECULES     (NOT USED YET)
C     MAXAM = MAXIMUM NUMBER OF ATOMS FOR MOLECULES   (NOT USED YET)
C     MAXAM = MAXIMUM NUMBER OF BOND RESTRAINTS
C     VERSION = CURRENT VERSION NUMBER
C     GMIN = MINIMIUM GAUSSIAN WIDTH VALUE (IF GMIN <=0.0 THE PROGRAM ONLY WARNS OF -VE VALUES, IF GMIN > 0 THEN
C                     THE PROGRAM WILL FORCE A +VE VALUE TO BE EQUAL TO GMIN)
C            Note: having a too small value here will cause RJAC*RJAC values to be 0.0 and hence cause 1/0.0 errors
c                  in EXPUT subroutine.
C     FFMIN = MINIMUM STRUCTURE FACTOR^2 (PLUS *PREFFERED*EXTINCTION) ALLOWED (USED WHEN THE CALCULATED FF = 0 AND
C                     YOU STILL WANT THE OBSERVED FF PRINTED OUT - NEEDED BECAUSE THE PROGRAM DOES NOT GIVE THE
C                     FF(OBS) WHEN FF(CALC) = 0.  THIS IS USEFUL WHEN YOU ARE PLAYING WITH NEW STRUCTURES) THE
C                     VALUE OF 0.00001 IS GOOD AND PROBABLY SHOULD NEVER BE CHANGED)
C                     This value was 0.01, but when LeBailing on x-rays this was causing problems.
C     ABSMIN = MINUMUM VALUE OF THE ABSORPTION.  IF CALCULATION GOES -VE THEN THIS VALUE IS RETURNED.  IF
C              ABSMIN IS NEGATIVE A WARNING IS PRINTED BUT NO ACTION TAKEN.
C     ASMALLNO = A SMALL NUMBER FOR DERIVATIVE PURPOSES
C
c     Notes:
c         1) IRS*NIPOI must be less than the default maximum value of INTEGER, i.e. fortran77 this is 2147483647
c                      but in old compilers and non-standard this may default to INTEGER*2 and hence equal 32767.
c
C         This is repeated for every histogram
C  GLB #              PURPOSE               
C-------------------------------------------
C      1              ZERO

C      2              BACKGROUND 0
C      3              BACKGROUND 1
C      4              BACKGROUND 2

C      5              BACKGROUND 3
C      6              BACKGROUND 4
C      7              BACKGROUND 5

C      8              BACKRGOUND 6      ] 
C      9              BACKRGOUND 7      ]
C     10              BACKRGOUND 8      ] not used if BFLAG = 0

C     11              BACKRGOUND 9      ]
C     12              BACKRGOUND 10     ]
C     13              BACKRGOUND 11     ]

C     14              HISTOGRAM SCALE
C     15              WAVELENGTH 1 OR DIFC
c     16              DIFA (CURRENTLY NOT WAVELENGTH 2)
c     17              SAMPLE DISPLACEMENT
C     MAXGP = 17
C
C      
C             This is repeated for every histogram
C     Note: The Phase Scale, Iso Thermal, a,b,c,al,be,gam are applicable only for the first histogram
C  PAR #              PURPOSE
C  -----------------------------------------
C      1              PHASE SCALE
C      2              ISOTROPIC THERMAL
C      3              U
C      4              V
C      5              W
C      6              a
C      7              b
C      8              c
C      9              alpha
C     10              beta
C     11              gamma
C     12              PREFFERRED ORIETNATION
C     13              R ABSORPTION VALUE OR FLAT PLATE P0
C     14              ASYMMETRY
C     15              GAM-0/Lor particle size
C     16              GAM-1/Lor strain
C     17              GAM-2
C     18              EXTINCTION
C     19              Uaniso    
C     20              ASYMMETRY 2
C     21              TOF ALPHA-1
C     22              TOF ALPHA-2
C     23              TOF BETA-1
C     24              TOF BETA-2
C     25              FLAT PLATE ABSORPTION C1
C     26              FLAT PLATE ABSORPTION C2   
c
C     28              aR  - R
C     29              bR  - R
C     30              cR  - R
C     31              cS  - tau_s
C     32              dS  - tau_s
C     33              cF  - tau_f
C     34

C     MAXIPAR = 26
