C   (C) COPYRIGHT 1994-1996 
C   PROGRAM FOR RIETVELD ANALYSIS OF NEUTRON & X-RAY POWDER DIFFRACTION PATTERNS
C                           VERSION LH 4
C                                                       
C   BASED ON A PROGRAM WRIITEN BY D.B.WILES,
C                      APPLIED PHYSICS BRANCH,
C                      GEORGIA INSTITUTE OF TECHNOLOGY,
C                      ATLANTA,GA. 30332.
C
C   EXTENSIVELY MODIFIED BY C.J. HOWARD AND R.J. HILL
C                      C/O AAEC, LUCAS HEIGHTS RESEARCH LABORATORIES,
C                      NEW SOUTH WALES, AUSTRALIA
C
C   MODIFIED FOR MULTI-HISTOGRAMS AND TOF BY B.A. HUNTER
C                OTHER FEATURES ALSO ADDED
C                      ANSTO, NEUTRON SCATTERING GROUP,
C                      NEW SOUTH WALES, AUSTRALIA
C
c   The Chorus:
c     CJH = C. J. Howard
c     MME = M. M. Elcombe
c     BAH = B. A. Hunter
c     SJK = S. J. Kennedy
c     MF  = M. Field
c     JH  = J. Hester
c
c
C
C   THIS PROGRAM IS COPYRIGHTED (1991) AND ITS CODE CANNOT BE USED IN ANY OTHER APPLICATION
C   LAST UPDATE JULY 1ST, 1996
C
C         THE PROGRAM IS STILL WRITTEN USING MOSTLY FORTRAN 66 CONVENTIONS, ALTHOUGH F77 COMPILATION RECOMMENDED
C         TO DATE IT CAN BE COMPILED WITHOUT EDITING ON ALL COMPUTERS WITH THE EXCEPTION OF THE INITIAL ROUTINE
C         WHERE THE COMMAND LINE ARGUMENTS ARE READ.  NEW MEMORY FEATURES NEED FORTRAN 90 EXTENSIONS.
C         
C
C                          
CCJH      1)PROVISION FOR MULTI-PHASES
CCJH      2)    "      "  WRITING THE PLOT INFORMATION TO A FILE FOR SPECIAL PLOTS
CCJH      3)USES MARCH MODEL FOR PREFERRED ORIENTATION
CCJH      4)SABINE'S EXTINCTION CORRECTION
CCJH      5)MOD TO EXCLUDE 'BAD POINTS'
CBAH      6)READS GENERIC DATA IN FORM (2THETA, YOBS, WT) 
CBAH      7)ADDED NEW FLAG FOR SYNCROTRON (OR OTHER) DATA WITH 
CBAH          HIGHER ANGULAR PRECISION (DATA THETAS ARE FREE FORMATTED, INPUT FILE IS 3F12)
CBAH/SJK  8)ADDED DIFFERENT PLOT FILE OPTIONS
CBAH      9)ADDED MULTI-HISTOGRAMS (SIMULTANEOUS X-RAY/NEUTRON REFINEMENT) 
CBAH/SJK 10)ADDED ANISOTROPIC GAUSSIAN PEAK BROADENING COS^4 FOR ALL CW PROFILE FUNCTIONS AND COS^2 FOR TOF               
CBAH     11)SEVERAL OTHER MODIFICATIONS DUE TO POOR CODE LOGIC INCLUDING
CBAH          U,V,W STABILITY (MOST GAUSSIAN CODE NOW IN PROFILE.FOR), REFGEN CODE,....
CBAH          GOT RID OF FORM FACTOR REFINE AND PUT IN INTERPOLATED FORM FACTORS
CBAH     12)ADDED REFINABLE WAVELENGTH
CBAH     13)REPLACED HEWATS APPROXIMATE ABSORPTION WITH SABINE/DWIGGINS ABSORPTION 
CBAH          CORRECTION (LARGE mUR), NOW REFINEABLE WITH MULTIPLE DATASETS
CBAH          ALSO PEAKSHIFT ADDED DUE TO LARGE MUR (ONLY APPLICABLE FOR MUR <~ 6.0)
CBAH/MME 14)FIXED PROBLEM WITH COBS = 0 WHEN YCALC = 0 EVEN WHEN THERE WAS OBSERVED INTENSITY
CBAH     15)ADDED RUDIMENTARY DISTANCE CALCULATOR WITH ERROR CALCULATION
CBAH     16)ADDED REFINABLE f',f'' FOR ANOMOLOUS/RESONANT SCATTERING.
CBAH     17)ADDED SOME COMMENTS IN THE CODE FOR EASY MODIFICATIONS
CBAH     18)ADDED TOF CODE/JORGENSEN PEAK SHAPE                                              
CSJK     19)CAN NOW REJECT PEAKS IF LOWER THAN SOME THRESHOLD
CBAH     20)ADDED SUMMATION OVER EQUIVALENT REFLECTIONS FOR PREFERRED ORIENTATION CORRECTIONS
CBAH     21)NOW OUTPUTS RELATIVE AND ABSOLUTE QUANTATIVE ANALYSIS (ADDED MOLECULAR WEIGHTS TO TABLES)
CBAH     22)CAN READ AND REFINE USING <U^2>'S INSTEAD OF B AND BETA'S
CBAH     23)IMPROVED SUMMAT FOR FASTER TURNAROUND WHEN REFINING LARGE NUMBERS OF PARAMETERS
CBAH     24)DYNAMIC ALLOCATION OF SOME LARGER ARRAYS (fortran 90 only)
CBAH     25)ADDED BETTER ERROR CHECKING
CMF/BAH  26)ADDED ANGLE CALCULATIONS (FULL CORRELATION TREATMENT)
CMF      27)ADDED BOND VALENCE CALCULATIONS
CMME     28)FIXED REFGEN TO HANDLE STRANGE MONOCLINIC SETTINGS (SOMETIMES MISSED SOME HKL'S)
CBAH     29)ADDED DYNAMIC DYNAMIC MEMORY ALLOCATION FOR IDSZ AND IRS AS WELL AS
C           GETTTING THE VALUES FROM THE ENVIRONMENT
CBAH     30)ADDED LEBAIL (number of atoms = 0)
CBAH     31)STARTED BOND DISTANCE CONSTRAINTS (NOT WORKING YET)
CBAH     32)FIXED MINOR BUGS WITH DATAREAD
CBAH     33)ADDED MARQUART MINIMIZATION
CBAH     34)TOF EXTINCTION
CBAH     35)SAMPLE DISPLACEMENT
C
c
c**********************************************************************************
c
C         MEMORY ALLOCATION/DEALLOCATION
      SUBROUTINE ALCMEMORY(JDS,IDSZ,IRS,MEMTYPE,ERROR)
      include 'param.inc'
      INTEGER JDS,ERROR
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      INTEGER, Pointer::  IREFS(:,:),ICX(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      REAL, POINTER:: COBS(:,:),SOMEGA(:,:),VAR(:,:)
      REAL,POINTER:: PHASE(:)
      COMMON/FOUR/PHASE
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      COMMON/REFLS/IREFS,REFS,FF,ICX
      COMMON/RBRAGG/COBS,SOMEGA,VAR

      IF (MEMTYPE.EQ.1) THEN 
          Allocate(Y(JDS,IDSZ),STAT=ERROR)
          Allocate(YC(JDS,IDSZ),STAT=ERROR)
          Allocate(KR(JDS,IDSZ),STAT=ERROR)
          Allocate(BK(JDS,IDSZ),STAT=ERROR)
          Allocate(WT(JDS,IDSZ),STAT=ERROR)
          Allocate(NPTS(JDS),STAT=ERROR)
C
          Allocate(IREFS(JDS,IRS),STAT=ERROR)
          Allocate(REFS(JDS,IRS,4),STAT=ERROR)
          Allocate(FF(JDS,IRS),STAT=ERROR)
          Allocate(ICX(JDS,NUPH),STAT=ERROR)
C
          Allocate(COBS(JDS,IRS),STAT=ERROR)
          Allocate(SOMEGA(JDS,IRS),STAT=ERROR)
          Allocate(VAR(JDS,IRS),STAT=ERROR)
C
          Allocate(PHASE(IRS),STAT=ERROR)
      ENDIF
C
      IF (ERROR.NE.0) ERROR = 100 
      RETURN
      END
c
c**********************************************************************************
c
      SUBROUTINE DALCMEMORY(ERROR)
      include 'param.inc'
      INTEGER ERROR
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      INTEGER, Pointer::  IREFS(:,:),ICX(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,ICX
      REAL, POINTER:: COBS(:,:),SOMEGA(:,:),VAR(:,:)
      COMMON/RBRAGG/COBS,SOMEGA,VAR
      REAL,POINTER:: PHASE(:)
      COMMON/FOUR/PHASE
      DeAllocate(Y,STAT=ERROR)
      DeAllocate(YC,STAT=ERROR)
      DeAllocate(KR,STAT=ERROR)
      DeAllocate(BK,STAT=ERROR)
      DeAllocate(WT,STAT=ERROR)
      DeAllocate(NPTS,STAT=ERROR)
      DeAllocate(IREFS,STAT=ERROR)
      DeAllocate(REFS,STAT=ERROR)
      DeAllocate(FF,STAT=ERROR)
      DeAllocate(ICX,STAT=ERROR)
      DeAllocate(COBS,STAT=ERROR)
      DeAllocate(SOMEGA,STAT=ERROR)
      DeAllocate(VAR,STAT=ERROR)
      DeAllocate(PHASE,STAT=ERROR)
      IF (ERROR.NE.0) ERROR = 101 
      RETURN
      END
c
c**********************************************************************************
c
c             THIS SUBROUTINE CHANGES THMIN/THMAX TO SMALLER/LARGER VALUES TO 
C             ACCOMMODATE PEAK CALCULATION BEYOND THE OBSERVED PATTERN
c
      SUBROUTINE GENLIM(NDS,TOF,IPHASE,ZERO,NPRO)
      INCLUDE 'param.inc'
      INTEGER NDS,IPHASE,NPRO,NEWEXC
      LOGICAL TOF
      REAL ZERO,THETAX,THETAN,HWMIN,HWMAX,TTMIN,TTMAX,RAD,LAMDA
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
C      
      RAD=3.14159265359/360.0
      IF(IPHASE.LE.1) THEN
          THETAX = THMAX(NDS)
          THETAN = THMIN(NDS)
      ELSE
          THETAX = ALOW(NDS,NEXCRG(NDS)-1)-STEP(NDS)                            !OLD THMAX
          THETAN = AHIGH(NDS,NEXCRG(NDS))+STEP(NDS)                             !OLD THMIN
      ENDIF
C                                           
      IF (.NOT.TOF) THEN                                                
          TTMAX=TAN((THETAX-ZERO)*RAD)
          TTMIN=TAN((THETAN-ZERO)*RAD)
          HWMAX=VHALF(IPHASE,TTMAX,0,0,0,NDS,NPRO)
          HWMIN = SQRT(ABS(W(NDS)))
          IF (TTMIN.GT.0) HWMIN=VHALF(IPHASE,TTMIN,0,0,0,NDS,NPRO)
          THETAX=THETAX+INT(HWMAX*WDT(NDS)/(2.0*STEP(NDS))+0.5)
     *                          *STEP(NDS)                                
          THETAN=THETAN-INT(HWMIN*WDT(NDS)/(2.0*STEP(NDS))+0.5)
     *                          *STEP(NDS)                           
      ELSE          
          TTMAX=DVAL(THETAX,LAMDA(NDS,1),LAMDA(NDS,2),ZERO)
          TTMIN=DVAL(THETAN,LAMDA(NDS,1),LAMDA(NDS,2),ZERO)
          HWMAX=VHALF(IPHASE,TTMAX,0,0,0,NDS,NPRO)
          HWMIN=VHALF(IPHASE,TTMIN,0,0,0,NDS,NPRO)
          THETAX=THETAX + WDT(NDS)*HWMAX                                                                         
          THETAN=THETAN - WDT(NDS)*HWMIN                                                               
          THETAX = INT(THETAX/STEP(NDS) + 0.5)*STEP(NDS)                    !GO TO NEAREST BIN VALUE
          THETAN = INT(THETAN/STEP(NDS) + 0.5)*STEP(NDS)
       ENDIF
C
      IF (IPHASE.LE.1) THEN
          NEWEXC = NEXCRG(NDS)+2                                           !GENERATE A NEW EXCLUDED FOR FIRST PHASE
          NEXCRG(NDS) = NEWEXC
          ALOW(NDS,NEWEXC-1)=THMAX(NDS) + STEP(NDS)                         
          AHIGH(NDS,NEWEXC-1)=THETAX
          THMAX(NDS) = THETAX
          AHIGH(NDS,NEWEXC)= THMIN(NDS) - STEP(NDS)
          ALOW(NDS,NEWEXC)= THETAN                                
          THMIN(NDS) = THETAN
      ELSE
          NEWEXC = NEXCRG(NDS)
          IF (THETAX.GT.THMAX(NDS)) THEN
              THMAX(NDS) = THETAX
              AHIGH(NDS,NEWEXC-1) = THMAX(NDS)                             !ADJUST CURRENT (FROM THE FIRST PHASE)
          ENDIF                                                            !FOR SECOND+ PHASES
          IF (THETAN.LT.THMIN(NDS)) THEN
              THMIN(NDS) = THETAN
              ALOW(NDS,NEWEXC) = THMIN(NDS)
          ENDIF
      ENDIF
C                
      RETURN
      END
c
c**********************************************************************************
c
      SUBROUTINE REFGEN(IPHASE,IRS,ZERO,RVAL,NDS,ERROR)
      include 'param.inc'
      REAL LAMDA,DMIN,DMAX,RVAL,PADJ
      INTEGER H1,H2,H3,NDS,ERROR
      LOGICAL TOF,ISTOF,ISXRAY
      COMMON/HKLCTL/KZ(3,24),AZ(24),NCN(10,7),ICQ,N1,IER,HN
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      INTEGER, Pointer::  IREFS(:,:),ICX(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,ICX
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/SPG/NSPGRP,K,M(10),FILL(3)
      COMMON/SPGKEEP/NSPACE(NUPH),NC(NUPH),NCONT(10,7,NUPH),N11(NUPH),
     *IC1(NUPH)
      COMMON/CELLX/A,B,C,ALPHA,BETA,GAMMA,AL(3,3)
csjk
      COMMON/FFREJECT/ REJECT,RFLAG,realj,realint
      EQUIVALENCE (AL(1,1),ASTAR),(AL(2,2),BSTAR),(AL(3,3),CSTAR),
     *(AL(1,2),BACOSC),(AL(1,3),CACOSB),(AL(2,3),BCCOSA)
   24 FORMAT (///,' *\ TOO MANY REFLECTIONS *')
   36 FORMAT(' LAUE SYMMETRY ',A8,' WILL BE USED TO GENERATE INDICES')
      CHARACTER*8 LAU(14)
      DATA LAU(1),LAU(2),LAU(3),LAU(4),LAU(5),LAU(6),LAU(7),LAU(8),
     *LAU(9),LAU(10),LAU(11),LAU(12),LAU(13),LAU(14)
     */'1BAR','2/M','MMM','4/M','4/MMM','3BAR   R','3BAR M R','3BAR',
     *'3BAR M 1','3BAR 1 M','6/M','6/MMM','M3','M3M'/
C
      SIN1(A)=SIN(A*6.28318531)                                           !sin1(a) = sin(2 Pi a)
      ERROR = 0
      RAD=3.14159265359/360.0
C
      TOF = ISTOF(JOBTYP(NDS))                                              
csjk     
      RFLAG=1   
      NREJ=0
      IF ( K.GT.3 ) THEN
         WRITE(7,*) 'REFGEN ERROR'
         ERROR = 51
         GOTO 998
      ENDIF
      KXIS=K
      K=1
 1002 N = 0
      J = 0
      I2D = 0
      I3D = 0
      I1D = 1
      I12D = 1
      I13D = 1
      I123D = 1                                                               
      I23D = 1
      I2DEL = 1
      I3DEL = 1
      DO 8000 I=1,8
          IF ( M(I).EQ.0 ) GO TO 9000
          IF ( M(I)-8192 ) 8002,8001,8000
 8001     I3DEL = 3
          I1D = 2
          I123D = 3
          GO TO 9000
 8002     IF ( M(I)-576 ) 8004,8003,8004
 8003     I3DEL = 2
          I23D = 2
          GO TO 8000
 8004     IF ( M(I)-516 ) 8008,8009,8008
 8009     I3DEL = 2
          I13D = 2
          GO TO 8000
 8008     IF ( M(I)-68 ) 8012,8013,8012
 8012     IF ( M(I)-580 ) 8015,8016,8015
 8013     I2DEL = 2
          I12D = 2
          GO TO 8000
 8016     I123D = 2
          I3DEL = 2
 8015     CONTINUE
 8000 CONTINUE
 9000 N=J-1
 97   CONTINUE
C
      CALL GENLIM(NDS,TOF,IPHASE,ZERO,NPROF(NDS))                                !CALL ROUTINE TO EXPAND LIMITS
C
      WRITE(7,201) NDS,THMIN(NDS),THMAX(NDS),IPHASE
  201 format(' Histogram ',i2,' is using angles ',f12.4,' to ',f12.4,
     &       ' for Phase ',i2)
C
      IF (TOF) THEN
          TMIN=1/(2*DVAL(THMAX(NDS),LAMDA(NDS,1),LAMDA(NDS,2),ZERO))**2
      ELSE
          TMIN = (SIN1((THMIN(NDS)-ZERO)/720.0)/LAMDA(NDS,1))**2
      ENDIF      
    2 CONTINUE
    
CY    END CODE
      IC = 0
      IF(IPHASE.GE.2) THEN
          DO 3 NP=1,IPHASE-1
    3     IC=IC+ICX(NDS,NP)
      ENDIF
      IF (TOF) THEN
          SMAX =1/(2*DVAL(THMIN(NDS),LAMDA(NDS,1),LAMDA(NDS,2),ZERO))**2
      ELSE
          SMAX = (SIN1((THMAX(NDS)-ZERO)/720.0)/LAMDA(NDS,1))**2                         
          IF(LAMDA(NDS,2).GT.LAMDA(NDS,1))TMIN=
     &                TMIN*(LAMDA(NDS,1)/LAMDA(NDS,2))**2
          IF(LAMDA(NDS,2).GT.0..AND.LAMDA(NDS,2).LT.LAMDA(NDS,1))SMAX=
     &                SMAX*(LAMDA(NDS,1)/LAMDA(NDS,2))**2
      ENDIF
      CALL OP1
c         save some values for Getequiv subroutine
      NSPACE(IPHASE) = NSPGRP
      NC(IPHASE) = FILL(1)         
      DO 5000 II=1,10
      DO 5000 JJ=1,7
 5000     NCONT(II,JJ,IPHASE) = NCN(II,JJ)
      N11(IPHASE) = N1
      IC1(IPHASE) = ICQ
C
      WRITE(6,36)LAU(NSPGRP)
      I1MAX=A*2.0*SQRT(SMAX)+20                                              !mmmm..what's this...
      I2MAX=B*2.0*SQRT(SMAX)+20                                              !NEEDED TO ADDED MORE FOR BIZARRE
      I3MAX=C*2.0*SQRT(SMAX)+20                                              !CASES SUCH AS WEIRD MONOCLINIC SETTINGS
      L1 = NSPGRP
      IF ( L1.GE.13.AND.M(1).EQ.580 ) L1=L1+2                             !if M3 OR M3M AND ???
      IF ( I12D+I13D+I23D.NE.5 ) GO TO 2131
      I12D = 2
      I13D = 1
      I23D = 2
      I2DEL = 2
      I3DEL = 2
 2131 IF ( L1.EQ.6 ) I2D=1                                                !3BAR  R
      IF ( L1.EQ.7 ) I2D=2                                                !3BAR  M  R
      I3D = I2D
      I1 = -1
 2200 I1 = 1+I1
      IF ( I1-I1MAX ) 2201,2201,2303
 2201 H1 = I1
      IF ( I2D.GT.0 ) I2MAX=I1
C
      GO TO (2203,2204,2204,2205,2206,2208,2209,2207,2204,2206,2204,
     1 2206,2206,2206,2206,2206),L1
 2203 I2= -MIN0(I2MAX,I1*I2MAX)                                           !1BAR
      GO TO 2210
 2204 I2 = 0                                                              !2/M, MMM, 3BAR M 1,6MMM 
      GO TO 2210
 2205 I2= MIN0(I1,1)                                                      !4/M
      GO TO 2210
 2206 I2 = I1                                                             !4/MMM,
      GO TO 2210
 2207 I2= MIN0(-I1+1,0)                                                   !3BAR
      GO TO 2210
 2208 I2 = -2*I1                                                          !3BAR R
      GO TO 2210
 2209 I2 = -I1/2                                                          !3BAR M R
 2210 I2= I2DEL*(I2/I2DEL)+MOD(I1,I12D)
      GO TO 2221
 2220 I2 = I2DEL+I2
 2221 H2 = I2
      IF ( I2-I2MAX ) 2222,2222,2200
C
 2222 GO TO (2223,2223,2224,2224,2224,2225,2225,2224,2224,2223,2224,
     1 2224,2226,2227,2236,2235),L1
 2223 I3= -MIN0(I3MAX,(I1+IABS(I2))*I3MAX)                                !1BAR
      GO TO 2228
 2224 I3 = 0                                                              !2/M
      GO TO 2228
 2225 I3 = -I1-I2                                                         !MMM
      GO TO 2228
 2226 I3= MIN0(I2,I1+I3DEL)
      GO TO 2228
 2227 I3 = I2
 2228 I3= I3DEL*(I3/I3DEL)+MOD(MOD(I1+I1D*I2,I123D)+I123D,I123D) +MOD(I1
     1,I13D)+MOD(I2,I23D)
      IF ( I3D-1 ) 2232,2229,2231
 2229 I3MAX = I1
      IF ( I2-I1 ) 2230,2232,2230
 2230 I3MAX = I3MAX-1
      GO TO 2232
 2231 I3MAX = I2
      GO TO 2232
 2235 I3= I2+MOD(I1,2)
      GO TO 2232
 2236 I3 = I1+2-MOD(I2,2)
      IF ( I1.EQ.I2.AND.MOD(I1,2).EQ.0 ) I3=I1
      GO TO 2232
 2233 I3 = I3DEL+I3
 2232 H3 = I3
      IF ( KXIS.NE.3 ) GO TO 2240
      H3 = I2
      H2 = I3
 2240 CONTINUE
C
      IF ( I3-I3MAX ) 113,113,2220
  113 SQ=FLOAT(H1*H1)*ASTAR+FLOAT(H2*H2)*BSTAR+FLOAT(H3*H3)*CSTAR
     & +FLOAT(H1*H2)*BACOSC+FLOAT(H1*H3)*CACOSB+FLOAT(H2*H3)*BCCOSA
      SQ=SQ/4.                                                            !SQ = h^2/(4a^2) + ...
 2234 IF ( SQ-SMAX ) 3000,3000,2233
 2303 ICX(NDS,IPHASE)=IC
CSJK 
      IF (FFLIM(NDS).NE.0) then
      write(7,*) NREJ,' Reflections rejected with Intensity<',FFLIM(NDS)
      endif
CSJK  
      IF(IPHASE.GE.2) THEN
          DO 4 NP=1,IPHASE-1
    4     ICX(NDS,IPHASE)=ICX(NDS,IPHASE)-ICX(NDS,NP) 
      ENDIF
      WRITE(7,5001)ICX(NDS,IPHASE),NDS,IPHASE  
 5001 FORMAT(' There are a total of ',I4,' reflections in Histogram ',
     &I2,', Phase  ',I2)
      CALL SORT(IPHASE,NDS,IRS)
CSJK
      RFLAG = 0
  998 RETURN
c         return
 3000 IF ( SQ - TMIN ) 2233,2233,3117                                     !CHANGED ZERO CASE TO NEG CASE -
 3117 IF ( IC.GT.IRS-2 ) GO TO 6001                                       !IT WAS SET TO THE POS CASE
      KZ(1,1)=H1                                                          !CAUSING ERRORS WHEN SQ = 0
      KZ(2,1)=H2                                                          !AND TMIN = 0
      KZ(3,1)=H3
      AZ(1)=0.0
      IER=0
      CALL SMTRY2
      IF(IER.NE.0)GOTO 2233    
C
      IF (TOF) THEN
          LX1 = 1
          PIT = SQRT(1/(4*SQ))                                            ! STORE TOF VALUES AS D VALUES
          DMIN = DVAL(THMIN(NDS),LAMDA(NDS,1),LAMDA(NDS,2),ZERO)
          DMAX = DVAL(THMAX(NDS),LAMDA(NDS,1),LAMDA(NDS,2),ZERO)
          IF ((PIT.LE.DMAX).AND.(PIT.GE.DMIN)) THEN 
           PLOR = FINSPEC(NDS,TVAL(PIT,LAMDA(NDS,1),LAMDA(NDS,2),ZERO))/
     *                                            (16*SQ*SQ)               !TOF LORENTZIAN CORECTION
           IC = IC + 1                                                     !AND INCIDENT SPEC CORR
           FF(NDS,IC)=MULT(H1,H2,H3)
           REFS(NDS,IC,1)=VHALF(IPHASE,PIT,H1,H2,H3,NDS,NPROF(NDS))
           REFS(NDS,IC,2)=PIT
           REFS(NDS,IC,3)=PLOR                                       
           IF(NPROF(NDS).NE.3.AND.NPROF(NDS).NE.5) REFS(NDS,IC,4)=
     &        (WW(NDS)*REFS(NDS,IC,2) +VV(NDS))*REFS(NDS,IC,2) + UU(NDS)
           IREFS(NDS,IC)=256*(256*(256*(4*IPHASE+LX1)+128+H1)+128+H2)+
     &                128+H3
          ENDIF
      ELSE
          LXN=2
          IF(LAMDA(NDS,2).EQ.0..OR.LAMDA(NDS,2).EQ.LAMDA(NDS,1)) LXN=1
          DO 3118 LX1=1,LXN                                                   !SIN(THETA) = SQRT(SQH) THEREFORE
          SQH=SQ*LAMDA(NDS,LX1)*LAMDA(NDS,LX1)                                !TAN(THETA) = SQRT(SQH/(1-SQH))
          TAN2=SQH/(1.-SQH)                                                     !NOTE: I BELIEVE EVERYTHING IS PUT IN TAN()
          IF(SQH.GE.1.)GOTO 3118                                                !AS OLDER COMPILERS MAY NOT HAVE HAD SIN OR COS?
          TANX=SQRT(TAN2)                                                     !TANX -> REAL 2THETA BASED ON CALC
          PIT=ATAN(TANX)/RAD+ZERO                                             !PIT  -> OBSERVED I.E. CALC + ZERO
          IF(PIT.GT.THMAX(NDS).OR.PIT.LT.THMIN(NDS)) GOTO 3118                !NOTE PIT = 2THETA AS RAD = PI/360 NOT PI/180
          IC=IC+1                                                    
          PLOR=1./(2.*SQH*SQRT(1.-SQH))
          IF (IFULLILL(NDS).EQ.1) PLOR = PLOR*SQRT(SQH)						!full illumination correction
c
          IF (ISXRAY(JOBTYP(NDS)))                                            !LORENTZ-POLARIZATION
     &        PLOR=PLOR*(1.+(1.-2.*SQH)*(1.-2.*SQH)*CTHM(NDS))                !PLOR = 1+COS^2(2THETA)
C                                                                         !      SIN(THETA)*SIN(2THETA)
C                                                                         !ACTUALLY 1 + COS^2(THETA)
C                                                                         !     2*SIN^2(THETA)*COS(THETA)
          PADJ = PEAKSHFT(RVAL,TMV(NDS),PIT*0.5)
          FF(NDS,IC)=MULT(H1,H2,H3)
          REFS(NDS,IC,1)=VHALF(IPHASE,TANX,H1,H2,H3,NDS,NPROF(NDS))
          REFS(NDS,IC,2)=PIT+PADJ                                             !absorption shift addition
          REFS(NDS,IC,3)=PLOR
          REFS(NDS,IC,4)=0.0
          IF(NPROF(NDS).NE.3.AND.NPROF(NDS).NE.5) REFS(NDS,IC,4)=
     &        (WW(NDS)*REFS(NDS,IC,2) +VV(NDS))*REFS(NDS,IC,2) + UU(NDS)

          IREFS(NDS,IC)=256*(256*(256*(4*IPHASE+LX1)+128+H1)+128+H2)+
     &                128+H3
 3118 CONTINUE        
      ENDIF
CSJK CALL TO CALCUL TO REJECT PEAKS WITH INTENSITY LESS THAN FFMIN
CSJK The call to calcul leads to a corruption of the MULT(i) array -by overwriting
CSJK in the FSQ calculation so I recalculate here. Also a call to MULT from CALCUL
CSJK returns incorrect values, so I have defined realj which is common to REFGEN and CALCUL
      IF (FFLIM(NDS).NE.0) THEN
          realj=MULT(H1,H2,H3)                                              ! pass 'j' to CALCUL
          CALL CALCUL(IC,NDS,ERROR) 
          IF (REJECT.EQ.1) THEN
              NREJ=NREJ+1
              IC =IC -1  
          ELSE
              REFS(NDS,IC,2)=PIT
              REFS(NDS,IC,3)=PLOR
          ENDIF      
          FF(NDS,IC)=MULT(H1,H2,H3) 
      ENDIF
      
      GOTO 2233
 6001 WRITE(6,24)
      GO TO 2303
      END
C         IREFS = PHASE NUMBER, H, K, L                                   
C         FF = MULTIPILICITY (FOR NOW)
C         REFS(1) = GAUSSIAN FWHM
C         REFS(2) = 2 THETA (ZERO INCLUDED)
C         REFS(3) = LORENTZ FACTOR
C         REFS(4) = SHAPE (LORENZTIAN PEAKSHAPE COMPONENT)
c**********************************************************************************
c
      SUBROUTINE REFREAD(IPHASE,IRS,ZERO,RVAL,NDS,ERROR)
      include 'param.inc'
      REAL LAMDA,DMIN,DMAX,RVAL,PADJ
      INTEGER H1,H2,H3,IRC,NDS,ERROR
      LOGICAL TOF,ISTOF,ISXRAY
      COMMON/HKLCTL/KZ(3,24),AZ(24),NCN(10,7),ICQ,N1,IER,HN
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      INTEGER, Pointer::  IREFS(:,:),ICX(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,ICX
      REAL, POINTER:: COBS(:,:),SOMEGA(:,:),VAR(:,:)
      COMMON/RBRAGG/COBS,SOMEGA,VAR
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/SPG/NSPGRP,K,M(10),FILL(3)
      COMMON/SPGKEEP/NSPACE(NUPH),NC(NUPH),NCONT(10,7,NUPH),N11(NUPH),
     *IC1(NUPH)
      COMMON/CELLX/A,B,C,ALPHA,BETA,GAMMA,AL(3,3)
      EQUIVALENCE (AL(1,1),ASTAR),(AL(2,2),BSTAR),(AL(3,3),CSTAR),
     *(AL(1,2),BACOSC),(AL(1,3),CACOSB),(AL(2,3),BCCOSA)
   24 FORMAT (///,' *\ TOO MANY REFLECTIONS *')
   36 FORMAT(' LAUE SYMMETRY ',A8,' WILL BE USED TO GENERATE INDICES')
      CHARACTER*8 LAU(14)
      DATA LAU(1),LAU(2),LAU(3),LAU(4),LAU(5),LAU(6),LAU(7),LAU(8),
     *LAU(9),LAU(10),LAU(11),LAU(12),LAU(13),LAU(14)
     */'1BAR','2/M','MMM','4/M','4/MMM','3BAR   R','3BAR M R','3BAR',
     *'3BAR M 1','3BAR 1 M','6/M','6/MMM','M3','M3M'/
C
      SIN1(A)=SIN(A*6.28318531)                                           !sin1(a) = sin(2 Pi a)
      ERROR = 0
      RAD=3.14159265359/360.0
C
      TOF = ISTOF(JOBTYP(NDS))                                              
      IF ( K.GT.3 ) THEN
         WRITE(7,*) 'REFREAD ERROR'
         ERROR = 51
         GOTO 998
      ENDIF
      KXIS=K
      K=1
 1002 N = 0
      J = 0
C
      CALL GENLIM(NDS,TOF,IPHASE,ZERO,NPROF(NDS))                                !CALL ROUTINE TO EXPAND LIMITS
C
      WRITE(7,201) NDS,THMIN(NDS),THMAX(NDS),IPHASE
  201 format(' Histogram ',i2,' is using angles ',f12.4,' to ',f12.4,
     &       ' for Phase ',i2)
C
      IF (TOF) THEN
          TMIN=1/(2*DVAL(THMAX(NDS),LAMDA(NDS,1),LAMDA(NDS,2),ZERO))**2
      ELSE
          TMIN = (SIN1((THMIN(NDS)-ZERO)/720.0)/LAMDA(NDS,1))**2
      ENDIF      
    2 CONTINUE
    
CY    END CODE
      IC = 0
      IF(IPHASE.GE.2) THEN
          DO 3 NP=1,IPHASE-1
    3     IC=IC+ICX(NDS,NP)
      ENDIF
      IF (TOF) THEN
          SMAX =1/(2*DVAL(THMIN(NDS),LAMDA(NDS,1),LAMDA(NDS,2),ZERO))**2
      ELSE
          SMAX = (SIN1((THMAX(NDS)-ZERO)/720.0)/LAMDA(NDS,1))**2                         
          IF(LAMDA(NDS,2).GT.LAMDA(NDS,1))TMIN=
     &                TMIN*(LAMDA(NDS,1)/LAMDA(NDS,2))**2
          IF(LAMDA(NDS,2).GT.0..AND.LAMDA(NDS,2).LT.LAMDA(NDS,1))SMAX=
     &                SMAX*(LAMDA(NDS,1)/LAMDA(NDS,2))**2
      ENDIF
      CALL OP1
c         save some values for Getequiv subroutine
      NSPACE(IPHASE) = NSPGRP
      NC(IPHASE) = FILL(1)         
      DO 5000 II=1,10
      DO 5000 JJ=1,7
 5000     NCONT(II,JJ,IPHASE) = NCN(II,JJ)
      N11(IPHASE) = N1
      IC1(IPHASE) = ICQ
C
      WRITE(6,36)LAU(NSPGRP)
      I1MAX=A*2.0*SQRT(SMAX)+20                                              !mmmm..what's this...
      I2MAX=B*2.0*SQRT(SMAX)+20                                              !NEEDED TO ADDED MORE FOR BIZARRE
      I3MAX=C*2.0*SQRT(SMAX)+20                                              !CASES SUCH AS WEIRD MONOCLINIC SETTINGS
      L1 = NSPGRP
 2233 continue
c  get hkl
      read(21,'(4I4,F15.5)',END=2303,ERR=2303) H1, H2, H3, IRC, FOBS
C	IF (IC.EQ.1)	write(*,*) h1,h2,h3,fobs

  113 SQ=FLOAT(H1*H1)*ASTAR+FLOAT(H2*H2)*BSTAR+FLOAT(H3*H3)*CSTAR
     & +FLOAT(H1*H2)*BACOSC+FLOAT(H1*H3)*CACOSB+FLOAT(H2*H3)*BCCOSA
      SQ=SQ/4.                                                            !SQ = h^2/(4a^2) + ...
c
 2234 IF (( SQ.GT.SMAX ).OR.(SQ.LE.TMIN)) GOTO 2233                       !if greater than zero read another one in
c		if we have a value SQ then...
      IF ( IC.GT.IRS-2 ) GO TO 6001                                       !IT WAS SET TO THE POS CASE
      KZ(1,1)=H1                                                          !CAUSING ERRORS WHEN SQ = 0
      KZ(2,1)=H2                                                          !AND TMIN = 0
      KZ(3,1)=H3
      AZ(1)=0.0
      IER=0
      CALL SMTRY2
      IF(IER.NE.0)GOTO 2233    
C
      IF (TOF) THEN
          LX1 = 1
          PIT = SQRT(1/(4*SQ))                                             ! STORE TOF VALUES AS D VALUES
          DMIN = DVAL(THMIN(NDS),LAMDA(NDS,1),LAMDA(NDS,2),ZERO)
          DMAX = DVAL(THMAX(NDS),LAMDA(NDS,1),LAMDA(NDS,2),ZERO)
          IF ((PIT.LE.DMAX).AND.(PIT.GE.DMIN)) THEN 
           PLOR = FINSPEC(NDS,TVAL(PIT,LAMDA(NDS,1),LAMDA(NDS,2),ZERO))/
     *                                            (16*SQ*SQ)               !TOF LORENTZIAN CORECTION
           IC = IC + 1                                                     !AND INCIDENT SPEC CORR
           FF(NDS,IC)=MULT(H1,H2,H3)
           REFS(NDS,IC,1)=VHALF(IPHASE,PIT,H1,H2,H3,NDS,NPROF(NDS))
           REFS(NDS,IC,2)=PIT
           REFS(NDS,IC,3)=PLOR                                       
           COBS(NDS,IC) = FOBS
           IF (FOBS.EQ.0.0) FOBS = 0.000011
           IF(NPROF(NDS).NE.3.AND.NPROF(NDS).NE.5) REFS(NDS,IC,4)=
     &        (WW(NDS)*REFS(NDS,IC,2) +VV(NDS))*REFS(NDS,IC,2) + UU(NDS)
           IREFS(NDS,IC)=256*(256*(256*(4*IPHASE+LX1)+128+H1)+128+H2)+
     &                128+H3
          ENDIF
      ELSE
          LXN=2
	    LX1=1
          IF(LAMDA(NDS,2).EQ.0..OR.LAMDA(NDS,2).EQ.LAMDA(NDS,1)) LXN=1
C          DO 3118 LX1=1,LXN                                                   !SIN(THETA) = SQRT(SQH) THEREFORE
            SQH=SQ*LAMDA(NDS,LX1)*LAMDA(NDS,LX1)                                !TAN(THETA) = SQRT(SQH/(1-SQH))
            TAN2=SQH/(1.-SQH)                                                     !NOTE: I BELIEVE EVERYTHING IS PUT IN TAN()
            IF(SQH.GE.1.)GOTO 3118                                                !AS OLDER COMPILERS MAY NOT HAVE HAD SIN OR COS?
            TANX=SQRT(TAN2)                                                     !TANX -> REAL 2THETA BASED ON CALC
            PIT=ATAN(TANX)/RAD+ZERO                                             !PIT  -> OBSERVED I.E. CALC + ZERO
            IF(PIT.GT.THMAX(NDS).OR.PIT.LT.THMIN(NDS)) GOTO 3118                !NOTE PIT = 2THETA AS RAD = PI/360 NOT PI/180
            IC=IC+1                                                    
            PLOR=1./(2.*SQH*SQRT(1.-SQH))
            IF (ISXRAY(JOBTYP(NDS)))                                            !LORENTZ-POLARIZATION
     &        PLOR=PLOR*(1.+(1.-2.*SQH)*(1.-2.*SQH)*CTHM(NDS))                !PLOR = 1+COS^2(2THETA)
            PADJ = PEAKSHFT(RVAL,TMV(NDS),PIT*0.5)
            FF(NDS,IC)=MULT(H1,H2,H3)
            REFS(NDS,IC,1)=VHALF(IPHASE,TANX,H1,H2,H3,NDS,NPROF(NDS))
            REFS(NDS,IC,2)=PIT+PADJ                                             !absorption shift addition
            REFS(NDS,IC,3)=PLOR
            REFS(NDS,IC,4)=0.0
            IF (FOBS.EQ.0.0) FOBS = 0.000011
		  COBS(NDS,IC) = FOBS
            IF(NPROF(NDS).NE.3.AND.NPROF(NDS).NE.5) REFS(NDS,IC,4)=
     &        (WW(NDS)*REFS(NDS,IC,2) +VV(NDS))*REFS(NDS,IC,2) + UU(NDS)

            IREFS(NDS,IC)=256*(256*(256*(4*IPHASE+IRC)+128+H1)+128+H2)+
     &                128+H3
 3118 CONTINUE        
      ENDIF																		!tof or cw
      GOTO 2233																	!read in another

 6001 WRITE(6,24)
 2303 ICX(NDS,IPHASE)=IC
      IF(IPHASE.GE.2) THEN
          DO 4 NP=1,IPHASE-1
    4     ICX(NDS,IPHASE)=ICX(NDS,IPHASE)-ICX(NDS,NP) 
      ENDIF
c
      WRITE(7,5001)ICX(NDS,IPHASE),NDS,IPHASE  
 5001 FORMAT(' There are a total of ',I4,' reflections in Histogram ',
     &I2,', Phase  ',I2)
      CALL SORT(IPHASE,NDS,IRS)
	GOTO 998
 7001	ERROR=71
	CLOSE(20)

  998 RETURN
c         return
      END
C         IREFS = PHASE NUMBER, H, K, L                                   
C         FF = MULTIPILICITY (FOR NOW)
C         REFS(1) = GAUSSIAN FWHM
C         REFS(2) = 2 THETA (ZERO INCLUDED)
C         REFS(3) = LORENTZ FACTOR
C         REFS(4) = SHAPE (LORENZTIAN PEAKSHAPE COMPONENT)
c
C     JOBTYPE = 1  XRAY DATA				   NOTE JOBTYPE IS +1 FROM THE INPUT FILE
C     JOBTYPE = 2  CW NEUTRON DATA
C     JOBTYPE = 3  XRAY CALC
C     JOBTYPE = 4  CW NEUTRON CALC
C     JOBTYPE = 5  TOF DATA
C     JOBTYPE = 6  TOF CALC
c
      LOGICAL FUNCTION ISCALC(JN)
      INTEGER JN
      ISCALC = .FALSE.
      IF ((JN.EQ.3).OR.(JN.EQ.4).OR.(JN.EQ.6)) ISCALC = .TRUE.
      RETURN
      END
C
      LOGICAL FUNCTION ISDATA(JN)
      INTEGER JN
      LOGICAL ISCALC
      ISDATA = .NOT. ISCALC(JN)
      RETURN
      END
C
      LOGICAL FUNCTION ISTOF(JN)
      INTEGER JN
      ISTOF = .FALSE.
      IF ((JN.EQ.5).OR.(JN.EQ.6)) ISTOF = .TRUE.
      RETURN
      END												  
C
      LOGICAL FUNCTION ISCW(JN)
      INTEGER JN
      LOGICAL ISTOF
      ISCW =  .NOT. ISTOF(JN)
      RETURN
      END
C
      LOGICAL FUNCTION ISXRAY(JN)
      INTEGER JN
      ISXRAY = .FALSE.
      IF ((JN.EQ.1).OR.(JN.EQ.3)) ISXRAY = .TRUE.
      RETURN
      END
C
      LOGICAL FUNCTION ISNEUT(JN)
      INTEGER JN
      LOGICAL ISXRAY
      ISNEUT = .NOT. ISXRAY(JN)
      RETURN
      END
c
c      LOGICAL FUNCTION ISBAIL(JN)
c      INTEGER JN
c	ISBAIL = .FALSE.
c	IF (JN.GE.7) ISBAIL = .TRUE.
c      RETURN
c	END
c
c**********************************************************************************
c
      SUBROUTINE INPTR(NDS,IDSZ,IRS,ERROR)
      include 'param.inc'
      REAL LAMDA,ZZ,DXYZ(3)
      INTEGER PTR,NDS,TNEX,ERROR,TEMPPH
      COMMON/DC/SAVE(NUPH,6),NSAVE
      INTEGER, Pointer::  IREFS(:,:),IC(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,IC
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS),TEMPAT1,TEMPAT2
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      CHARACTER SYMB(NUPH,20)*1,SPG(20)*1,FTEMP*250
      CHARACTER TITLE*80,PHSNM(NUPH)*80,FNAME*250,MOLTITLE*80,MOLSYM*20
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/SPG/NSP(2),NCONT(10),FILL(3)
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      COMMON/BLNK1/NJNK(22),FILL2(751)
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      CHARACTER*4 NAM(MAXDS,MAXFF),MTEXT,MTYPE
      COMMON/COEFC/NAM
      COMMON/CELLX/AA,B,C,ALPHA,BETA,GAMMA,AL(3,3)
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      COMMON/JNK2/WEIDS(MAXDS)
      COMMON/QUANT/NZF(NUPH),WATOM(NATS)
      COMMON/CTOF/AIV(MAXDS,9),PALP(2),PBET(2)
      COMMON/FORMF/ADFP(MAXDS,MAXFF,2),LDFP(MAXDS,MAXFF,2)
      COMMON/FILEINT/LC,LT,FNAME,FTEMP
      COMMON/MOLE/MOLTITLE(MAXMOLE),MOLSYM(MAXMOLE),NAMOLE(MAXMOLE),
     >            MTEXT(MAXAM),MTYPE(MAXAM),XMOLE(MAXAM,11),
     >            MOLDIM(MAXMOLE,6)
      COMMON/MAGN/MAGOPT(NATS,2)
	COMMON/DISRES/ATOMATOM(MAXRES,7)
	COMMON/DRAG/NUMHIS
      DIMENSION XRYZ(5)
CMLTT(MAXDS,IRS)
      DIMENSION FLGZER(MAXDS),ZER(MAXDS),BACK(MAXDS,12),FBACK(MAXDS,12)
C      EQUIVALENCE (MLTT(1,1),FF(1,1))
      INTEGER TDUMMY,IXRAY(MAXDS)
      CHARACTER DUM1*1,DUM2*1
C
      LOGICAL CONLY,DONLY,XONLY,NONLY,TOF,FOUND,LEBAIL
      LOGICAL ISCALC,ISDATA,ISNEUT,ISXRAY,ISTOF,ISCW
      LOGICAL ZBACK,OPENED
      DATA XRYZ(1),XRYZ(2),XRYZ(3),XRYZ(4),XRYZ(5)
     */2.28962,1.93597,1.54051,0.70926,0.556363/
C
      ERROR = 0
	OPENED = .FALSE.
      WRITE(7,*) 'Reading Input file....'     
      READ(5,1,END=99999,ERR=999)TITLE
1001  FORMAT(1X,A80)
   1  FORMAT(BZ,A80)
C
C         READ JOBTYPE, PROFILE TYPE, NUMBER OF PHASES, BACKGROUND TYPE...
C
      READ(5,2,END=99999,ERR=999)JOBTYP(1),NPROF(1),NPHASE,NBCKGD(1),
     *     NEXCRG(1),NSCAT(1),IWT(1),IABSCOR(1),IFULLILL(1),IGEOM(1),          
     *     NRES,NMOLE
      GLB(14) = 1.0                                                        !SCALER (FIRST ONE ALWAYS = 1)
      AGLB(14) = 0.0
      IAP(1) = 0
    2 FORMAT(BZ,12I4)                                                          
  211 FORMAT(BZ,2I4,F4.0,4I4)                                                          
      IF(NPHASE.EQ.0)NPHASE=1
      NDS = INT(JOBTYP(1)/10)+1
	NUMHIS=NDS
      CALL ALCMEMORY(NDS,IDSZ,IRS,1,ERROR)
      IF (ERROR.NE.0) RETURN
      JOBTYP(1) = JOBTYP(1) - (NDS-1)*10                                     
      JOBTYP(1)=JOBTYP(1)+1
      TNEX = NEXCRG(1)
      IF (NDS.GT.MAXDS) THEN
          WRITE(7,*) 'MORE HISTOGRAMS WANTED THAN ALLOWED'
          ERROR = 35
          RETURN
      ENDIF
      IF ((IABSCOR(1).GE.2).OR.(IABSCOR(1).LT.0)) THEN
          IABSCOR(1) = 0
      ENDIF
      IF(JOBTYP(1).LT.1.OR.JOBTYP(1).GT.6) THEN
          WRITE(7,*) 'ILLEGAL JOBTYPE'
          ERROR = 45
          RETURN
      ENDIF             
      CONLY= ISCALC(JOBTYP(1))                                                    !ONLY CALCULATION
      DONLY= ISDATA(JOBTYP(1))                                                    !ONLY DATA REFINEMENT
      NONLY= ISNEUT(JOBTYP(1))                                                    !ONLY NEUTRON REFINE/CALC
      XONLY= ISXRAY(JOBTYP(1))                                                    !ONLY X-RAY REFINE/CALC
C
C         Read any other histograms JOBTYPE,...
C
      IF (NDS.GE.2) THEN
      DO 2100 JJ=2,NDS
          READ(5,2,END=99999,ERR=999)JOBTYP(JJ),NPROF(JJ),TDUMMY,
     *        NBCKGD(JJ),NEXCRG(JJ),NSCAT(JJ),IWT(JJ),IABSCOR(JJ),
     *        IFULLILL(JJ),IGEOM(JJ)
          IAP(JJ) = 0
          JOBTYP(JJ) = JOBTYP(JJ) + 1
          IF (NEXCRG(JJ).GT.(MAXEXCL-2)) THEN
              WRITE(7,*) 'MAXIMUM EXCUDED REGIONS EXCEEDED'
              ERROR = 41
              RETURN
          ENDIF
          IF (IFULLILL(JJ).LE.0) IFULLILL(JJ) = 0
          IF (IFULLILL(JJ).GE.1) IFULLILL(JJ) = 1
          IF ((IABSCOR(JJ).GE.2).OR.(IABSCOR(JJ).LT.0)) THEN
              IABSCOR(JJ) = 0
          ENDIF
          IF(JOBTYP(JJ).LT.1.OR.JOBTYP(JJ).GT.6) THEN
              WRITE(7,*) 'ILLEGAL JOBTYPE'
              ERROR = 45
              RETURN
          ENDIF             
          TNEX = TNEX + NEXCRG(JJ)
          IF (IWT(JJ).EQ.0) IWT(JJ) = IWT(1)
          CONLY= CONLY.AND.ISCALC(JOBTYP(JJ))
          DONLY= DONLY.AND.ISDATA(JOBTYP(JJ))                                       
          NONLY= NONLY.AND.ISNEUT(JOBTYP(JJ))                     
          XONLY= XONLY.AND.ISXRAY(JOBTYP(JJ))                     
 2100 CONTINUE          
      ENDIF     
C      IF ((.NOT.CONLY).AND.(.NOT.DONLY)) THEN                             !STOP GAP MEASURE FOR THE
C          STOP 'MUST BE ALL CALCULATION OR ALL REFINEMENT'                !MOMENT UNTIL EVERYTHING WORKS
C      ENDIF                                                               !EVENTUALLY CAN HAVE JOINT CALCULATIONS AND REFINEMENTSAT SAME TIME
c
c         Write out header
c
      WRITE(6,3) VERSION
    3 FORMAT('  **** MULTI-RIETVELD ANALYSIS PROGRAM LH-RIET ',F5.3)
      WRITE(6,1001)TITLE
      WRITE(6,9)NPHASE,NDS,NMOLE,NRES
   9  FORMAT(' NUMBER OF PHASES = ',I4,/,' NUMBER OF HISTOGRAMS = ',I4,
     *     /,' NUMBER OF MOLECULES = ',I4,
     *     /,' NUMBER OF BOND RESTRAINTS = ',I4)
c
c         Read Control line in
c
      READ(5,14,END=99999,ERR=999)IOT,IPL,IPC,MAT,NXT,LST1,LST2,LST3,
     *IPL1,IPL2,IFOUR,NFMT,LSYNC,LMR,IDSBB,IBCK,IPREF,ITHER,IMARQT,
     *RADMIN,RADMAX,VMARQT                                                         
   14 FORMAT(BZ,19I1,1X,2F8.3,F8.5)
c
      IF ((IMARQT.EQ.2).AND.(VMARQT.EQ.0)) VMARQT = 0.5
c
      DO 231 JJ=1,NDS                                                           
          READ(5,23,END=99999,ERR=999) LAMDA(JJ,1),LAMDA(JJ,2),
     *     RATIO(JJ,2),WEIDS(JJ),WDT(JJ),CTHM(JJ),TMV(JJ),RLIM,FFLIM(JJ)
          IF (ISCW(JOBTYP(JJ))) THEN
              IF (LAMDA(JJ,2).EQ.0.0) LAMDA(JJ,2)=LAMDA(JJ,1)
              IF (RATIO(JJ,2).EQ.0.0) LAMDA(JJ,2)=LAMDA(JJ,1)
              IF (WEIDS(JJ).EQ.0) WEIDS(JJ) = 1.0
              RATIO(JJ,1)=1.0
          ENDIF
          IF (ISTOF(JOBTYP(JJ))) THEN                                                                    !READ TOF INCIDENT SPECTRUM
              READ(5,2311,END=99999,ERR=999) (AIV(JJ,I),I=1,9)
              RATIO(JJ,1)=1.0
          ENDIF       
  231 CONTINUE
 2311 FORMAT(9F9.0)
   23 FORMAT(BZ,10F8.0)
c
c         Get appropriate value of IXRAY depending on the wavelength
c         This value is then used in the lookup table of form factor values
c
      DO 119 JJ=1,NDS
          DO 109 IX=1,5                                                       
              IF(LAMDA(JJ,1)+0.1.GT.XRYZ(IX))GOTO 119
  109     CONTINUE
  119     IXRAY(JJ)=IX
c
      IF(NPROF(1).LT.4) WRITE(6,29)RLIM
   29 FORMAT(' ASYMMETRY CORRECTION FOR ANGLES LESS THAN ',F8.3,
     *' DEGREES')
c
c         Depending on LSYNC read theta values in as either f8 (old way) or f12 (new way)
c
      IF (LSYNC.EQ.0) THEN                                                    !old theta
          READ(5,30,END=99999,ERR=999)MCYCLE,EPS,RELAX,THMIN(1),STEP(1),
     *                                THMAX(1),AGLB(15),AGLB(16)
      ELSE
        READ(5,3001,END=99999,ERR=999)MCYCLE,EPS,RELAX,THMIN(1),STEP(1),
     *                                THMAX(1),AGLB(15),AGLB(16)              !new theta (sync)
      ENDIF                                             
c
c         Read the two theta, etc, values in for other histograms - this is the only free format line
c
      IF (NDS.GT.1) THEN
        DO JJ=2,NDS
          JJJ=(JJ-1)*MAXIGL
          READ(5,*,END=99999,ERR=999)THMIN(JJ),STEP(JJ),THMAX(JJ),
     &                GLB(14+JJJ),AGLB(14+JJJ),AGLB(15+JJJ),AGLB(16+JJJ)               !new theta FOR MULTI
        ENDDO
      ENDIF    
      DO JJ=1,NDS
	   JJJ=(JJ-1)*MAXIGL
	   GLB(15+JJJ) = LAMDA(JJ,1)
	   GLB(16+JJJ) = LAMDA(JJ,2)
	ENDDO
 3001 FORMAT(BZ,1I4,5F4.0,3F12.0,2F8.2)
   30 FORMAT(BZ,1I4,5F4.0,3F8.0,2F8.2)
c
c             Write out the information read in so far
c
      DO 1111 JJ=1,NDS                                            
          WRITE(6,1112) JJ
 1112 FORMAT(/,' *** HISTOGRAM ',I2,' ***')
          IF(JOBTYP(JJ).EQ.1)WRITE(6,4)
          IF(JOBTYP(JJ).EQ.2)WRITE(6,5)
          IF(JOBTYP(JJ).EQ.3)WRITE(6,6)
          IF(JOBTYP(JJ).EQ.4)WRITE(6,7)
          IF(JOBTYP(JJ).EQ.5)WRITE(6,711)
          IF(JOBTYP(JJ).EQ.6)WRITE(6,712)
C          IF(JOBTYP(JJ).EQ.7)WRITE(6,713)
C          IF(JOBTYP(JJ).EQ.8)WRITE(6,714)
C          IF(JOBTYP(JJ).EQ.9)WRITE(6,715)
    4 FORMAT(10X,'FOR X-RAY DATA')
    5 FORMAT(10X,'FOR CW NEUTRON DATA')
    6 FORMAT(10X,'PATTERN CALCULATION, XRAY')
    7 FORMAT(10X,'PATTERN CALCULATION, CW NEUTRON')
  711 FORMAT(10X,'FOR TOF NEUTRON DATA')
  712 FORMAT(10X,'PATTERN CALCULATION, TOF NEUTRON')
C
          IF(IWT(JJ).EQ.1) WRITE(6,36)
   36 FORMAT(10X,'WEIGHTING SCHEME BASED ON YCALC FOR DATASET')
          IF(IMARQT.EQ.0) WRITE(6,363)
          IF(IMARQT.EQ.1) WRITE(6,361) VMARQT
          IF(IMARQT.EQ.2) WRITE(6,362) VMARQT
  361 FORMAT(10X,'MARQUARDT ALGORITH - FIXED PARAMETER OF ',F8.5)
  362 FORMAT(10X,'MARQUARDT ALGORITH - AUTOMATIC, STARTING FROM',F8.5)
  363 FORMAT(10X,'NEWTON-RAPHSON ALGORITH')
          IF (NEXCRG(JJ).NE.0)WRITE(6,611) NEXCRG(JJ)
          IF (NSCAT(JJ).NE.0)WRITE(6,612) NSCAT(JJ)
  611 FORMAT(10X,'THERE ARE ',I2,' EXCLUDED REGIONS')
  612 FORMAT(10X,'THERE ARE ',I2,' SCATTERING SETS')                  
C
          IF(NBCKGD(JJ).LE.1) THEN
              IF(NBCKGD(JJ).NE.1) WRITE(6,10) (IBCK+1)*6
              IF(NBCKGD(JJ).EQ.-6) WRITE(6,1016)                                 
              IF(NBCKGD(JJ).EQ.-5) WRITE(6,1015)                                 
              IF(NBCKGD(JJ).EQ.-4) WRITE(6,1014)                                 
              IF(NBCKGD(JJ).EQ.-3) WRITE(6,1013)                                 
              IF(NBCKGD(JJ).EQ.-2) WRITE(6,1012)                                 
              IF(NBCKGD(JJ).EQ.-1) WRITE(6,1010)
              IF(NBCKGD(JJ).EQ.0)  WRITE(6,1011)
              IF(NBCKGD(JJ).EQ.1)  WRITE(6,11)
          ELSE
              WRITE(6,12) NBCKGD(JJ)
          ENDIF
   10 FORMAT(10X,'BACKGROUND TO BE REFINED (MAX ',I2,' PARAMETERS)')
   11 FORMAT(10X,'BACKGROUND DATA TO BE READ FROM FILE')
   12 FORMAT(10X,'BACKGROUND CORRECTION BY INTERPOLATION ',
     *'BETWEEN THE ',I4,' POINTS GIVEN')
 1010 FORMAT(15X,'- AMORPHOUS SINC FUNCTION BACKGROUND')
 1011 FORMAT(15X,'- POLYNOMIAL BACKGROUND')
 1012 FORMAT(15X,'- CHEYBSHEV I POLYNOMIAL BACKGROUND')
 1013 FORMAT(15X,'- SHIFTED CHEYBSHEV I POLYNOMIAL BACKGROUND')
 1014 FORMAT(15X,'- CHEYBSHEV II POLYNOMIAL BACKGROUND')
 1015 FORMAT(15X,'- SHIFTED CHEYBSHEV II POLYNOMIAL BACKGROUND')
 1016 FORMAT(15X,'- DAMPED AMORPHOUS SINC FUNCTION BACKGROUND')
  113     IF (NPROF(JJ).EQ.1) WRITE(6,13)                                     !Rietveld Asym + Pseduo Voigt
          IF (NPROF(JJ).EQ.2) WRITE(6,131)                                    !Rietveld Asym + Pearson
          IF (NPROF(JJ).EQ.3) WRITE(6,132)                                    !Rietveld Asym + Voigt
          IF (NPROF(JJ).EQ.4) WRITE(6,13)                                     !Howard Asym + Pseduo Voigt
          IF (NPROF(JJ).EQ.5) WRITE(6,132)                                    !Howard Asym + Voigt
          IF (NPROF(JJ).EQ.6) WRITE(6,13)                                     !FJC Asym + Pseduo Voigt
          IF (NPROF(JJ).EQ.7) WRITE(6,134)                                    !Jorgensen TOF
          IF (NPROF(JJ).EQ.8) WRITE(6,135)                                    !not currently implemented
   13 FORMAT(10X,'THE PSEDUO-VOIGT PROFILE FUNCTION WAS SELECTED')
  131 FORMAT(10X,'THE PEARSON VII PROFILE FUNCTION WAS SELECTED')
  132 FORMAT(10X,'THE VOIGT PROFILE FUNCTION WAS SELECTED')
  134 FORMAT(10X,'THE JORGENSEN PROFILE FUNCTION WAS SELECTED')
  135 FORMAT(10X,'THE IKEA-CARPENTER PROFILE FUNCTION WAS SELECTED')
          IF ((NPROF(JJ).LE.3).AND.(NPROF(JJ).GE.1)) WRITE(6,136)
          IF ((NPROF(JJ).LE.5).AND.(NPROF(JJ).GE.4)) WRITE(6,137)
          IF (NPROF(JJ).EQ.6) WRITE(6,138)
  136 FORMAT(10X,'- USING THE RIETVELD ASYMMETRY')
  137 FORMAT(10X,'- USING THE HOWARD, SUM OF 5 PEAKS, ASYMMETRY')
  138 FORMAT(10X,'- USING THE FINGER/COX/JEPHCOAT ASYMMETRY')
          IF (ISCW(JOBTYP(JJ))) THEN
              WRITE(6,24)LAMDA(JJ,1),LAMDA(JJ,2)
              WRITE(6,223)RATIO(JJ,2)
          ELSE
              WRITE(6,240) LAMDA(JJ,1),LAMDA(JJ,2),RATIO(JJ,2)
              WRITE(6,241) (AIV(JJ,I),I=1,9)
          ENDIF
   24 FORMAT(10X,'WAVELENGTHS = ',2F8.5)
  223 FORMAT(10X,'ALPHA2:ALPHA1 RATIO = ',F8.4)
  240 FORMAT(10X,'TOF CONSTANTS: DIFC, DIFA = ',2F10.3,/,
     *       10X,'BANK ANGLE = ', F10.3)
  241 FORMAT(10X,'TOF INCIDENT SPECTRUM: A0..A8 = ',3(1X,G9.3),/,
     *15X,6(1X,G9.3))
          WRITE(6,26) WDT(JJ)
   26 FORMAT(10X,'BASE OF PEAK = 2.0*HW*',F8.2)
          WRITE(6,27)CTHM(JJ)
   27 FORMAT(10X,'MONOCHROMATOR CORRECTION =',F8.4)               
          IF(ISTOF(JOBTYP(JJ))) WRITE(6,282) TMV(JJ)
          IF(ISCW(JOBTYP(JJ)).AND.IABSCOR(JJ).EQ.0) WRITE(6,28) TMV(JJ)
          IF(ISCW(JOBTYP(JJ)).AND.IABSCOR(JJ).EQ.1) WRITE(6,283)                  
   28 FORMAT(10X,'ABSORPTION CORRECTION FOR CYLINDER SAMPLE',/,10X,
     *'USING ALGORITHM OF SABINE(1996)/DWIGGINS(1972) WITH mu = ',
     *F8.4)
  283 FORMAT(10X,'ABSORPTION CORRECTION FOR FLAT PLATE',/,10X,
     *'USING ALGORITHM OF HERMANN AND ERMRICH(1987)')
  282 FORMAT(10X,'ABSORPTION CORRECTION FOR TOF: A=EXP(-muR*d), mu =',
     *F8.4)
          IF (IFULLILL(JJ).EQ.0) WRITE(6,295)
          IF (IFULLILL(JJ).EQ.1) WRITE(6,296)
  295 FORMAT(10X,'NO ILLUMINATION CORRECTION')
  296 FORMAT(10X,'FULL ILLUMINATION CORRECTION (sin(theta))')
          IF (IPREF.EQ.0) WRITE(6,291)
          IF (IPREF.EQ.1) WRITE(6,292)
  291 FORMAT(10X,'PREFERRED ORIENTATION USING MARCH MODEL ',
     *' - NO SUMMING OF EQUIVALENTS')
  292 FORMAT(10X,'PREFERRED ORIENTATION USING MARCH MODEL ',
     *' - SUMMING OF EQUIVALENTS')
          WRITE(6,281) WEIDS(JJ)
  281 FORMAT(10X,'HISTOGRAM WEIGHTING =',F8.4)
          IF (IGEOM(JJ).EQ.0) WRITE(6,301)
          IF (IGEOM(JJ).EQ.1) WRITE(6,302)
  301	FORMAT(10X,'NO OTHER GEOMETRY CORRECTIONS APPLIED')
  302 FORMAT(10X,'USING BRAGG-BRENTANO SAMPLE DISPLACEMENT')
 1111 CONTINUE
C
      WRITE(6,*)
          IF((LMR.EQ.0).AND.(NDS.GT.1)) WRITE(6,1521)
 1521 FORMAT(' READING DATA SEQUENTIALLY FROM 1 FILE')
          IF(LSYNC.NE.0) WRITE(6,1510)                                             
 1510 FORMAT(' READING DATA AS SYNCROTRON DATA')                     
          IF(ITHER.NE.0)WRITE(6,1811)
 1811 FORMAT(' ANISOTROPIC THERMALS WILL ALSO BE PRINTED AS <u^2>')
          IF(IOT.NE.0)WRITE(6,15)
   15 FORMAT(' OUTPUT OBSERVED AND CALCULATED INTENSITIES ON ',
     *'LAST CYCLE')
          IF(IPL.NE.0)WRITE(6,16)
   16 FORMAT(' GENERATE LINE PRINTER PLOT')
          IF(IPL2.NE.0)WRITE(6,17)
   17 FORMAT(' GENERATE OFF-LINE PLOT')
          IF(IPL2.EQ.1)WRITE(6,253)
          IF(IPL2.EQ.2)WRITE(6,25)
          IF(IPL2.EQ.3)WRITE(6,251)
          IF(IPL2.EQ.4)WRITE(6,252)
   25 FORMAT(5X,' - ILL PLOT FILE OF OBS AND CALC DATA')
  251 FORMAT(5X,' - LHPM PLOT FILE OF OBS AND CALC DATA')
  252 FORMAT(5X,' - LHPM NORMALIZED PLOT FILE OF OBS AND CALC DATA')
  253 FORMAT(5X,' - KALEDIA/ORIGIN  PLOT FILE OF OBS AND CALC DATA')
          IF(IFOUR.NE.0) WRITE(6,106)
          IF(IFOUR.EQ.1) WRITE(6,1060)
          IF(IFOUR.EQ.2) WRITE(6,1061)
          IF(IFOUR.EQ.4) WRITE(6,1062)
          IF(IFOUR.EQ.5) WRITE(6,1063)
          IF(IFOUR.EQ.6) WRITE(6,1064)
  106 FORMAT(' GENERATE FOURIER FILE ON UNIT 20')
 1060 FORMAT(5X,' - FOURIER FORMAT IN FOURIER MAP FORMAT')
 1061 FORMAT(5X,' - FOURIER FORMAT IN SHELX FORMAT')
 1062 FORMAT(5X,' - FOURIER CALC')
 1063 FORMAT(5X,' - sqrt(FOBS),sqrt(FCALC)')
 1064 FORMAT(5X,' - EXTRA/SIRPOW97 REF2 FORMAT')
          IF(IPC.NE.0)WRITE(6,18)
   18 FORMAT(' OUTPUT STRUCTURE FACTORS')
      IF(MAT.NE.0.AND.DONLY) WRITE(6,19)
   19 FORMAT(' OUTPUT CORRELATION MATRIX')
      IF(NXT.NE.0.AND.DONLY) WRITE(6,20)
   20 FORMAT(' GENERATE NEW INPUT FILE')
          IF(LST1.NE.0)WRITE(6,21)
   21 FORMAT(' PRINT REFLECTION LIST')
          IF(NPHASE.EQ.1)LST3=0
          IF(LST3.NE.0)WRITE(6,8)
    8 FORMAT(' PRINT MERGED REFLECTION LIST')
          IF(LST2.NE.0)WRITE(6,22)
   22 FORMAT(' PRINT CORRECTED DATA')
          IF (CONLY) MCYCLE=1
          WRITE(6,31)MCYCLE
   31 FORMAT(' NUMBER OF CYCLES = ',I4)
          WRITE(6,32)RELAX
   32 FORMAT(' RELAXATION FACTORS:',/,
     *'   FOR COORDINATES, ISOTROPIC B, SITE OCCUPANCY = ',F5.2,/,
     *'   FOR ANISOTROPIC TEMPERATURE FACTORS = ',F5.2,/,
     *'   FOR SCALE, ZERO, B OVERALL, UNIT CELL, PREFERRED ORIENTATION',
     *' BACKGROUND = ',F5.2,/,
     *'   FOR PEAK WIDTH, ASYMMETRY, SHAPE PARAMETERS = ',F5.2)
          WRITE(6,33)EPS
   33 FORMAT(' EPS-VALUE =',F6.3)                                             
c
      DO JJ=1,NDS
          IF(NBCKGD(JJ).GE.2) THEN
            IF (NBCKGD(JJ).GT.MAXBK) THEN
              WRITE(7,*) 'MORE BACKGROUND THAN ALLOWED'
              ERROR=42
              GOTO 998
            ENDIF 
            READ(5,34,END=99999,ERR=999)(POS(JJ,II),BCK(JJ,II),
     *                                 II=1,NBCKGD(JJ))
            WRITE(6,35)JJ,(POS(JJ,II),BCK(JJ,II),II=1,NBCKGD(JJ))
          ENDIF
      ENDDO
   34 FORMAT(BZ,2F8.2)
   35 FORMAT(' BACKGROUND FOR HISTOGRAM ',I2,/,' POSITION    INTENSITY'
     *       ,/,99(F12.4,5x,f10.3,/))                                              !NEED TO CHANGE THE 99 FOR MAXBK >99            
C
  120 IF (TNEX.NE.0) THEN
        WRITE(6,37)
        DO JJ=1,NDS                      
          IF (NEXCRG(JJ).NE.0) THEN
              DO I=1,NEXCRG(JJ)
                  READ(5,373,END=99999,ERR=999) ALOW(JJ,I),AHIGH(JJ,I)
                  WRITE(6,372)ALOW(JJ,I),AHIGH(JJ,I),JJ 
              ENDDO
          ENDIF
        ENDDO
      ENDIF
   37 FORMAT(' EXCLUDED REGIONS:      FROM        TO   IN  HISTORGRAM')
  372 FORMAT(20X,F12.4,2X,F12.4,5X,I2)
  373 FORMAT(2F8.4)
C
      NINTSC = 0 
  122 DO 124 JJ=1,NDS
          IF(NSCAT(JJ).LE.0)GOTO 124
          DO 125 I=1,NSCAT(JJ)
              IF (ISNEUT(JOBTYP(JJ))) THEN
                  READ(5,38,END=99999,ERR=999)  NAM(JJ,I),DFP(JJ,I,2),
     *                         ADFP(JJ,I,1)                                           !PICK UP NEUTRONS
                  DO 425 J=1,9
  425                 AC(JJ,J,I)=0.0
                  DFPP(JJ,I)=0.0
              ELSE                                                                    !PICK UP XRAYS
                  K=0                                                       
                  READ(5,38,END=99999,ERR=999)NAM(JJ,I),DFP(JJ,I,1),
     *                    DFPP(JJ,I),ADFP(JJ,I,1),ADFP(JJ,I,2)                         
  126             READ(5,39,END=99999,ERR=999)(AC(JJ,J,I),J=1,9)                      !NOW INTERPOLATES INSTEAD OF CALC
                  IF(AC(JJ,1,I).EQ.-100.) GOTO 1251
                  IF(AC(JJ,3,I).NE.0.) GOTO 1251                           
                  K=K+1                                                               !SIN()/LAM,F
                  IF (K.EQ.1) NINTSC = NINTSC + 1
                  POSI(K,I)=AC(JJ,1,I)											!NINTSC = SCATTER NUMBER
                  SCAT(K,I)=AC(JJ,2,I)
                  IF(K.LE.(MFCO-1))GOTO126
                  WRITE(6,40)
                  ERROR = 43
                  GOTO 998
              ENDIF
 1251         IF (AC(JJ,1,I).EQ.-100.0) AC(JJ,4,I) = NINTSC      
              IF (AC(JJ,1,I).EQ.-100.0) AC(JJ,5,I) = K      
              DO 1110 KI = 1,2           
                  X = ADFP(JJ,I,KI)
                  IYY = INT(ABS(X)/10.0) 
                  LDFP(JJ,I,KI) = IYY     
 1110             ADFP(JJ,I,KI) = SIGN(1.0,X)*(ABS(X)-10.*FLOAT(IYY))
  125     CONTINUE
  124 CONTINUE
 38   FORMAT(BZ,A4,4F8.0)
 39   FORMAT(BZ,F8.0,8F9.0)
 40   FORMAT(' TOO MANY SCATTERING TABLE ENTRIES ')
C
      READ(5,43,END=99999,ERR=999)MAXS
      IF (MAXS.GT.MSZ) THEN
          WRITE(7,*) 'NUMBER OF VARIABLES GREATER THAN ALLOWED'
          ERROR = 44
      ENDIF
   43 FORMAT(BZ,I8)
      IF (CONLY) MAXS=0
      WRITE(6,44) MAXS
   44 FORMAT(/,' NUMBER OF PARAMETERS VARIED = ',I5,/)
c
c     read zero values/codewords
      READ(5,45,END=99999,ERR=999)(ZER(JJ),FLGZER(JJ),JJ=1,NDS)
   45 FORMAT(BZ,10F8.0)                                                   
      WRITE(6,46)                                                           
   46 FORMAT(' GLOBAL PARAMETERS AND CODEWORDS:')                       
      DO 1462 JJ=1,NDS
          WRITE(6,1460)JJ,ZER(JJ),FLGZER(JJ)                          
 1462 CONTINUE
 1460 FORMAT(5X,'ZEROPOINT(',I2,') = ',2F8.2)
c
c     read sample displacement values/codewords
      DO JJ=1,NDS
      IF (IGEOM(JJ).EQ.1) THEN
       JJJ = (JJ-1)*MAXIGL
       READ(5,'(F10.0,F8.3)',END=99999,ERR=999) GLB(JJJ+17),AGLB(JJJ+17)
       WRITE(6,1465) JJ,GLB(17+JJJ),AGLB(JJJ+17)
	ENDIF
      ENDDO
 1465 FORMAT(5X,'SAMPLE DISPLACEMENT(',I2,') = ',F8.5,F8.2)

C     READ DATA IN
      DO 1120 JJ=1,NDS
          IF(ISCALC(JOBTYP(JJ))) THEN                                              !FOR PATTERN CALC
              NPTS(JJ)=(THMAX(JJ)-THMIN(JJ))/STEP(JJ)+1.5
              IF (NPTS(JJ).GT.IDSZ) THEN
	           NPTS(JJ) = IDSZ-200                                               !TRIES TO CATCH WHEN THERE ARE
	           THMAX(JJ) = THMIN(JJ)+STEP(JJ)*NPTS(JJ)                           !NOT ENOUGH DATA POINTS IN ARRAY
              ENDIF
          ELSE
              CALL DATAREAD(JJ,IDSZ,NFMT,LSYNC,LMR,ERROR)
              IF (ERROR.NE.0) RETURN
          ENDIF
 1120 CONTINUE
C                   
      DO 49 JJ=1,NDS
          ZBACK = .TRUE.
          IF(NBCKGD(JJ).GT.0)GOTO 49
          READ(5,51,END=99999,ERR=999) (BACK(JJ,J),J=1,6*(IBCK+1))
          READ(5,51,END=99999,ERR=999) (FBACK(JJ,J),J=1,6*(IBCK+1))
          DO J=1,6*(IBCK+1)															!STOPS A DIVERGENT ERROR WHEN
             ZBACK = ZBACK.AND.(BACK(JJ,J).EQ.0.0)									!REFINING FROM 0.0
		ENDDO
          IF (ZBACK) BACK(JJ,1) = 0.000001
C          IF ((BACK(JJ,1).EQ.0).AND.(FBACK(JJ,1).GE.0)) THEN
C               BACK(JJ,1) = YMEAN(JJ,IDSZ,NPTS(JJ))                                        !SIMPLE ESTIMATE OF 
C          ENDIF                                                                       !CONSTANT BACKGROUND TERM
          WRITE(6,521) JJ                                                             
          WRITE(6,52) (BACK(JJ,J),J=1,6*(IBCK+1)),
     *                (FBACK(JJ,J),J=1,6*(IBCK+1))
   49 CONTINUE
   51 FORMAT(BZ,6G12.6)
  521 FORMAT(/,5X,'BACKGROUND PARAMETERS AND CODEWORDS(',I2,')')
   52 FORMAT(5X,6F12.6,/,6F12.6)
 483  CONTINUE              
c
      DO 1030 JJ=1,NDS  
          JJJ = (JJ-1)*MAXIGL
          IF (AGLB(JJJ+15).NE.0) THEN
              IF (ISCW(JOBTYP(JJ))) THEN
                  WRITE(6,5011) JJ,LAMDA(JJ,1),AGLB(JJJ+15)
              ELSE
                  WRITE(6,5012) JJ,LAMDA(JJ,1),AGLB(JJJ+15),
     &                            LAMDA(JJ,2),AGLB(JJJ+16)
              ENDIF
          ENDIF
 1030 CONTINUE
 5012 FORMAT(5X,'DIFC/A(',I2,') = ',2(F8.3,F8.2,5X))
 5011 FORMAT(/,5X,'WAVELENGTH(',I2,') = ',F8.6,F8.2)
c
      DO 574 JJ=1,NDS
          JJJ= (JJ-1)*MAXIGL
          GLB(1+JJJ) = ZER(JJ)
          AGLB(1+JJJ)= FLGZER(JJ)
          DO 574 IJ=1,12
              GLB(IJ+JJJ+1) = BACK(JJ,IJ)
              AGLB(IJ+JJJ+1) = FBACK(JJ,IJ)
  574 CONTINUE         
C
C         Calculate/Read Background
C
      DO 4801 K=1,NDS                  
      TOF = ISTOF(JOBTYP(K))
      IF(NBCKGD(K).EQ.1) GOTO 475
C             BACKGROUND FUCTIONAL EG. POLYNOMIAL/AMORPHOUS
      DO 473 I=1,NPTS(K)
          TH=THMIN(K)+(I-1)*STEP(K)
          BK(K,I) = BACKFN(K,NBCKGD(K),TOF,TH,IBCK,ERROR)
          IF (ERROR.NE.0) RETURN
  473 CONTINUE
      GOTO 4801
C         BACKGROUND FROM FILE
  475 OPEN(UNIT=2,FILE=FNAME(1:LC)//'.bck',STATUS='OLD',ERR=99997) 
      CALL READBCK(K,NFMT,LSYNC,THMIN(K),STEP(K),THMAX(K),ERROR)
      IF (ERROR.NE.0) RETURN
 4801 CONTINUE
C
c
c    
  477 DO 440 J=1,NDS
      DO 440 K=1,NPHASE
  440 IC(J,K)=0
C
C                       START OF LOOP OVER MOLECULES
      IOF = 0
      DO K=1,NMOLE
         READ(5,'(A80)',END=99999,ERR=999) MOLTITLE(K)
         READ(5,'(A20,I4)',END=99999,ERR=999)	MOLSYM(K),NAMOLE(K)
         READ(5,65,END=99999,ERR=999) (MTEXT(I+IOF),MTYPE(I+IOF),
     *               (XMOLE(I+IOF,J),J=1,11),I=1,NAMOLE(K))                    
         READ(5,'(6F8.4)',END=99999,ERR=999) (MOLDIM(K,I),I=1,6)
         IOF = IOF + NAMOLE(K)
      ENDDO
C
C
C                       START OF GIANT LOOP OVER NUMBER OF PHASES
C
      DO 8111 K=1,NPHASE
      READ(5,465,END=99999,ERR=999)PHSNM(K)
  465 FORMAT(BZ,A80)
   47 FORMAT(/,' ****** PHASE ',I2,' *******',/,1X,A80,/)
      WRITE(6,47)K,PHSNM(K)
      DO 1040 J=1,NDS
          READ(5,4810,END=99999,ERR=999)NATOM(K),NZF(K),
     *    (PREF(J,K,I),I=1,3),(ANHKL(J,K,I),I=1,3)
          IF(NATOM(K).EQ.0) THEN
            IPTYPE(K) = 1
            WRITE(6,511)
          ELSE
            IPTYPE(K) = 0
            WRITE(6,512)
          ENDIF
          IF(ANHKL(J,K,1).NE.0.0.OR.ANHKL(J,K,2).NE.0.0.OR.
     *        ANHKL(J,K,3).NE.0.0) IAP(J) = 1
          IF(PREF(J,K,1).EQ.0.0.AND.PREF(J,K,2).EQ.0.0.AND.
     *        PREF(J,K,3).EQ.0.0) PREF(J,K,3)=1.0
          IF (J.EQ.1) THEN
              IF (NZF(K).EQ.0) NZF(K) = 1
              WRITE(6,1480) NZF(K)
              N = ABS(NATOM(K))
              WRITE(6,480) N
          ENDIF
          WRITE(6,486) J,(PREF(J,K,I),I=1,3)
          IF (IAP(J).NE.0) WRITE(6,489) J,(ANHKL(J,K,I),I=1,3)
 1040 CONTINUE        
      N=ABS(NATOM(K))
  511 FORMAT(' PHASE IS CALCULATED USING LE BAIL EXTRACTION')             
  512 FORMAT(' PHASE IS CALCULATED USING STRUCTURAL INPUT')             
  489 FORMAT(' ANISOTROPIC VECTOR(',I2,') = ',3F8.4)             
  486 FORMAT(' PREFERRED ORIENTATION VECTOR(',I2,') = ',3F8.4)
  480 FORMAT(' NUMBER OF ATOMS =',I4)
 1480 FORMAT(' NUMBER OF FORMULA PER UNIT CELL =',I4)
   48 FORMAT(BZ,I4,8X,3F4.0)
 4810 FORMAT(BZ,2(I4,2X),3F4.0,8X,3F4.0,2X,I1)
      READ(5,460,END=99999,ERR=999)(SYMB(K,I),I=1,20)
  460 FORMAT(BZ,20A1)
      DO 1351 I=1,20
 1351 SPG(I)=SYMB(K,I)
      CALL SPGP(SPG)
C-----READ AND PRINT FOR EACH ATOM
      IOF=0
      IF(K.GT.1) THEN
      DO 441 KK=1,K-1
  441 IOF=IOF+ABS(NATOM(KK))
      ENDIF
   65 FORMAT(BZ,2A4,1X,2A1,5X,5F8.5/6F8.5)
  651 FORMAT(3F8.5)
      IF (N.GT.0) THEN
         WRITE(6,57)
         DO I=1,N
            READ(5,65,END=99999,ERR=999) ATEXT(I+IOF),NTYP(I+IOF),
     *         DUM1,DUM2,(XL(I+IOF,J),J=1,11)
            IF ((DUM1.EQ.'M').OR.(DUM1.EQ.'m')) THEN
               MAGOPT(I+IOF,1) = 1
               READ(5,651,END=99999,ERR=999) (XL(I+IOF,J),J=12,14)
            ELSE
               MAGOPT(I+IOF,1) = 0
            ENDIF                    
            IF ((DUM2.EQ.'I').OR.(DUM2.EQ.'i')) THEN
               MAGOPT(I+IOF,2) = 1
            ELSE
               MAGOPT(I+IOF,2) = 0
            ENDIF                    
         ENDDO
         DO 660 I=1,N
  660       WATOM(I+IOF) = GETMASS(NTYP(I+IOF))
         DO I=1,N
           WRITE(6,170) ATEXT(I+IOF),NTYP(I+IOF),(XL(I+IOF,J),J=1,11)
           IF (MAGOPT(I+IOF,1).EQ.1) WRITE(6,1701) (XL(I+IOF,J),J=12,14)
         ENDDO
      ENDIF
 1701 FORMAT(22X,3F10.5)  
      IF (NPROF(1).LE.6) THEN                                                     !READ PARAMETERS
          READ(5,50,END=99999,ERR=999)(PAR(K,I),I=1,5),PAR(K,19),
     *       (PAR(K,I),I=6,14),PAR(K,20),(PAR(K,I),I=15,18) 
      ELSE
          READ(5,501,END=99999,ERR=999)(PAR(K,I),I=1,5),PAR(K,19),
     *       (PAR(K,I),I=21,24),(PAR(K,I),I=6,18)                                 !READ EXTRA VALUES IN FOR TOF
      ENDIF
      IF(IABSCOR(1).EQ.1)READ(5,502,END=99999,ERR=999)(PAR(K,I),I=25,26)
      IF (PAR(K,12).EQ.0) PAR(K,12) = 1.0                                         !PREF. ORIENTATION = 1.0 IF READ IN 0.0
   50 FORMAT(G12.6,4X,F8.0,/,4F8.2,/,        6F8.2,/,4F8.4,/,4F8.5)
  501 FORMAT(G12.6,4X,F8.0,/,4F8.2,/,4F8.2,/,6F8.2,/,3F8.4,/,4F8.5)
  502 FORMAT(2F8.4)
C     FOR MORE DATASETS
      IF (NDS.GT.1) THEN
          DO 1980 JJ=2,NDS
             J = (JJ-1)*MAXIPAR 
             IF (NPROF(JJ).LE.6) THEN
                 READ(5,1986,END=99999,ERR=999) (PAR(K,I+J),I=3,5),
     >PAR(K,J+19),(PAR(K,I+J),I=12,14),PAR(K,20+J),(PAR(K,I+J),I=15,18)
             ELSE
                 READ(5,1987,END=99999,ERR=999) (PAR(K,I+J),I=3,5),
     >             PAR(K,J+19),(PAR(K,I+J),I=21,24),(PAR(K,I+J),I=12,18)
             ENDIF
             IF(IABSCOR(JJ).EQ.1)READ(5,502,END=99999,ERR=999)
     >                                (PAR(K,I+J),I=25,26)	       
             IF (PAR(K,12+J).EQ.0) PAR(K,12+J) = 1.0                              !PREF. ORIENTATION = 1.0 IF READ IN 0.0
 1980     CONTINUE
      ENDIF
 1986 FORMAT(4F8.4,/        ,4F8.4,/,4F8.4)
 1987 FORMAT(4F8.4,/,4F8.4,/,3F8.4,/,4F8.4)
C         write out information          
      WRITE(6,662)
  662 FORMAT(/,15X,'***** PHASE INFORMATION *****')
      WRITE(6,66) (PAR(K,I),I=1,2),(PAR(K,I),I=6,11)
      AAA = PAR(1,6)
      BB = PAR(1,7)
      CC = PAR(1,8)
   66 FORMAT(' OVERALL SCALE FACTOR =',G12.6,/,
     *' OVERALL TEMP. FACTOR =',F12.5,/,
     *' DIRECT CELL PARAMETERS =',6F9.4)
      DO 1981 JJ=1,NDS
          J = (JJ-1)*MAXIPAR
          JJJ=(JJ-1)*MAXIGL
          WRITE(6,661)JJ,GLB(14+JJJ),AGLB(14+JJJ)
          WRITE(6,459) PAR(K,12+J)
          IF (IABSCOR(JJ).EQ.0) THEN
              WRITE(6,4592) PAR(K,13+J)
          ELSE
              WRITE(6,4593) PAR(K,13+J),(PAR(K,I+J),I=25,26)
          ENDIF    
          IF (NPROF(JJ).LE.6) THEN
              WRITE(6,4590) PAR(K,J+14),PAR(K,J+20),(PAR(K,I+J),I=3,5)
          ELSE
              WRITE(6,4591) (PAR(K,I+J),I=3,5),(PAR(K,I+J),I=21,24)
          ENDIF          
          IF (IAP(JJ).NE.0) WRITE(6,5001) PAR(K,J+19)
          GOTO (100,101,102,100,102,101,1020) NPROF(JJ)
  100     WRITE(6,462) (PAR(K,I+J),I=15,17)
          GOTO 103
  101     WRITE(6,463) (PAR(K,I+J),I=15,17)
          GOTO 103
  102     WRITE(6,464) PAR(K,15+J),PAR(K,16+J)         
          GOTO 103
 1020     WRITE(6,4640) (PAR(K,I+J),I=15,17)
  103     WRITE(6,5000) PAR(K,18+J)
 1981 CONTINUE
  459 FORMAT(' PREFERRED ORIENTATION PARAMETER = ',F8.4)
 4592 FORMAT(' ABSORPTION R = ',F8.4)
 4593 FORMAT(' ABSORPTION Po = ',F8.4,/,
     *' ABSORPTION C1 = ',F8.4,/,
     *' ABSORPTION C2 = ',F8.4)
 4590 FORMAT(' ASYMMETRY PARAMETERS = ',F8.6,2X,F8.6,/,
     *' GAUSSIAN HALF-WIDTH PARAMETERS = ',3F12.4)
 4591 FORMAT(' GAUSSIAN HALF-WIDTH PARAMETERS = ',3F12.4,/,
     *' JORGENSEN:  ALPHA 1&2, BETA 1&2: ',4F12.4)
  462 FORMAT(' PSEUDO-VOIGT PEAK SHAPE = ',/,10X,F8.4,' + ',
     *F8.5,' * TWOTH + ',F8.6,' * TWOTHSQ')
  463 FORMAT(' PEARSON VII PEAK SHAPE = ',/,10X,F8.4,' + ',
     *F8.5,' * TWOTH + ',F8.6,' * TWOTHSQ')
  464 FORMAT(' VOIGT PEAK SHAPE = ',2(F8.4,2X))
 4640 FORMAT(' TOF LORENZTIAN = ',3(F8.4,2X))
  661 FORMAT(/,15X,'*** HISTOGRAM ',I2,' ***',/,
     *' HISTOGRAM SCALE FACTOR = ',G12.6,2X,F8.2)
 5000 FORMAT(' EXTINCTION PARAMETER = ',F10.6)
 5001 FORMAT(' ANISOTROPIC PARAMETER = ',F10.6)
      AA=PAR(K,6)
      B=PAR(K,7)
      C=PAR(K,8)
      ALPHA=PAR(K,9)
      BETA=PAR(K,10)
      GAMMA=PAR(K,11)
      CALL CELL2(ERROR)
      IF (ERROR.NE.0) GOTO 998
      DO 72 I=1,6
   72 SAVE(K,I)=PAR(K,I+5)
      DO 73 I=1,3
   73 PAR(K,I+5)=AL(I,I)
      PAR(K,9)=AL(2,3)
      PAR(K,10)=AL(1,3)
      PAR(K,11)=AL(1,2)
      IF(CONLY) GO TO 151                          
C----- READ AND PRINT CODEWORDS FOR ATOMIC PARAMETERS
      IF (N.GT.0) THEN 
        WRITE(6,82)
        READ(5,861,END=99999,ERR=999)((A(I+IOF,J),J=1,11),I=1,N)
  861   FORMAT(BZ,5F8.2,/,6F8.2)
        WRITE(6,85)(ATEXT(I+IOF),(A(I+IOF,J),J=1,11),I=1,N)
        DO 83 I=1,N
          DO 84 J=1,11
              X=A(I+IOF,J)
              IYY=INT(ABS(X)/10.)
              LP(I+IOF,J)=IYY
   84     A(I+IOF,J)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
   83   CONTINUE
      ENDIF
C-----READ AND PRINT CODEWORDS FOR PROFILE PARAMETERS
      IF (NPROF(1).LE.6) THEN
         READ(5,68,END=99999,ERR=999)(APAR(K,I),I=1,5),APAR(K,19),
     *     (APAR(K,I),I=6,14),APAR(K,20),(APAR(K,I),I=15,18)
      ELSE
         READ(5,680,END=99999,ERR=999)(APAR(K,I),I=1,5),APAR(K,19),
     *                    (APAR(K,I),I=21,24),(APAR(K,I),I=6,18)
      ENDIF    
      IF (IABSCOR(1).EQ.1) READ(5,681,END=99999,ERR=999) 
     >   (APAR(K,I),I=25,26)
  680 FORMAT(F8.2,8X,F8.2,/,4F8.2,/,4F8.2,/,6F8.2,/,3F8.2,/,4F8.4)
   68 FORMAT(F8.2,8X,F8.2,/,4F8.2,/,6F8.2,/,4F8.2,/,4F8.4)
  681 FORMAT(2F8.2)
C
      WRITE(6,89) (APAR(K,I),I=1,2),(APAR(K,I),I=6,11)
   89 FORMAT(/,15X,' ***** PHASE INFORMATION CODEWORDS *****',/
     *' OVERALL SCALE FACTOR =',F8.2,/,
     *' OVERALL TEMP. FACTOR =',F8.2,/,
     *' CELL CONSTANTS =',6F8.2)
  105 FORMAT(/,15X,' *** HISTROGRAM ',I2,' CODEWORDS ***',/,
     *' PREFERRED ORIENTATION PARAMETER = ',F8.2,/,
     *' ABSORPTION R/Po PARAMETER = ',F8.2,/,
     *' ASYMMETRY PARAMETERS = ',2(F8.2,2X),/,
     *' GAUSSIAN COMPONENT = ',3F8.2)
 1051 FORMAT(' ABSORPTION C1,C2 = ',2(F8.2,2X))
 1050 FORMAT(' JORGENSEN: ALPHA1&2 = ',2F8.2,/,
     *' JORGENSEN: BETA1&2 = ',2F8.2)
      DO 1511 JJ=1,NDS
          J = (JJ-1)*MAXIPAR
          IF (JJ.GE.2) THEN
              READ(5,1512,END=99999,ERR=999) (APAR(K,J+I),I=3,5),
     >                                        APAR(K,J+19)
              IF (NPROF(JJ).EQ.7) READ(5,1512,END=99999,ERR=999) 
     >                            (APAR(K,J+I),I=21,24)
              READ(5,1515,END=99999,ERR=999) (APAR(K,J+I),I=12,14),
     >                            APAR(K,J+20),(APAR(K,J+I),I=15,18)               
              IF (IABSCOR(JJ).EQ.1) THEN
                  READ(5,681,END=99999,ERR=999) (APAR(K,J+I),I=25,26)
              ENDIF
          ENDIF
          WRITE(6,105) JJ,(APAR(K,J+I),I=12,14),APAR(K,J+20),
     >                    (APAR(K,J+I),I=3,5)
          IF (IAP(JJ).NE.0) WRITE(6,5102) APAR(K,J+19)
          IF (IABSCOR(JJ).EQ.1) WRITE(6,1051) (APAR(K,I),I=25,26)
          IF (NPROF(JJ).EQ.7) WRITE(6,1050) (APAR(K,J+I),I=21,24)
C
          GOTO (400,401,402,400,402,401,4020) NPROF(JJ)
  400     WRITE(6,5105) (APAR(K,J+I),I=15,17)
          GOTO 403
  401     WRITE(6,5105) (APAR(K,J+I),I=15,17)
          GOTO 403
  402     WRITE(6,5106) (APAR(K,J+I),I=15,17)
          GOTO 403
 4020     WRITE(6,5105) (APAR(K,J+I),I=15,17)
  403     WRITE(6,5101) APAR(K,J+18)
 1511 CONTINUE
C
C         READ IN BOND RESTRAINTS
  503 FORMAT(I2,2X,2A4,2F8.3)
      IF(NRES.NE.0) THEN
	    DO I=1,NRES 
             DO KK=1,7
	          ATOMATOM(I,KK)=0.0
             ENDDO
             IOF=0
             READ(5,503,END=99999,ERR=999) TEMPPH,TEMPAT1,TEMPAT2,
     *                                     (ATOMATOM(I,J),J=4,5)
c             WRITE(*,*) TEMPPH,TEMPAT1,TEMPAT2,(ATOMATOM(I,J),J=4,5)
             ATOMATOM(I,1) = TEMPPH
             IF ((TEMPPH.LE.0).OR.(TEMPPH.GT.NPHASE)) THEN
                WRITE(7,*) 'INVALID PHASE NUMBER FOR RESTRAINT',I
                GOTO 99992 
             ENDIF
             IF(TEMPPH.GT.1) THEN
                DO KK=1,TEMPPH-1
                  IOF=IOF+ABS(NATOM(KK))
                ENDDO
             ENDIF
             DO J=1,ABS(NATOM(TEMPPH))
	          IF (ATEXT(J+IOF).EQ.TEMPAT1) ATOMATOM(I,2)=J
	          IF (ATEXT(J+IOF).EQ.TEMPAT2) ATOMATOM(I,3)=J
	       ENDDO
             IF ((ATOMATOM(I,2).EQ.0).OR.(ATOMATOM(I,3).EQ.0)) THEN
                WRITE(7,*) 'RESTRAINT ',I,'HAS INVALID ATOMS'
                GOTO 99991 
             ENDIF
	    ENDDO
	ENDIF
C
 1512 FORMAT(4F8.2)
 1515 FORMAT(4F8.2,/,4F8.2)
 1513 FORMAT(4F8.2,/,4F8.2,/,3F8.2,/,4F8.2)
 5101 FORMAT(' EXTINCTION = ',F8.2)
 5102 FORMAT(' ANISOTROPIC =',F8.2)
 5105 FORMAT(' LORENZTIAN COMPONENTS = ',3(F8.2,2X))                
 5106 FORMAT(' VOIGT LORENZTIAN COMPONENTS = ',2(F8.2,2X))
C
      DO 87 I=1,MAXIPAR*NDS                                               !SOME PAR MAY BE BLANK BUT WHO CARES!
          X=APAR(K,I)                                                     !(AND IT DOES ALLOW FUTURE EXPANSION)
          IYY=INT(ABS(X)/10.)
          LPAR(K,I)=IYY
   87 APAR(K,I)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
 151  CONTINUE
      DO 130 JJ=1,NDS
      IF (N.GT.0) THEN
      IF (ISXRAY(JOBTYP(JJ))) THEN
          CALL LOOKUP(K,ABS(NATOM(K)),NSCAT(JJ),IXRAY(JJ),1,JJ,ERROR)               !XRAY
          IF (ERROR.NE.0) GOTO 998
          WRITE(6,42)
          DO 1150 I =1,NSAVE
              IF (AC(JJ,3,I).NE.0) THEN
                  WRITE(6,41) NAM(JJ,I),DFP(JJ,I,1),DFPP(JJ,I),
     >                 (AC(JJ,J,I),J=1,9)
              ELSE
                  WRITE(6,410) NAM(JJ,I),INT(AC(JJ,5,I))                                 
                  WRITE(6,'(2F12.6,2X)') (POSI(II,I),
     *                    SCAT(II,I),II=1,AC(JJ,5,I))           !TODO - ONLY PRINT REQUIRED ONES
              ENDIF
 1150     CONTINUE
      ELSE                               
          CALL LOOKUP(K,ABS(NATOM(K)),NSCAT(JJ),IXRAY(JJ),2,JJ,ERROR)               !NEUTRON     
          IF (ERROR.NE.0) GOTO 998
          WRITE(6,422) JJ
          WRITE(6,423)(NAM(JJ,I),DFP(JJ,I,2),I=1,NSAVE)
      ENDIF           
      ENDIF   
  130 CONTINUE
  422 FORMAT(/,' SCATTERING LENGTHS FOR HISTOGRAM ',I2)                                     
  423 FORMAT(5H FOR ,A4,5H     ,F10.6)
   42 FORMAT(/,' FORMFACTORS FOR HISTOGRAM ',I2)                                             
   41 FORMAT(' FOR ',A4,' DFP=',F10.6,' DFPP=',F10.6,/,
     >' COEFFICIENTS= ',9F10.6)
  410 FORMAT(' INTERPOLATION FOR ',A4,' USING THE FOLLOWING ',I4,
     >       ' POINTS:')
csjk   COPY this subroutine above refgen call to define mlt(nuph) before call to calcul
csjk   from refgen
c          packs the space group into IVEC
      CALL RTMT(IPL1,K)
c          generate the REF array
      LEBAIL = IPTYPE(K).EQ.1                                           !TRUE WHEN LEBAIL
	IF ((IDSBB.EQ.1).AND.(LEBAIL).AND.(.NOT.OPENED)) then
		OPEN(unit=21,file=fname(1:LC)//'.HKL',status='OLD',ERR=8222)             !HKL file
          READ(21,'(A)',ERR=99993) FOURTITLE
	    OPENED = .TRUE.
          GOTO 8223
 8222     IDSBB = 0
 8223		CONTINUE
      ENDIF
      DO JJ=1,NDS
         J = (JJ-1)*MAXIPAR
         U(JJ)=PAR(K,3+J)                                                    
         V(JJ)=PAR(K,4+J)
         W(JJ)=PAR(K,5+J)
         UU(JJ)=PAR(K,15+J)
         VV(JJ)=PAR(K,16+J)
         WW(JJ)=PAR(K,17+J)
         IF ((IDSBB.EQ.1).AND.(LEBAIL).AND.(OPENED)) then
            CALL REFREAD(K,IRS,ZER(JJ),PAR(K,13+J),JJ,ERROR)
         ELSE
            CALL REFGEN(K,IRS,ZER(JJ),PAR(K,13+J),JJ,ERROR)
         ENDIF
         IF (ERROR.NE.0) GOTO 998
      ENDDO
c          packs the space group into IVEC
      CALL RTMT(IPL1,K)
C             FINISH LOOP OVER PHASES
 8111 CONTINUE
C
C       FIND THE SYMMETRY OPERATORS FOR THE BOND RESTRAINTS
 8333 DO II=1,NRES
        IRL1=MLT(INT(ATOMATOM(II,1)))											!s.group multiplicity for phase number    
	  I = 0
	  FOUND = .FALSE.
        DO WHILE ((.NOT.FOUND).AND.(I.LT.IRL1))
          I = I + 1
          J = 0
          DO WHILE ((.NOT.FOUND).AND.(J.LT.IRL1))
             J = J + 1
             ZZ =  BONDCALC(INT(ATOMATOM(II,1)),INT(ATOMATOM(II,2)),
     >         INT(ATOMATOM(II,3)),I,J,DXYZ)
             IF ( ABS(ZZ-ATOMATOM(II,4)) .LE.(20*ATOMATOM(II,5)) ) THEN
                 ATOMATOM(II,6) = I
                 ATOMATOM(II,7) = J
                 FOUND = .TRUE.
				write(7,*) (ATOMATOM(II,zzz),zzz=1,7)
             ENDIF
	    ENDDO
	  ENDDO
	ENDDO


C      
      DO 4850 JJ=1,NDS
      DO 81 K =1,NPHASE
      IF (K.EQ.1) THEN
          ICZ=0
          ICY=1
          IXDEL=0
      ENDIF
c
      IF (K.GT.1) ICY=ICY+IC(JJ,K-1)
      ICZ=ICZ+IC(JJ,K)
      IF (LST1.NE.1) GO TO 479
      IF(K.GT.1) IXDEL=IXDEL+IC(JJ,K-1)
      DO 481 IXX=ICY,ICZ
      IX=IXX-IXDEL
      IRL=MOD(IREFS(JJ,IXX),256)-128
      IRK=MOD(IREFS(JJ,IXX)/256,256)-128
      IRH=MOD(IREFS(JJ,IXX)/256/256,256)-128
      IRC=MOD(IREFS(JJ,IXX)/256/256/256,4)
      GO TO (91,91,93,91,93) NPROF(JJ)
   91 IF(MOD(IX-1,50).EQ.0) WRITE(6,485)
  485 FORMAT(' NO.  CODE     H   K   L   MULT    HW',
     *'     POSN       FACTOR   SHAPE'/)
      WRITE(6,570)IX,IRC,IRH,IRK,IRL,INT(FF(JJ,IXX)),(REFS(JJ,IXX,JX),
     *JX=1,4)
  570 FORMAT(1X,2I4,3X,3I4,I6,2F8.3,1X,F12.3,F8.3)
      GO TO 481
   93 IF(MOD(IX-1,50).EQ.0) WRITE(6,482)
  482 FORMAT(' NO.  CODE     H   K   L   MULT    HW     ',
     *'POSN    FACTOR'/)
      WRITE(6,470)IX,IRC,IRH,IRK,IRL,INT(FF(JJ,IXX)),(REFS(JJ,IXX,JX),
     *JX=1,3)
  470 FORMAT(1X,2I4,3X,3I4,I6,2F8.3,F10.6)
  481 CONTINUE  
c		Important!  this adds to REFS(,,3) the hkl multiplicity
  479 DO 499 IX=ICY,ICZ
  499     REFS(JJ,IX,3)=REFS(JJ,IX,3)*FF(JJ,IX)

c

   81 CONTINUE
 4850 CONTINUE
C           CURRENTLY 10*NDS GLOBAL PARS FOR EACH DATASET:1 ZERO,6 BACKGROUND,1 SCALOR,1 WAVELENGTH, 1 DIFA
      DO 88 I=1,MAXGP
          X=AGLB(I)
          IYY=INT(ABS(X)/10.)
          LGLB(I)=IYY
   88 AGLB(I)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
C
   57 FORMAT(/,' ***INITIAL PARAMETERS***',/,' ATOM  NTYP            '
     1,6X,'X',9X,'Y',9X,'Z',9X,'B',9X,'N',/,27X,'B11'
     2,7X,'B22',7X,'B33',7X,'B12',7X,'B13',7X,'B23')
  571 FORMAT(/,' ***INITIAL PARAMETERS***',/,' ATOM  NTYP            '
     1,6X,'X',9X,'Y',9X,'Z',9X,'B',9X,'N',/,27X,'u^211'
     2,5X,'u^222',5X,'u^233',5X,'u^212',5X,'u^213',5X,'u^223')
   67 FORMAT(BZ,4F8.2)
   76 FORMAT(' CELL CONSTANTS=',6F12.8)
   77 FORMAT(BZ,2F8.4)
   82 FORMAT(/,' ***CODING OF VARIABLES***',/,' ATOM',24X,'X',9X,'Y',9X
     1,'Z',9X,'B',9X,'N',/,27X,'B11',7X,'B22',7X
     2,'B33',7X,'B12',7X,'B13',7X,'B23')
   85 FORMAT(1X,A4,17X,5F10.2/22X,6F10.2)
   86 FORMAT(BZ,8F8.2)
  170 FORMAT(1X,A4,1X,A4,12X,5F10.5/22X,6F10.5)  
  998 CLOSE(21)
      RETURN
99999 CONTINUE
      ERROR=31
      RETURN
99998 CONTINUE
      ERROR=32
      RETURN
99997 CONTINUE
      ERROR=33
      RETURN
  999 ERROR = 34
      RETURN
99996 ERROR=35
      RETURN
99991 ERROR=37
      RETURN
99992 ERROR=38
      RETURN
99993 ERROR=71
      RETURN
      END
c
c**********************************************************************************
c
      SUBROUTINE ASSIGN(NDS,IDSZ,IRS,ERROR)
      include 'param.inc'
      REAL LAMDA,HW
      INTEGER, Pointer::  IREFS(:,:),IC(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,IC
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      CHARACTER SYMB(NUPH,20)*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80
      COMMON/CHAR/SYMB,TITLE,PHSNM
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      DIMENSION KRR(2,IDSZ),ICN(NUPH)
      INTEGER NDS,JP,ERROR
      LOGICAL TOF,CALC,ISCALC,ISTOF
      ERROR = 0
C      
      CALC = ISCALC(JOBTYP(NDS))
C     CODE FOR REFLECTIONS BEYOND OBS PATTERN
      NNPTS=NPTS(NDS)                                                     !NNPTS NOW = REAL NUMBER OF POINTS
      NPTS(NDS)=(THMAX(NDS)-THMIN(NDS))/STEP(NDS) + 1.5                   !NPTS = EXPANDED RANGE (AFTER REFGENS EXPANSION)
      NLPTS = (AHIGH(NDS,NEXCRG(NDS))- ALOW(NDS,NEXCRG(NDS)))/STEP(NDS)
     &            +1.5
      NXPTS=NPTS(NDS)-NNPTS-NLPTS                                         !NXPTS = # OF POINTS BEYOND REAL
      DO 1001 I=NNPTS,1,-1
         Y(NDS,NLPTS+I) = Y(NDS,I)
         WT(NDS,NLPTS+I) =WT(NDS,I)
         IF (CALC) WT(NDS,NLPTS+I) = 1.0
         BK(NDS,NLPTS+I) =BK(NDS,I)
 1001 CONTINUE
      DO 1002 I=1,NLPTS                                                           
          Y(NDS,I) = 1.0
         WT(NDS,I) = 1.0
         BK(NDS,I) = 1.0
 1002 CONTINUE
      DO 100 I=1,NXPTS
          Y(NDS,NNPTS+I+NLPTS)=   1.0
          WT(NDS,NNPTS+I+NLPTS)=  1.0
          BK(NDS,NNPTS +I+NLPTS)=  1.0
  100 CONTINUE
C     END CODE
      ICX=0
      TOF = ISTOF(JOBTYP(NDS))
C
      DO 101 I=1,NPHASE
          ICX=ICX+IC(NDS,I)
          ICN(I)=IC(NDS,I)
  101     IC(NDS,I)=0
C
      IC(NDS,1)=ICX
      IF (NPHASE.GT.1) CALL SORT(1,NDS,IRS)
C
      DO 102 I=1,NPHASE
  102 IC(NDS,I)=ICN(I)
C
      DO 2 J=1,2
      DO 2 K=1,IDSZ
   2  KRR(J,K)=0
C
      IF(LST3.EQ.0)GOTO 7
C
      DO 8 I=1,ICX
          IRL=MOD(IREFS(NDS,I),256)-128
          IRK=MOD(IREFS(NDS,I)/256,256)-128
          IRH=MOD(IREFS(NDS,I)/256/256,256)-128
          IRC=MOD(IREFS(NDS,I)/256/256/256,4)
          IPHAS=IREFS(NDS,I)/256/256/256/4
          IF(MOD(I-1,50).EQ.0)WRITE(6,9)
    8 WRITE(6,10)I,IRC,IRH,IRK,IRL,IPHAS,(REFS(NDS,I,JX),JX=1,2)
C
    9 FORMAT(10X,'MERGED REFLECTION LIST',//,
     *' NO.  CODE     H   K   L   PHASE  HW    POSN  ',/)
   10 FORMAT(1X,2I4,3X,3I4,I6,2F8.3)
C
    7 DO 479 I=1,ICX                                      
          IF (.NOT.TOF) THEN                 
              RMIN=REFS(NDS,I,2)-WDT(NDS)*REFS(NDS,I,1)
              RMAX=REFS(NDS,I,2)+WDT(NDS)*REFS(NDS,I,1)
              MIN=(RMIN-THMIN(NDS))/STEP(NDS)+1.5
              MAX=(RMAX-THMIN(NDS))/STEP(NDS)+1.5
              MIN=MAX0(MIN,1)
              MIN=MIN0(MIN,NPTS(NDS))
              MAX=MIN0(MAX,NPTS(NDS))
          ELSE        
              JP = (NDS-1)*MAXIGL
              RMIN=TVAL(REFS(NDS,I,2),LAMDA(NDS,1),LAMDA(NDS,2),
     *                GLB(JP+1))-THMIN(NDS)
              RMAX=TVAL(REFS(NDS,I,2),LAMDA(NDS,1),LAMDA(NDS,2),
     *                GLB(JP+1))-THMIN(NDS)
              HW = VHALF(1,REFS(NDS,I,2),0,0,0,NDS,NPROF(NDS))
              MAX=(RMIN+WDT(NDS)*HW)/STEP(NDS) +1.5
              MIN=(RMAX-WDT(NDS)*HW)/STEP(NDS) +1.5                       !NOTE REFS(2) = 2THETA FOR CW AND = D SPACING FOR TOF
              MIN=MAX0(MIN,1)
              MIN=MIN0(MIN,NPTS(NDS))
              MAX=MIN0(MAX,NPTS(NDS))
          ENDIF
          DO 479 K=MIN,MAX
              KRR(2,K)=I
  479     IF(KRR(1,K).EQ.0)KRR(1,K)=I
C
      DO 482 J=1,NEXCRG(NDS)
C          IF(AHIGH(NDS,J).LE.THMIN(NDS)) GOTO 482
C          IF(ALOW(NDS,J).GT.THMAX(NDS)) GOTO 482
          IN1=(ALOW(NDS,J)-THMIN(NDS))/STEP(NDS)+1.5
          IN1=MAX0(IN1,1)
          IN2=(AHIGH(NDS,J)-THMIN(NDS))/STEP(NDS)+1.5
          IN2=MIN0(IN2,NPTS(NDS))
          DO 483 I=IN1,IN2
              KRR(2,I)=1
  483         KRR(1,I)=0
C          IF(IN2.EQ.NPTS(NDS)) GOTO 484                                  !REMOVED SINCE IT IS NOT NEEDED
  482 CONTINUE                                                            !AND RUINS MULTI-DATASETS
  484 CONTINUE
C
      IF(ISCALC(JOBTYP(NDS))) GOTO 301                                    !CALC
C
      DO 300 J=1,NPTS(NDS)
          IF(Y(NDS,J).EQ.0.0) Y(NDS,J)=BK(NDS,J)/2.0                      !? CHANGES DATA, BUT WHY AND WHEN WOULD IT?
          IF(WT(NDS,J).EQ.0.0) WT(NDS,J)=1.0
          IF(Y(NDS,J).LT.0.0) WT(NDS,J)=1.0                               !REMOVES BAD POINTS FROM REFINEMENT	CHANGED TO 1.0 FROM PREVIOUS 0.0
          IF(WT(NDS,J).LT.0.0) WT(NDS,J)=1.0                              !REMOVES BAD POINTS FROM REFINEMENT
          IF (NFMT.LT.2) THEN
              IF(NBCKGD(NDS).EQ.1) THEN
                  WT(NDS,J)=WT(NDS,J)/(Y(NDS,J)+BK(NDS,J))                !THE 2 DIFFERENT WEIGHTINGS
              ELSE
                  WT(NDS,J)=WT(NDS,J)/Y(NDS,J)
              ENDIF
          ENDIF
  201 CONTINUE
  300 CONTINUE
  301 CONTINUE
C
      IF(LST2.EQ.0)GOTO 530
      WRITE(6,589)NDS,THMIN(NDS),THMAX(NDS),STEP(NDS)
 589  FORMAT(' HISTOGRAM ',I2,' FROM',F12.5,' TO ',F12.5,' IN STEPS OF '
     *,F10.5,' DEGREES')
      WRITE(6,544)
 544  FORMAT('  POSN',10X,'I+B',5X,'B',7X,'I',4X,'100*W',3X,'K11',2X,
     *'K21')
      DO 520 J=1,NPTS(NDS)
          PX=THMIN(NDS)+FLOAT(J-1)*STEP(NDS)
          YUN=Y(NDS,J)-BK(NDS,J)
      WRITE(6,559)PX,Y(NDS,J),BK(NDS,J),YUN,WT(NDS,J),(KRR(J2,J),J2=1,2)
  559 FORMAT(1X,F12.4,3F7.0,2PF9.4,2I5)                                  
  520 CONTINUE
  530 CONTINUE
C
      DO 600 I=1,NPTS(NDS)
          IF(KRR(2,I)-KRR(1,I).GT.NIPOI)THEN
              WRITE(6,601)
              WRITE(7,601)
              ERROR = 46
              GOTO 998 
          ENDIF
  600 CONTINUE
  601 FORMAT(1X,'EXCESSIVE PEAK OVERLAP')
C
      DO 531 I=1,NPTS(NDS)
          KR(NDS,I)=KRR(1,I)+IRS*KRR(2,I)                                          !this may be restrictive if INTEGER*2 is the default 
  531 CONTINUE                                                                     !as IRS*NIPOI must be less than 32768 (i think)
C
      DO 602 I=1,NPTS(NDS)
           IF(KR(NDS,I).NE.0.AND.KR(NDS,I).NE.IRS)GOTO 603
  602 CONTINUE
C
      WRITE(7,*) 'NO REFLECTIONS FOUND'                                                  !should we be able to continue the refinement
      ERROR = 52
      GOTO 998
C                                                                                  !without any reflections?
C THE FOLLOWING TEST IS REALLY ONLY VALID FOR THE SINGLE PHASE CASE
  603 IF(REFS(NDS,KRR(1,I),2).GE.RLIM.AND.LPAR(1,14+(NDS-1)*MAXIPAR)
     *.NE.0.AND.NPROF(NDS).LT.4) THEN
          WRITE(6,604)
          WRITE(7,604)
           OR = 54
          GOTO 998
      ENDIF
  604 FORMAT(1X,'ASYMMETRY PARAMETER USAGE INVALID')
C
      DO 606 I=1,NPHASE
          IF((PAR(I,12+(NDS-1)*MAXIPAR).EQ.0.).AND.
     &       (LPAR(I,12+(NDS-1)*MAXIPAR).NE.0))THEN
              WRITE(6,605)
              WRITE(7,605)
              ERROR = 53
              GOTO 998
          ENDIF
  606 CONTINUE
  605 FORMAT(1X,'PREFERRED ORIENTATION USAGE INVALID')
C
  998 RETURN
      END
c
c**********************************************************************************
c
      SUBROUTINE CHISQ(NDS,IRS)
      include 'param.inc'
      COMMON/G2/S1(MAXDS),S2(MAXDS),S3(MAXDS),D1(MAXDS),D2(MAXDS),
     &          R1(MAXDS),R2(MAXDS),R3(MAXDS),DWD(MAXDS),WDWD(MAXDS),
     &          R1TOT,R2TOT,R3TOT
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      REAL T1,T2,T3,TH
      INTEGER NDS,KK,JJ,I
      LOGICAL ISCALC
      T1 = 0.0
      T2 = 0.0
      T3 = 0.0
      R1TOT = 0.0
      R2TOT = 0.0
      R3TOT = 0.0
      DO 20 JJ = 1,NDS
      S1(JJ)=0.0
      S2(JJ)=0.0
      D1(JJ)=0.0
      D2(JJ)=0.0
      S3(JJ)=0.0
      DWDN=0.0
      DWDD=0.0
      WDWDN=0.0
      WDWDD=0.0
      IF (ISCALC(JOBTYP(JJ))) GOTO 20            !SKIP FOR CALCULATIONS
      DO 10 I=1,NPTS(JJ)
          IF(KR(JJ,I).EQ.IRS) GOTO 10
          IF(NBCKGD(JJ).GT.0.AND.KR(JJ,I).EQ.0) GOTO 10
          DO 1000 KK=1,NEXCRG(JJ)              
              TH=THMIN(JJ)+(I-1)*STEP(JJ) 
 1000         IF((TH.GE.ALOW(JJ,KK)).AND.(TH.LE.AHIGH(JJ,KK))) GOTO 10
          DEL=Y(JJ,I)-BK(JJ,I)-YC(JJ,I)
          S1(JJ)=S1(JJ)+ABS(DEL)
          S2(JJ)=S2(JJ)+DEL*DEL*WT(JJ,I)
          D1(JJ)=D1(JJ)+Y(JJ,I)
          D2(JJ)=D2(JJ)+Y(JJ,I)*Y(JJ,I)*WT(JJ,I)
          S3(JJ)=S3(JJ)+BK(JJ,I)+YC(JJ,I)
          IF(I.EQ.1) GO TO 11
          DELK=Y(JJ,I-1)-BK(JJ,I-1)-YC(JJ,I-1)
          DWDEL=( DEL - DELK )**2
          WDWDEL=( DEL * SQRT(WT(JJ,I))
     *             - DELK * SQRT(WT(JJ,I-1)) )**2
          DWDN=DWDN+DWDEL
          WDWDN=WDWDN+WDWDEL
   11     CONTINUE     
          DWDD=DWDD + DEL*DEL
          WDWDD=WDWDD + DEL*DEL*WT(JJ,I)
   10 CONTINUE
      R1(JJ)=0   
      R2TOT = S1(JJ) + R2TOT
      T2 = D1(JJ) + T2
      R3TOT = SQRT(S2(JJ)) + R3TOT
      T3 = SQRT(D2(JJ)) + T3
      R2(JJ)=100.*S1(JJ)/D1(JJ)
      R3(JJ)=100.*SQRT(S2(JJ)/D2(JJ))
      DWD(JJ)=DWDN/DWDD
      WDWD(JJ)=WDWDN/WDWDD
   20 CONTINUE              
      R2TOT = 100.*R2TOT/T2
      R3TOT = 100.*R3TOT/T3
      RETURN
      END
C
c
c**********************************************************************************
c
      SUBROUTINE ITER(NDS,IRS,IMCYCLE,IFINISH,ERROR)
      include 'param.inc'                                 
      REAL LAMDA,PERCENT
      COMMON/F1/RJAC(MSZ2),VX(MSZ),OCHI
      COMMON/F3/RJAC2(MSZ,MSZ)
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/G2/S1(MAXDS),S2(MAXDS),S3(MAXDS),D1(MAXDS),D2(MAXDS),
     &          R1(MAXDS),R2(MAXDS),R3(MAXDS),DWD(MAXDS),WDWD(MAXDS),
     &          R1TOT,R2TOT,R3TOT
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      CHARACTER SYMB(NUPH,20)*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      CHARACTER*4 NAM(MAXDS,MAXFF)
      COMMON/COEFC/NAM
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      COMMON/G3/COND,IORD1,IORD2,TH,NUM(MAXDS)
      REAL, POINTER:: COBS(:,:),SOMEGA(:,:),VAR(:,:)
      COMMON/RBRAGG/COBS,SOMEGA,VAR
      COMMON/JNK2/WEIDS(MAXDS)
      COMMON/ABSCALC/ABT,DABT,ALT,DALT,ABSVAL,FIRSTABS(MAXDS)
      COMMON/RUNNING/PERCENT
      INTEGER, Pointer::  IREFS(:,:),IC(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,IC
	COMMON/DISRES/ATOMATOM(MAXRES,7)
      DIMENSION VLAST(MSZ)
      INTEGER NDS,NSUM,ERROR,IMCYCLE,IFINISH,TOTALPTS,INDEXPTS,IPH
      LOGICAL CALC,TOF,ISTOF,ISCALC,LEBAIL,ISBAIL
      REAL SSUM,DER1,DER2,GMAT(3,3),DXYZ(3)
      IFINISH = 0
      ERROR = 0       
C         ZERO MATRIX AND VECTOR ELEMENTS
      DO 70 I=1,MAXS
   70   VLAST(I)=0.
c
C      DO 10 IX=1,MCYCLE                                                       !START OF LOOP THROUGH # OF CYCLES
      IX = IMCYCLE
      IF (IX.EQ.1) OCHI = 0.0
	IF (IX.EQ.MCYCLE) IFINISH = 1
      JK = 0
      DO 1 I=1,MAXS
        VX(I)=0.
        DO 1 J=1,MAXS
        RJAC2(I,J) = 0.0
        JK = JK + 1
   1  RJAC(JK)=0.0
      ISBAIL = .FALSE.
      DO 2 JDS=1,NDS
         ICTOT = 0
         DO K=1,NPHASE
           ICTOT = ICTOT + IC(JDS,K)                                              !ICTOT = TOTAL NUMBER OF REFLECTION IN JDS
         ENDDO
         FIRSTABS(JDS) = 0
         DO 2 I=1,ICTOT
            LEBAIL = IPTYPE(IREFS(JDS,I)/256/256/256/4).EQ.1
            IF (LEBAIL) THEN
               ISBAIL = .TRUE.
			 IF (IX.EQ.1) THEN                                                  !first cycle
                  IF ((IDSBB.EQ.0).OR.FF(JDS,I).LE.0.0) FF(JDS,I)=1.0
                  IF ((IDSBB.EQ.1).AND.(COBS(JDS,I).GT.0.0)) FF(JDS,I) = 
     &							COBS(JDS,I)
               ELSE
                  IF (SOMEGA(JDS,I).NE.0) THEN									!next cycles
                     FF(JDS,I) = COBS(JDS,I)/SOMEGA(JDS,I)
                  ELSE
                     FF(JDS,I) = 0.0
                  ENDIF
               ENDIF
            ENDIF
            COBS(JDS,I)=0.0
            VAR(JDS,I)=0.0
    2 SOMEGA(JDS,I)=0.0                      
c      write(*,*) FF(1,1)
C         RECALCULATE BACKGROUND    
      DO 30 JDS=1,NDS
          JTYPE = 0
          TOF = ISTOF(JOBTYP(JDS))
          IF(NBCKGD(JDS).GT.0)GOTO 30
          DO 31 I=1,NPTS(JDS)
              TH=THMIN(JDS)+(I-1)*STEP(JDS)
              IF(KR(JDS,I).EQ.IRS) GO TO 31
              BK(JDS,I) = BACKFN(JDS,NBCKGD(JDS),TOF,TH,IBCK,ERROR)
              IF (ERROR.NE.0) RETURN
   31     CONTINUE
   30 CONTINUE
C
      TOTALPTS = 0
      CALC = ISCALC(JOBTYP(1))
      DO 1000 JDS=1,NDS
          TOTALPTS = TOTALPTS + NPTS(JDS)
 1000     CALC=CALC.AND.ISCALC(JOBTYP(JDS))								!RE WE DEALING ONLY WITH CALC'S ?
      INDEXPTS = 0
      DO 9 JDS=1,NDS                                                       !LOOP OVER NUMBER OF DATASETS
      NUM(JDS)=0
      IPREV=1
      FIRSTABS(JDS) = 1                                                   !RE-INITIALIZE THE ABSORPTION CALCULATION (SO IT IS
c         loop over all points in the pattern                             !CALCULATED ONLY ONCE PER HISTOGRAM PER CYCLE
      DO 9 IPM=1,NPTS(JDS)                                                
        INDEXPTS = INDEXPTS+1	
        PERCENT = (INDEXPTS*100)/TOTALPTS
        IF (MOD(IPM,50).EQ.0) THEN
          ERROR = IGETSYSTEM()
          IF (ERROR.EQ.99) EXIT
        ENDIF 
        IF(WT(JDS,IPM).LE.0.0.AND.CALC) GOTO 9            
        TH=THMIN(JDS)+(IPM-1)*STEP(JDS)
        IF(KR(JDS,IPM).EQ.IRS) GOTO 9                                     !KR IS A PACKED LIST (ONLY START
        IF(KR(JDS,IPM).EQ.0.AND.NBCKGD(JDS).NE.0) GOTO 9                  !AND FINISH) OF REFLECTION POINTERS
        IORD1=MOD(KR(JDS,IPM),IRS)                                        !(WHICH IN TURN CAN BE USED TO GET
        IORD2=MOD(KR(JDS,IPM)/IRS,IRS)                                    !HKL FROM IREF()) FOR A
   15   NUM(JDS)=NUM(JDS)+1                                               !PARTICULAR 2THETA VALUE
        IF(IPREV.GT.IORD2)GOTO 40

        DO 21 J=IPREV,IORD2
   21     CALL CALCUL(J,JDS,ERROR)                                        !calculates |F|^2 and d|F|^2/dparameter

   40   IPREV=MAX0(IPREV,IORD2+1)
        CALL SUMMAT(IPM,JDS,ERROR)
        IF (ERROR.NE.0) RETURN
    9 CONTINUE
c
      JK = 0                                                              !FINISH IF CALCULATION ONLY
      DO 50 I=1,MAXS
      DO 50 J=I,MAXS
         JK = JK + 1
         RJAC2(I,J)=RJAC(JK) 
   50    RJAC2(J,I)=RJAC(JK)
C
C         Loop over the number of distance restraints
      ZZ = 0.0
c	write(*,*)nres
      DO II=1,NRES
	    IPH=INT(ATOMATOM(II,1))
          IRL1=MLT(INT(ATOMATOM(II,1)))    
	    DO I=1,3
            GMAT(I,I)=PAR(IPH,I+5)
          ENDDO                                                                 !D*^2 = (transposeofX)*(GMAT)*X
          GMAT(1,2)=PAR(IPH,11)                                                 !GMAT = (a*^2        a*b*cosgam  a*c*cosbet)
          GMAT(1,3)=PAR(IPH,10)                                                 !       (a*b*cosgam     b*^2     b*c*cosalp)
          GMAT(2,1)=PAR(IPH,11)                                                 !       (a*c*cosbet  b*c*cosalp      c*^2  )
          GMAT(2,3)=PAR(IPH,9)                                                  
          GMAT(3,1)=PAR(IPH,10)
          GMAT(3,2)=PAR(IPH,9) 
	   BD =  BONDCALC(IPH, INT(ATOMATOM(II,2)),
     >     INT(ATOMATOM(II,3)),INT(ATOMATOM(II,6)),INT(ATOMATOM(II,7)),
     >     DXYZ)
C       write(*,*) dxyz, ATOMATOM(ii,2),ATOMATOM(ii,3),ATOMATOM(II,6),
C     >                  ATOMATOM(II,7)
	   BDD = (ATOMATOM(II,4)-BD)/ATOMATOM(II,5)**2
c       WRITE(*,*) BD, ATOMATOM(II,4),ATOMATOM(II,5)
       ZZ = ZZ + 10000.0*( (ATOMATOM(II,4)-BD)/ATOMATOM(II,5) )**2
	   DO I = 1,MAXS
	     DER1 = 0.0
	     IF (LP(ATOMATOM(II,2),1).EQ.I) THEN
	             DER1 = DER1 + GMAT(1,1)*DXYZ(1) + GMAT(1,2)*DXYZ(2) + 
     >              GMAT(1,3)*DXYZ(3)
	       ENDIF
	     IF (LP(ATOMATOM(II,2),2).EQ.I) THEN
	             DER1 = DER1 + GMAT(2,1)*DXYZ(1) + GMAT(2,2)*DXYZ(2) + 
     >              GMAT(2,3)*DXYZ(3)
	       ENDIF
	     IF (LP(ATOMATOM(II,2),3).EQ.I) THEN
	             DER1 = DER1 + GMAT(3,1)*DXYZ(1) + GMAT(3,2)*DXYZ(2) + 
     >              GMAT(3,3)*DXYZ(3)
	       ENDIF
	     IF (LP(ATOMATOM(II,3),1).EQ.I) THEN
	             DER1 = DER1 - GMAT(1,1)*DXYZ(1) - GMAT(1,2)*DXYZ(2) - 
     >              GMAT(1,3)*DXYZ(3)
	       ENDIF
	     IF (LP(ATOMATOM(II,3),2).EQ.I) THEN
	             DER1 = DER1 - GMAT(2,1)*DXYZ(1) - GMAT(2,2)*DXYZ(2) - 
     >              GMAT(2,3)*DXYZ(3)
	       ENDIF
	     IF (LP(ATOMATOM(II,3),3).EQ.I) THEN
	             DER1 = DER1 - GMAT(3,1)*DXYZ(1) - GMAT(3,2)*DXYZ(2) - 
     >              GMAT(3,3)*DXYZ(3)
	     ENDIF
           DO J = 1,MAXS
	       DER2 = 0.0
	       IF (LP(ATOMATOM(II,2),1).EQ.J) THEN
	             DER2 = DER2 + GMAT(1,1)*DXYZ(1) + GMAT(1,2)*DXYZ(2) + 
     >              GMAT(1,3)*DXYZ(3)
	       ENDIF
	       IF (LP(ATOMATOM(II,2),2).EQ.J) THEN
	             DER2 = DER2 + GMAT(2,1)*DXYZ(1) + GMAT(2,2)*DXYZ(2) + 
     >              GMAT(2,3)*DXYZ(3)
	       ENDIF
	       IF (LP(ATOMATOM(II,2),3).EQ.J) THEN
	             DER2 = DER2 + GMAT(3,1)*DXYZ(1) + GMAT(3,2)*DXYZ(2) + 
     >              GMAT(3,3)*DXYZ(3)
	       ENDIF
	       IF (LP(ATOMATOM(II,3),1).EQ.J) THEN
	             DER2 = DER2 - GMAT(1,1)*DXYZ(1) - GMAT(1,2)*DXYZ(2) - 
     >              GMAT(1,3)*DXYZ(3)
	       ENDIF
	       IF (LP(ATOMATOM(II,3),2).EQ.J) THEN
	             DER2 = DER2 - GMAT(2,1)*DXYZ(1) - GMAT(2,2)*DXYZ(2) - 
     >              GMAT(2,3)*DXYZ(3)
	       ENDIF
	       IF (LP(ATOMATOM(II,3),3).EQ.J) THEN
	             DER2 = DER2 - GMAT(3,1)*DXYZ(1) - GMAT(3,2)*DXYZ(2) - 
     >              GMAT(3,3)*DXYZ(3)
	       ENDIF
           BW = 10000.0/ATOMATOM(II,5)**2
           RJAC2(I,J) = RJAC2(I,J) + BW*DER1*DER2/(BD*BD)
c           IF (I.NE.J) RJAC2(J,I) = RJAC2(J,I) + BW*DER1*DER2/BD/BD
           ENDDO
           VX(I) = VX(I) + 10000.0*BDD*DER1/BD
           IF ((DER1.NE.0).AND.(DER2.NE.0)) then
c		  WRITE(*,*) 'der1,2 =',DER1,DER2
	 write(7,*) VX(I),BW*DER1*DER2/(BD*BD),10000.0*BDD*DER1/BD
	 endif
	   ENDDO
      ENDDO
      WRITE(7,*) 'CHI SQ = ',ZZ
C
      IF (CALC) THEN
        IFINISH = 1
        RETURN
      ENDIF
C			   Marquardt Algorithm
c      write(*,*) Vmarqt
      IF (((IMARQT.EQ.1).OR.(IMARQT.EQ.2)).AND.(VMARQT.GT.0.0)) THEN
        DO I=1,MAXS
           RJAC2(I,I) = RJAC2(I,I)*(1+VMARQT)
	  ENDDO
	ENDIF
C
      COND=DPINV(RJAC2(1,1),VX(1),MAXS)
      JK = 0
C      DO 501 I=1,MAXS
C      DO 501 J=I,MAXS
C         JK = JK + 1 
C  501    RJAC(JK)=RJAC2(I,J)
      CALL CHISQ(NDS,IRS)
      SSUM = 0.0
      NSUM = 0
      DO 550 I=1,NDS
          SSUM = SSUM + S2(I)*WEIDS(I)                                    !ADDED WEIDS TO ALLOW DIFFERENT
          NSUM = NSUM + NUM(I)                                            !WEIGHTINGS TO EACH DATASET
  550 CONTINUE
      OOM=(SSUM+ZZ)/FLOAT(NSUM-MAXS)                                           !OOM = GOODNESS OF FIT(CHI^2)
c	  SET NEW MARQUARDT PARAMETER IF REQUIRED
      IF ((IMARQT.EQ.2).AND.(IX.GT.1)) THEN
        IF (OOM.GT.OCHI) VMARQT = VMARQT*50.0
        IF (OOM.LE.OCHI) VMARQT = VMARQT*0.2
        IF (VMARQT.GT.100) VMARQT = 100.0
        IF (VMARQT.LE.0.00001) THEN
	     VMARQT = 0.0														!set Marq to Newton
           IMARQT = 0															!if small value reached
        ENDIF
	ENDIF
      OCHI = OOM
C
      DO 55 I=1,MAXS
      DO 55 J=1,MAXS
   55   RJAC2(I,J)=RJAC2(I,J)*OOM                                           !RJAC NOW = SIGMA(M)^2 (PAGE 4)
C CODE TO ATTEMPT TO STABILIZE OSCILLATIONS                                 !(SIGMAS OF PARS NOT DATA)
      DO 60 I=1,MAXS
      IF(SIGN(1.,VX(I)).EQ.SIGN(1.,VLAST(I)))GOTO 60                      !NO SIGN CHANGE
      IF(ABS(VX(I)).GT.1.2*ABS(VLAST(I)))GOTO 60                          !MUST CHANGE +-20%
      IF(ABS(VX(I)).LT.0.8*ABS(VLAST(I)))GOTO 60             
      VX(I)=VX(I)/2.
   60 VLAST(I)=VX(I)
      CALL OUTPTR(IX,NDS)
      DO 5 I=1,MAXS                                                       !CONVERGENCE TEST
        X1=SQRT(ABS(RJAC2(I,I)))*EPS                                       !ARE THE PARS SIGMAS*EPS LESS
        IF(ABS(VX(I)).GT.X1)GOTO 10                                       !THAN THE SHIFTS
   5  CONTINUE
      IF (ISBAIL) GOTO 10													!FOR LEBAIL NO CONVERGENCE ALLOWED
  20  IFINISH = 1
  10  CONTINUE                                                            !END LOOP OVER NUMBER OF CYCLES 
C      GOTO 20
C  10  CONTINUE                                                            !END LOOP OVER NUMBER OF CYCLES 
C   20 RETURN
      END
c                    
c
c**********************************************************************************
c
      SUBROUTINE CALCUL(NN,NDS,ERROR)
      include 'param.inc'    
      REAL LAMDA,PIT,PADJ,KAP,CFACTOR,PICON                                                          
      REAL ANN,AHKL(3),TRANS,ABT,DABT,ALT,DALT,ABSVAL 
      REAL X,DX,TORSIN,XN,BFACT,BCON
      INTEGER PTR,NDS,JG,JP,ERROR
      INTEGER, Pointer::  IREFS(:,:),IC(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,IC
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SBX,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      CHARACTER SYMB(NUPH,20)*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      CHARACTER*4 NAM(MAXDS,MAXFF)
      COMMON/COEFC/NAM
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      COMMON/G4/TANN(NIPOI),DERSTO(NIPOI,MSZ)
      REAL,POINTER:: PHASE(:)
      COMMON/FOUR/PHASE
csjk
      COMMON/FFREJECT/ REJECT,RFLAG,realj,realint
      COMMON/FORMF/ADFP(MAXDS,MAXFF,2),LDFP(MAXDS,MAXFF,2)
      COMMON/ABSCALC/ABT,DABT,ALT,DALT,ABSVAL,FIRSTABS(MAXDS)
      COMMON/MAGN/MAGOPT(NATS,2)
      DIMENSION HNN(3),XI(14)
      DIMENSION DERIV(MSZ),SNX(NATS),SINTL(NIPOI),SA(NATS),SB(NATS)
      DIMENSION TEMP(NATS),SNEX(NATS),T(3),SUMAX(NATS,9),SUMBX(NATS,9)
      DIMENSION H(3),AL(3,3),SM(3,3),PHKL(3)               
      LOGICAL PAC,IXNP,TOF,ISMAG,LEBAIL
      LOGICAL ISTOF,ISXRAY
C
      ERROR = 0
      PICON=360./3.14159265359                                            !PICON = 2 * 180/PI
      RAD=3.14159265359/360.0                                             
      JP = (NDS-1)*MAXIPAR                                                !PARAMETER INDEXER
      JG = (NDS-1)*MAXIGL                                                 !GLOBAL PARAMETER INDEXER
      IXNP=ISXRAY(JOBTYP(NDS))                                            !TRUE WHEN XRAYS
      TOF =ISTOF(JOBTYP(NDS))                                             !TRUE WHEN TOF
      IPH=IREFS(NDS,NN)/256/256/256/4                                     !IPH = PHASE NUMBER
      LEBAIL = IPTYPE(IPH).EQ.1                                           !TRUE WHEN LEBAIL
      IOF=0
      IF(IPH.GT.1) THEN
        DO 101 KK=1,IPH-1
  101     IOF=IOF+ABS(NATOM(KK))                                          !IOF = PHASE OFFSET
      ENDIF
      IRL=MLT(IPH)                                                        !SPACE GROUP MULTIPLICITY OF PHASE
      N=ABS(NATOM(IPH))                                                   !NUM ATOMS IN PHASE
      ISMAG = NATOM(IPH).LT.0
      ICENT=ICET(IPH)                                                     !ICENT = 1 FOR CENTRO, OTHERWISE NON-CENTRO
C-----ZEROIZE THE DERIVATIVES OF THIS REFLECTION W.R.T. TO PARAMETERS    
      NX=0
      DO 100 I=1,NPHASE
  100   NX=NX+ABS(NATOM(I))
      DO 12 I=1,MSZ                                                       !CAN BE MAXS, BUT WHAT THE HECK
   12   DERIV(I)=0.0
      DO 21 I=1,NX                                                        !NX = TOTAL NUMBER OF ATOMS
      DO 21 J=1,9
        SUMBX(I,J)=0.0
   21   SUMAX(I,J)=0.0
      CV=0.0          
      DV=0.0
      AV=0.0
      BV=0.0
      PAC=PAR(IPH,12+JP).NE.0.0.OR.LPAR(IPH,12+JP).LE.MAXS                !DO WE HAVE PREFERRED ORIENTATION?
      DO 303 I=1,3
 303    AL(I,I)=PAR(IPH,I+5)                                              !a,b,c,alpha..., AL = RECIPOCAL^2
      AL(1,2)=PAR(IPH,11)                                                 !AL = (a*^2  a*b*cosgam* a*c*cosbet*)
      AL(1,3)=PAR(IPH,10)                                                 !     (0        b*^2     b*c*cosalp*)
      AL(2,1)=0.0                                                         !     (0          0           c*^2  )
      AL(2,3)=PAR(IPH,9)                                                  
      AL(3,1)=0.0
      AL(3,2)=0.0
      AH=PAR(IPH,3+JP)                                                     !U
      BH=PAR(IPH,4+JP)                                                     !V
      CH=PAR(IPH,5+JP)                                                     !W
      AHH=PAR(IPH,19+JP)                                                   !ANISOTROPIC U VALUE
      B1=PAR(IPH,12+JP)                                                    !PREFFERED
      ABSPAR=PAR(IPH,13+JP)                                                !ABSORPTION (R VALUE)
      ABSVAL = TMV(NDS)*2.0*ABSPAR                                         !ABSORPTION VALUE*2 = 2*MU*R
      UU1=PAR(IPH,15+JP)                                                   !GAMMA-0
      VV1=PAR(IPH,16+JP)                                                   !GAMMA-1
      WW1=PAR(IPH,17+JP)                                                   !GAMMA-2
      EXTPAR=PAR(IPH,18+JP)                                                !EXTINCTION
      NM=MOD(NN,NIPOI)+1
C                                                                      
      ICX=MOD(IREFS(NDS,NN)/256/256/256,4)                                 !ICX = LAMBDA NUMBER
      IF (TOF) ICX = 1                                                     !IF TOF LETS ONLY HAVE 1 LAMBDA
      IF (.NOT.LEBAIL) FF(NDS,NN)=0.                                       !STRUCTURE FACTOR^2 = 0.0
      PAKNN=0.
      PRECOR=1.0
      EXTCOR=1.0
      TR=0.0
c
      BFACT = 1.0                                                                                 !normal b's
c      IF (ITHER.EQ.1) BFACT =  78.95683520871                                 !  8*PI*PI          !<u>'s
c
      BCON= 19.73920880218                                                    !  2*PI*PI
      HNN(3)=MOD(IREFS(NDS,NN),256)-128                                       !L
      HNN(2)=MOD(IREFS(NDS,NN)/256,256)-128                                   !K
      HNN(1)=MOD(IREFS(NDS,NN)/256/256,256)-128                               !H
      DO 1 I=1,3
    1   H(I)=HNN(I)                                                           !H = (h,k,l)
C-----CALCULATION OF TEMP.FACTOR,POSITION AND HALFWIDTH
      SS=0.
      DO 2 I=1,3
      DO 2 J=I,3
    2   SS=AL(I,J)*HNN(I)*HNN(J)+SS                                       !SS= (h/a)^2 ..+ (l/c)^2 + 
   13 SINTL(NM)=SQRT(SS)                                                  !SS = Q^2/(4pi^2) where d=1/(2*PI*Q)         
      SSNN=0.25*SS                                                        
C
c         Calculate Position of hkl (2theta or TOF/d values)
c     
      IF (.NOT.TOF) THEN
          SLABDA=LAMDA(NDS,ICX)*LAMDA(NDS,ICX)/4.
          SINTH=SLABDA*SS                                                 !sinth = sin(theta)^2 = (lamda^2/4)*Q where Q = 1/d^2
          COSTH=1.0 - SINTH
          TANTH=SQRT(SINTH/COSTH)                                         !tan(theta)
          TANN(NM)=TANTH
          PIT = ATAN(TANTH)*PICON                                         !POSITION (2theta), where PICON = 2 * 180/pi
          PADJ = PEAKSHFT(ABSPAR,TMV(NDS),PIT*0.5)						!absorption adjustment
          REFS(NDS,NN,2) = PIT+PADJ                                       !add all shifts
      ELSE
          TANTH = 1/SINTL(NM)
          TANN(NM)=TVAL(1/SINTL(NM),LAMDA(NDS,1),LAMDA(NDS,2),GLB(1+JG))  !HAVE TANN AS TOF VALUE
          REFS(NDS,NN,2) = TANTH                                          !BUT KEEP REFS(2) AND TANTH AS d
      ENDIF
c
c         Overall Thermal Value
c
      TAV=EXP(-2.*PAR(IPH,2)*BFACT*SSNN)                                   !TAV = | exp( -Biso * sin(th)^2/lam^2) |^2
C                                                                          !TAV = exp( -2 * Biso * sin(th)^2/lam^2)
C         Preferred Orientation Correction
C                         
      IF(PAC) THEN                
          DO 16 I=1,3
   16         PHKL(I) = PREF(NDS,IPH,I) 
          CALL PREFOR(IPREF,IPH,B1,HNN,PHKL,PRECOR,DPRECOR)
      ENDIF
C
C         Calculate the Peak Shape values
C     
      IF (IAP(NDS).EQ.1) THEN
          DO 1000 I=1,3
 1000         AHKL(I) = ANHKL(NDS,IPH,I)
         ANN = ANGLE(IPH,HNN,AHKL)                                        
      ELSE
         ANN = 0.0
      ENDIF
      REFS(NDS,NN,1) = GAUSPEAK(NPROF(NDS),TANTH,AH,BH,CH,AHH,ANN)
      REFS(NDS,NN,4) = GAMMPEAK(NPROF(NDS),TANTH,UU1,VV1,WW1,ANN)
      TL = REFS(NDS,NN,1)
C
      AV = 0.0
      BV = 0.0
      CV = 0.0
      DV = 0.0
      IF (LEBAIL) GOTO 81
C-----CALCULATION OF COS(H.X),SIN(H.X) AND TEMP. FACTOR FOR EACH ATOM
    3 DO 8 I=1,N                                                          !N= NUM OF ATOMS IN PHASE
      SNXI=0.0
      SAI=0.0
      SBI=0.0
      DO 9 J=1,11
    9    XI(J)=XL(I+IOF,J)                                                   !XI,XL=X,Y,Z,B,N,B11,B22...
      IF (MAGOPT(I+IOF,2).EQ.1) THEN
          IRL = 1
      ELSE
          IRL=MLT(IPH)                                                    
      ENDIF
      DO 10 IR=1,IRL                                                      !IRL= NUMBER OF SPACE GROUP OPERATIONS
      DO 301 J=1,3
        IV=IVEC(IPH,IR)/32768/32**(3-J)
        IV=MOD(IV,32)
        SM(J,1)=IV/9-1                                                    !SM = symmetry matrix
        SM(J,2)=MOD(IV/3,3)-1
        SM(J,3)=MOD(IV,3)-1
  301   T(J)=FLOAT(MOD(IVEC(IPH,IR)/32**(3-J),32)-16)/12.0                !T = translation vector
      X=0.
      DO 6 II=1,3
        YY=0.
        X=T(II)*HNN(II)+X
        DO 7 J=1,3
    7     YY=SM(J,II)*HNN(J)+YY
    6   H(II)=YY                                                          !H = SM*HKL (VECTOR),    X = T*HKL (SCALAR)
      TR=X
      ARG=TR
      DO 11 J=1,3
   11   ARG=H(J)*XI(J)+ARG                                                !ARG = 2*PI*( HKL.XYZ )   (EQ 3, ==> 2*PI*h.r)
      ARG=6.28318530718*ARG                                 
c      IF (ITHER.EQ.1) THEN                                                !for <u>'s
c          ARG2=H(1)*H(1)*XI(6)*AL(1,1)+
c     *         H(2)*H(2)*XI(7)*AL(2,2)+
c     *         H(3)*H(3)*XI(8)*AL(3,3)+
c     *       2*H(1)*H(2)*XI(9)*SQRT(AL(1,1)*AL(2,2))+
c     *       2*H(1)*H(3)*XI(10)*SQRT(AL(1,1)*AL(3,3))+
c     *       2*H(2)*H(3)*XI(11)*SQRT(AL(2,2)*AL(3,3))                      !ARG2 =   RECIP^T <U> RECIP
c          ARG2=ARG2*BCON
c      ELSE
          ARG2=H(1)*H(1)*XI(6)+H(2)*H(2)*XI(7)+                               !ANISOTHERMAL CONTRIBUTION; h^2*beta11 + ..
     1         H(3)*H(3)*XI(8)+2.*H(1)*H(2)*XI(9)+2.*                          !   ..+ 2*k*l*beta23
     2         H(1)*H(3)*XI(10)+2.*H(2)*H(3)*XI(11)
c      ENDIF                                                                   !ARG2 = h^T Beta h
c
c
      EXPARG=EXP(-ARG2)                                                   !EXPARG*EXP(ARG)=exp(2*pi*(h.r - h.B.h)) in eq 3)
      COSA=COS(ARG)*EXPARG                                                    !real part of " ==> usual A(hkl)
      SINA=SIN(ARG)*EXPARG                                                    !imag part of " ==> usual B(hkl)
      SAI=SAI+COSA
      IF(ICENT.EQ.1)SBI=SINA+SBI                                          !FOR NON-CENTROSYMMETRIC SPG
      DO 14 JJ=1,3
          SUMAX(I,JJ)=SUMAX(I,JJ)+H(JJ)*SINA                              !I=CURRENT ATOM NUMBER
  14      IF(ICENT.EQ.1)SUMBX(I,JJ)=SUMBX(I,JJ)+H(JJ)*COSA                !sumax = hkl.A(hkl) (JJ=1..3 = x,y,z derviv)  
c      IF (ITHER.EQ.1) THEN
c         SUMAX(I,4)=SUMAX(I,4)+H(1)*H(1)*AL(1,1)*COSA*BCON
c         SUMAX(I,5)=SUMAX(I,5)+H(2)*H(2)*AL(2,2)*COSA*BCON                !sumax needed for deriv calculation of Beta's
c         SUMAX(I,6)=SUMAX(I,6)+H(3)*H(3)*AL(3,3)*COSA*BCON
c         SUMAX(I,7)=SUMAX(I,7)+H(1)*H(2)*SQRT(AL(1,1)*AL(2,2))*COSA*BCON
c         SUMAX(I,8)=SUMAX(I,8)+H(1)*H(3)*SQRT(AL(1,1)*AL(3,3))*COSA*BCON
c         SUMAX(I,9)=SUMAX(I,9)+H(2)*H(3)*SQRT(AL(2,2)*AL(3,3))*COSA*BCON
c      ELSE
         SUMAX(I,4)=SUMAX(I,4)+H(1)*H(1)*COSA
         SUMAX(I,5)=SUMAX(I,5)+H(2)*H(2)*COSA                             !sumax needed for deriv calculation of Beta's
         SUMAX(I,6)=SUMAX(I,6)+H(3)*H(3)*COSA
         SUMAX(I,7)=SUMAX(I,7)+H(1)*H(2)*COSA
         SUMAX(I,8)=SUMAX(I,8)+H(1)*H(3)*COSA
         SUMAX(I,9)=SUMAX(I,9)+H(2)*H(3)*COSA
c      ENDIF
      IF(ICENT.NE.1)GOTO 10
c      IF (ITHER.EQ.1) THEN
c         SUMBX(I,4)=SUMBX(I,4)+H(1)*H(1)*AL(1,1)*SINA*BCON
c         SUMBX(I,5)=SUMBX(I,5)+H(2)*H(2)*AL(2,2)*SINA*BCON
c         SUMBX(I,6)=SUMBX(I,6)+H(3)*H(3)*AL(3,3)*SINA*BCON
c         SUMBX(I,7)=SUMBX(I,7)+H(1)*H(2)*SQRT(AL(1,1)*AL(2,2))*SINA*BCON
c         SUMBX(I,8)=SUMBX(I,8)+H(1)*H(3)*SQRT(AL(1,1)*AL(3,3))*SINA*BCON
c         SUMBX(I,9)=SUMBX(I,9)+H(2)*H(3)*SQRT(AL(2,2)*AL(3,3))*SINA*BCON
c      ELSE
         SUMBX(I,4)=SUMBX(I,4)+H(1)*H(1)*SINA
         SUMBX(I,5)=SUMBX(I,5)+H(2)*H(2)*SINA
         SUMBX(I,6)=SUMBX(I,6)+H(3)*H(3)*SINA
         SUMBX(I,7)=SUMBX(I,7)+H(1)*H(2)*SINA
         SUMBX(I,8)=SUMBX(I,8)+H(1)*H(3)*SINA
         SUMBX(I,9)=SUMBX(I,9)+H(2)*H(3)*SINA
c      ENDIF
   10 CONTINUE                                                            !NOTE: BFACT USED WHEN DEALING WITH <U2> OR B'S
      TEMP(I)=EXP(-BFACT*XL(I+IOF,4)*SSNN)                                !TEMP(I) = TEMPERATURE FACTOR FOR ATOM I
      SA(I)=SAI                                                           !SA(I) = REAL[EXP(2*PI*I*(h.R - h.B.h))] = Real[Expon]
      SB(I)=SBI                                                           !SB(I) = IMAG[EXP(2*PI*I*(h.R - h.B.h))] = Imag[Expon]
      NI=PTR(NDS,I+IOF)
C
      IF (IXNP) THEN                                                      !X-RAY FORM FACTOR
          FFX=DFP(NDS,NI,1)
          BNI=DFPP(NDS,NI)                         
          IF (AC(NDS,3,NI).NE.0) THEN
              DO 302 II=1,9,2
 302              FFX=FFX+AC(NDS,II,NI)*EXP(-AC(NDS,II+1,NI)*SSNN)
          ELSE
              KAP = SIN(REFS(NDS,NN,2)*RAD)/LAMDA(NDS,1)
              FFX = FFINT(KAP,INT(AC(NDS,4,NI)))                          !INTERPOLATE
          ENDIF
      ELSE
          IF (ISMAG) THEN
              KAP = SIN(REFS(NDS,NN,2)*RAD)/LAMDA(NDS,1)
              FXX = FFMAG(KAP,NI)                                         !MAGNETIC
          ELSE
              FFX=DFP(NDS,NI,2)                                               !NEUTRON FORM FACTOR
              BNI=0.0                                                         !FFX = form factor f
          ENDIF
      ENDIF
      SNEXI=FFX*XL(I+IOF,5)*TEMP(I)                                       !Real[f] * n * tempfactor[of atom i]
      SNXI=BNI*XL(I+IOF,5)*TEMP(I)                                        !Imag[f] * n * tempfactor[of atom i]
C-----CALCULATE A AND B OF F
      AV=AV+SNEXI*SAI                                                     !AV = Sum[Real[f] * n * tempfactor * Real[Exp(2*PI*I*(h.R - h.B.h)]]
      BV=BV+SNEXI*SBI                                                     !BV = Sum[Real[f] * n * tempfactor * Imag[Exp(2*PI*I*(h.R - h.B.h)]]
      CV=CV+SNXI*SAI                                                      !CV = Sum[Imag[f] * n * tempfactor * Real[Exp(2*PI*I*(h.R - h.B.h)]]
      DV=DV+SNXI*SBI                                                      !DV = Sum[Imag[f] * n * tempfactor * Imag[Exp(2*PI*I*(h.R - h.B.h)]]                      
      SNEX(I)=2.*SNEXI                                                    !SNEX = 2*Real[f] * n * tempfactor[atom i]
      SNX(I)=2.*SNXI                                                      !SNX =  2*Imag[f] * n * tempfactor[atom i]
    8 CONTINUE                                                            !sum over atoms
   81 CONTINUE
C
C  |FF|^2 = (FF * Conj[FF]) = (Real[f]^2 + Imag[f]^2)(Real[Expon]^2 + Imag[Expon]^2)
c         = (Real[f]*Real[Expon])^2 + (Real[f]*Imag[Expon])^2 + (Imag[f]*Real[Expon])^2 + (Imag[f]*Imag[Expon])^2
c         = AV^2                    + BV^2                    + CV^2                    + DV^2
      IF (LEBAIL) THEN
         FSQ= FF(NDS,NN)                                                  !USE THE OLD ONE FOR LE BAIL
      ELSE
         FSQ= CV*CV+AV*AV+DV*DV+BV*BV                                     !USE THE CALCULATION FOR ORDINARY REFINEMENT   
      ENDIF
C
C         EXTINCTION CORRECTION                 
C
      IF (.NOT.TOF) THEN
          EXTCOR = EXTCW(EXTPAR,LAMDA(NDS,ICX),FSQ*TAV,SINTH)
      ELSE
          EXTCOR=EXTTOF(EXTPAR,TANTH,FSQ*TAV*MULT(IFIX(HNN(1)),
     *           IFIX(HNN(2)),IFIX(HNN(3))))
      ENDIF
c
c         Absorption corrections
c
      IF(IABSCOR(NDS).EQ.1) THEN                         
          TRANS = FPLATE(PAR(IPH,13+JP),PAR(IPH,25+JP),PAR(IPH,26+JP),
     *            REFS(NDS,NN,2))
      ELSE
      IF ((FIRSTABS(NDS).EQ.1).AND.(ABSVAL.NE.0)) THEN                    !CALCULATE ONLY IF THIS IS THE FIRST TIME/CYCLE/HIST
          IF (ABSPAR.LT.0) THEN
              IF (ABSMIN.GT.0) ABSPAR = ABSMIN
              PAR(IPH,13+JP) = ABSPAR
              ABSVAL = 2.0*TMV(NDS)*ABSPAR
              WRITE(7,*)' *** WARNING-ABSORPTION R < 0.0-ATTEMPING FIX'   !DEADMANS WALL - IF ABSOR R < 0.0
          ENDIF                                                           !MAKE SURE ITS FORCED SLIGHTLY POSITIVE (ONLY IF ABSMIN > 0)
          IF (.NOT.TOF) THEN
              CALL ABSCAT(ABSVAL, ABT,DABT)
              CALL ALSCAT(ABSVAL, ALT,DALT)
          ENDIF
          FIRSTABS(NDS) = 0
      ENDIF
      IF (ABSVAL.NE.0) THEN 
          IF (TOF) THEN
              TRANS = TOFABS(ABSVAL,TANTH*0.5)                                !NEED 0.5 BECAUSE WE MULTIPLIED BY 2 PREVIOUSLY
          ELSE
              TRANS = ABT*SINTH + ALT*COSTH                                   !CALCULATE ABSORPTION
          ENDIF
      ELSE
          TRANS = 1.0             
          DABT = 0.
          DALT = 0.
      ENDIF
      ENDIF
      CFACTOR = TAV*RATIO(NDS,ICX)*PRECOR*EXTCOR*TRANS                        !ALL 'CORRECTION' FACTORS
      FNN = FSQ*CFACTOR
C
  120 FF(NDS,NN)=FNN                                                      !FF = F^2 * ABSOR * EXT * Pref(RE: EQ 3 IN MANUAL)
      PHASE(NN)=1.57079633                                                !PI/2
      IF(AV.NE.0.0) PHASE(NN)=ATAN(BV/AV)                                 !
      IF(AV.LT.0.0) PHASE(NN)=PHASE(NN)+3.14159265                        !+PI
      IF(PHASE(NN).LT.0.0) PHASE(NN)=PHASE(NN)+6.28318530                 !+2PI
      IF(MAXS.EQ.0)RETURN
      IF(LEBAIL) PHASE(NN) = 0.0
      IF(LEBAIL) GOTO 82
CV            END CALCULATION OF F^2
c
csjk reject flag set to eliminate low intensity lines from cyclic calculations 
csjk of structure factors by ITER. (RFLAG = 1 for calls from REFGEN)
csjk multiply F^2 by j (multiplicity) and 1/sin(theta)sin(2theta) (Lorentz factor)
      if(rflag.eq.1) then    
      thetarad = RAD*REFS(NDS,NN,2) 
      aloren=1/(sin(thetarad)*sin(2*thetarad))
      realint = FNN*realj*aloren   
          if (realint.LT.FFLIM(NDS)) then 
          write (6,110)  IFIX(HNN(1)),ifix(HNN(2)),ifix(HNN(3))
	*              ,realint, FFLIM(NDS)
            REJECT=1
          else
            REJECT=0
          end if
          return
      end if
  110 format (' (h,k,l)=',3I3,' I= ',F8.5,' Imin= ',F8.5,' Reflecti',
     *'on Rejected') 
c
c         Start of Derivative Calculations
c
      DO 17 I=1,N                                                         !RUN OVER THE ATOMS
         NI=PTR(NDS,I+IOF)
         SNEXI=SNEX(I)                                                    !remember SNEXI = 2*Real[f] * n * tempfactor[atom i] * Ratio * OverThermal * Preferred
         SNXI=SNX(I)                                                      !remember SNXI =  2*Imag[f] * n * tempfactor[atom i] * Ratio * OverThermal * Preferred
         SAI=SA(I)                                                        !remember SA(I) = REAL[EXP(2*PI*I*(h.R - h.B.h))]
         SBI=SB(I)                                                        !remember SB(I) = IMAG[EXP(2*PI*I*(h.R - h.B.h))]
         DO 22 J=1,11                                                     !K=PARAMETER NUMBER
            K=LP(I+IOF,J)
            IF(K.EQ.0) GOTO 22
            IF(J.GT.5) GOTO 221                                           !J>5 = B11..B33
            IF(J.GT.3) GOTO 29                                            !J>3 = B & N
            SUMA=SUMAX(I,J)
            SUMB=SUMBX(I,J)
            DER=-((AV*SUMA-BV*SUMB)*SNEXI+(CV*SUMA-DV*SUMB)*SNXI)          !DERIV FOR X,Y,Z
     1           *6.28318530718
            GOTO 26
   29       IF(J.GT.4)GOTO 31
            DER=-((SAI*AV+SBI*BV)*SNEXI+(SAI*CV+SBI*DV)*SNXI)*SSNN*BFACT   !DERIV FOR B 
            GOTO 26
   31       XN = XL(I+IOF,5)
            IF (XN.EQ.0) XN = ASMALLNO                                     !THIS IS TO STOP IT CRASHING FOR N=0.0
            DER=((SAI*AV+SBI*BV)*SNEXI+(SAI*CV+SBI*DV)*SNXI)/XN           !DERIV FOR N
            GOTO 26
  221       SUMA=SUMAX(I,J-2)
            SUMB=SUMBX(I,J-2)
            DER=-((AV*SUMA+BV*SUMB)*SNEXI+(CV*SUMA+DV*SUMB)*SNXI)         !DERIV FOR B11..B33
            IF(J.GE.9)DER=2.*DER                                          !*2 FOR B12,B13,B23
   26       DERIV(K)=A(I+IOF,J)*DER*CFACTOR + DERIV(K)                    !DERIV = SUM OF SHIFTS*DERIV
   22    CONTINUE
         K=LDFP(NDS,NI,1)                                                !DERIV OF f'
         IF(K.NE.0)  DERIV(K) = DERIV(K) + 
     *        CFACTOR*ADFP(NDS,NI,1)*SNEXI*(SAI*AV + SBI*BV)/FFX
         K=LDFP(NDS,NI,2)                                                !DERIV OF f''
         IF(K.NE.0) DERIV(K) = DERIV(K) + 
     *        CFACTOR*ADFP(NDS,NI,2)*SNXI*(SAI*CV + SBI*DV)/BNI
   17 CONTINUE
C
c         Preferred Orientation Derivatives (already calculated when absorption value was calculated)
c
      K=LPAR(IPH,12+JP)
      IF (K.NE.0) DERIV(K)=DERIV(K)+APAR(IPH,12+JP)*DPRECOR*FNN/PRECOR                  
c
c         Extinction Derivatives
c
      K=LPAR(IPH,18+JP)
      IF(K.NE.0) THEN
      IF (.NOT.TOF) THEN                                                     
          DERIV(K) = DERIV(K) + APAR(IPH,18+JP)*FNN/EXTCOR*
     *            DEXTCW(EXTPAR,LAMDA(NDS,ICX),FSQ*TAV,SINTH)
      ELSE
          DERIV(K) = DERIV(K) + APAR(IPH,18+JP)*FNN/EXTCOR*                      
     *       DEXTTOF(EXTPAR,TANTH,FSQ*TAV*MULT(IFIX(HNN(1)),
     *               IFIX(HNN(2)),IFIX(HNN(3))))
      ENDIF
      ENDIF
C
C         Absorption Derivatives
C
      K=LPAR(IPH,13+JP)
      IF(K.NE.0) THEN
          IF (IABSCOR(NDS).EQ.1) THEN
              DERIV(K) = DERIV(K) + APAR(IPH,13+JP)*FNN/TRANS                     !flat sample absorption
          ELSE
              IF (TOF) THEN
                  DERIV(K) = DERIV(K)-APAR(IPH,13+JP)*FNN*TANTH*TMV(NDS)          !TOF
              ELSE                                                                    
                  DERIV(K) = DERIV(K) + APAR(IPH,13+JP)*FNN/TRANS*                !CW
     &                       (DABT*SINTH + DALT*COSTH)*TMV(NDS)*2.0
              ENDIF
          ENDIF
      ENDIF
      K = LPAR(IPH,25+JP)
      IF ((K.NE.0).AND.(IABSCOR(NDS).EQ.1)) THEN
          TORSIN = PAR(IPH,26+JP)/SIN(REFS(NDS,NN,2)/2)                        !FOR FLAT PLATE
          DERIV(K)=DERIV(K)+APAR(IPH,25+JP)*FNN*TORSIN*(1-TORSIN)/TRANS   
      ENDIF
      K = LPAR(IPH,26+JP)
      IF ((K.NE.0).AND.(IABSCOR(NDS).EQ.1)) THEN
          TORSIN = 1.0/SIN(REFS(NDS,NN,2)/2)                                   !FOR FLAT PLATE
          DERIV(K) = DERIV(K) + APAR(IPH,25+JP)*FNN*(PAR(IPH,25+JP)*
     *               TORSIN - 2.0*PAR(IPH,25+JP)*PAR(IPH,26+JP)*
     *               TORSIN*TORSIN)/TRANS   
      ENDIF
c                                                           
c         Scale Factor Derivative
c
      K=LPAR(IPH,1)
      IF(K.NE.0) THEN
         IF (PAR(IPH,1).EQ.0) PAR(IPH,1) = ASMALLNO
         DERIV(K)=DERIV(K) + APAR(IPH,1+JP)*FNN/PAR(IPH,1)
	ENDIF
C
c         Overall Thermal Derivative
c     
      K=LPAR(IPH,2)                                                  
      IF(K.NE.0) DERIV(K)=DERIV(K) - 2.*APAR(IPH,2+JP)*SSNN*FNN
c
c         Derivatives of Gamma values
c

   82 X=1.0
      DO 15 J=15,17
          K=LPAR(IPH,J+JP)
          IF(K.NE.0) THEN
          IF(NPROF(NDS).EQ.3.OR.NPROF(NDS).EQ.5) THEN
             IF (J.EQ.15) DERIV(K)=DERIV(K)+APAR(IPH,J+JP)*FNN
     *                                     *SQRT(1+TANTH*TANTH)              !DERIV OF VOIGT K,SEC(TH)
             IF (J.EQ.16) DERIV(K)=DERIV(K)+APAR(IPH,J+JP)*FNN
     *                                     *TANTH                            !DERIV OF VOIGT TAN(TH)
             IF (J.EQ.17) DERIV(K)=DERIV(K)+APAR(IPH,J+JP)*FNN
     *                                *ANN*SQRT(1+TANTH*TANTH)               !DERIV OF ANISO-VOIGT SEC(TH)
          ELSE           
              DERIV(K)=DERIV(K)+X*APAR(IPH,J+JP)*FNN                         !DERIV OF PSEUDO/PEAR SHAPE
              X=X*REFS(NDS,NN,2)
          ENDIF
          ENDIF
   15 CONTINUE
C     END CODE
C
c         Gaussian FWHM Derivatives
c
      SS=0.5*FNN/TL
      IF (.NOT.TOF) THEN
          X=TANTH*TANTH                                                   !FOR (U*TAN^2 + V*TAN + W)^0.5
          DX = 1/TANTH
      ELSE          
          X = 1.0                                                         !FOR (SIG0 + SIG1*D^2 + SIG2*D^4)^0.5
          DX = TANTH*TANTH 
      ENDIF
      DO 78 J=3,5
          K=LPAR(IPH,J+JP)                                                !eg dHW = 0.5*tan(th)^2/HW (and dF/dU = dF/dHW * dHW/dU)
          IF(K.NE.0) DERIV(K) = X*APAR(IPH,J+JP)*SS+DERIV(K)              !   dU
   78 X=X*DX
C
      K = LPAR(IPH,JP+19)
      IF(NPROF(NDS).EQ.7) THEN
          IF (K.NE.0) DERIV(K)=DERIV(K)+APAR(IPH,19+JP)*SS*                   !TOF ANISOTROPIC HW
     *                         TANTH*TANTH*ANN   
	ELSE
          IF (K.NE.0) DERIV(K)=DERIV(K)+APAR(IPH,19+JP)*SS*                   !CW ANISOTRPIC HW(same as TOF but
     *                         TANTH*TANTH*ANN                                !   be different one day)
      ENDIF
c
C         Derivatives of Alpha,Beta
C
      K = LPAR(IPH,21+JP)
      IF(K.NE.0) DERIV(K)=DERIV(K)+APAR(IPH,21+JP)*FNN                         !DERIV OF ALPHA-0
      K = LPAR(IPH,22+JP)
      IF(K.NE.0) THEN
          IF (TOF) THEN
              DERIV(K)=DERIV(K)+APAR(IPH,22+JP)*FNN/REFS(NDS,NN,2)             !DERIV OF ALPHA-1
          ELSE
              DERIV(K)=DERIV(K)+APAR(IPH,22+JP)*FNN*REFS(NDS,NN,2)             !DERIV OF ALPHA-1
          ENDIF
      ENDIF
      K = LPAR(IPH,23+JP)
      IF(K.NE.0) DERIV(K)=DERIV(K)+APAR(IPH,23+JP)*FNN                         !DERIV OF BETA-0
      K = LPAR(IPH,24+JP)
      IF(K.NE.0) THEN
          IF (TOF) THEN
              DERIV(K)=DERIV(K)+APAR(IPH,24+JP)*FNN/REFS(NDS,NN,2)**4          !DERIV OF BETA-1
          ELSE
              DERIV(K)=DERIV(K)+APAR(IPH,24+JP)*FNN*REFS(NDS,NN,2)             !DERIV OF BETA-1
          ENDIF
      ENDIF
C                         
c         Derivatives of Zero
c
      K=LGLB(1+JG)
      IF(K.NE.0) DERIV(K)= DERIV(K) + AGLB(1+JG)*FNN                          
c
c         Derivatives of Sample Displacement
c
      K=LGLB(17+JG)
      IF(K.NE.0) THEN
	  DERIV(K)=DERIV(K) + AGLB(17+JG)*FNN*
     *                      DERSDISP(REFS(NDS,NN,2)*RAD)						!DERIV OF SAMPLE DISPLACEMENT                          
      ENDIF
C                         
c         Derivatives of Histogram Scale
c
      K=LGLB(14+JG)
      IF(K.NE.0) THEN 
        IF (GLB(14+JG).EQ.0) GLB(14+JG) = ASMALLNO
        DERIV(K)=DERIV(K) + AGLB(14+JG)*FNN/GLB(14+JG)                       
      ENDIF
C                         
c         Derivatives of Lamda/DIFC
c
      K=LGLB(15+JG)
      IF (.NOT.TOF) THEN
         IF(K.NE.0) DERIV(K) = DERIV(K) + FNN*AGLB(15+JG)*PICON*
     *                                    TANTH/LAMDA(NDS,1)          
      ELSE                                                                        
         IF(K.NE.0) DERIV(K)=DERIV(K)-FNN*AGLB(15+JG)*REFS(NDS,NN,2)        
      ENDIF
C                         
c         Derivatives of DIFA
c
      K=LGLB(16+JG)                                                                  
      IF (TOF) THEN                                                               
          IF(K.NE.0) DERIV(K)=DERIV(K)-FNN*AGLB(16+JG)*REFS(NDS,NN,2)**2
      ENDIF
C                         
c         Derivatives of a,b,c,alpha,beta,gamma
c
      IF (.NOT.TOF) THEN
          SINTH=0.5*FNN*PICON*SLABDA/SQRT(SINTH*COSTH)
      ELSE          
          SINTH = 0.5*FNN*(LAMDA(NDS,1)+2*LAMDA(NDS,2)*REFS(NDS,NN,2))*
     *            REFS(NDS,NN,2)**3
      ENDIF
      DO 79 J=1,6
          K=LPAR(IPH,J+5)
          IF(K.EQ.0)GOTO 79
          IF(J.LT.4)X=HNN(J)*HNN(J)
          IF(J.EQ.4)X=HNN(2)*HNN(3)
          IF(J.EQ.5)X=HNN(1)*HNN(3)
          IF(J.EQ.6)X=HNN(1)*HNN(2)
          DERIV(K)=X*SINTH*APAR(IPH,J+5)+DERIV(K)                             
   79 CONTINUE                                                                
C                         
c         Derivatives of Asymmetry
c
      K=LPAR(IPH,14+JP)
      IF(K.NE.0) DERIV(K)=APAR(IPH,14+JP)*FNN+DERIV(K)                       
      K=LPAR(IPH,20+JP)
      IF(K.NE.0) DERIV(K)=APAR(IPH,20+JP)*FNN+DERIV(K)                       
C
C-----STORE DERIVATIVES FOR LIMO REFLECTIONS AT A TIME
      DO 80 I=1,MAXS
   80 DERSTO(NM,I)=DERIV(I)                                             
   48 RETURN
      END
c
c**********************************************************************************
c
      SUBROUTINE EXPUT(JDS,IDSZ,NDS,ERROR)
      include 'param.inc'
      REAL LAMDA,FCALC,THTEMP,YMV
      INTEGER PTR,JDS,NDS,JPG,LC,ERROR
      LOGICAL TOF,ISTOF,ISDATA,ISCALC,ISXRAY,LEBAIL
      DIMENSION YDIF(IDSZ)
      DIMENSION SM(3,3),T(3)               
      COMMON/F1/RJAC(MSZ2),VX(MSZ),OCHI
      COMMON/F3/RJAC2(MSZ,MSZ)
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      CHARACTER SYMB(NUPH,20)*1,ISPACE*1,IDOT*1,ISTAR*1,IPLUS*1,IMINUS*1
     *,IBAR*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80
      CHARACTER*1 IOUT(150)
      CHARACTER FNAME*250,FTEMP*250
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      CHARACTER*4 NAM(MAXDS,MAXFF)
      COMMON/COEFC/NAM
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      INTEGER, Pointer::  IREFS(:,:),IC(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,IC
      REAL, POINTER:: COBS(:,:),SOMEGA(:,:),VAR(:,:)
      COMMON/RBRAGG/COBS,SOMEGA,VAR
      REAL,POINTER:: PHASE(:)
      COMMON/FOUR/PHASE
      COMMON/FORMF/ADFP(MAXDS,MAXFF,2),LDFP(MAXDS,MAXFF,2)
      COMMON/FILEINT/LC,LT,FNAME,FTEMP
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      COMMON/F2/SIGCEL(NUPH,6),SIGATOM(NATS,3)
      COMMON/DC/SAVE(NUPH,6),NSAVE
	COMMON/MOREBR/THEBRA(NUPH,MAXDS)
      DIMENSION DEL(10),KI(10)
      DIMENSION LABEL(12),KS(50)
      DATA ISPACE,IDOT,ISTAR,IPLUS,IMINUS,IBAR/' ','.','*','+','0','-'/
C                
      ERROR = 0
      TOF = ISTOF(JOBTYP(JDS))
      ZER=GLB(1+(JDS-1)*MAXIGL)                      
      JP = (JDS-1)*MAXIPAR
C
c      IF(IPL.NE.0)READ(5,19,END=10000)ISCALE,IDIF
       IF(IPL.NE.0) ISCALE=1.0
       IF(IPL.NE.0) IDIF=1.0
   19 FORMAT(BZ,2I8)
   17 FORMAT(BZ,4I1,4X,F8.0)
C10000 IF(IPL2.NE.0)READ(5,17,END=10001)IFY,IFYC,IFM,IFD,EXPAND
10000 IF(IPL2.NE.0) THEN
        IFY = 1
        IFYC= 1
        IFM = 1
        IFD = 1
        EXPAND = 1
      ENDIF
10001 IF(ISCALC(JOBTYP(1)))   IFY=0
C     IFD SET TO 9 TO BYPASS PLOT OF DIFFERENCE PROFILE IN CALPLT
      IF(ISCALC(JOBTYP(1)))IFD=9
C
C         CODE FOR REFLECTIONS BEYOND OBS PATTERN
C     
      NLPTS = (AHIGH(JDS,NEXCRG(JDS))- ALOW(JDS,NEXCRG(JDS)))/STEP(JDS)
     &            +1.5
      THMAX(JDS)=ALOW(JDS,NEXCRG(JDS)-1) - STEP(JDS)
      THMIN(JDS)=AHIGH(JDS,NEXCRG(JDS)) + STEP(JDS)
      NPTS(JDS)=(THMAX(JDS)-THMIN(JDS))/STEP(JDS) + 1.5
      DO 1000 I=1,NPTS(JDS)
          Y(JDS,I) = Y(JDS,I+NLPTS)
          YC(JDS,I) = YC(JDS,I+NLPTS)
 1000     BK(JDS,I) = BK(JDS,I+NLPTS)
C
C
      IF(ISCALC(JOBTYP(JDS)))GOTO 370
      IF((MAT.EQ.0).OR.(JDS.GT.1)) GOTO 37
c
c		write out correlation matrix
      IF ((IMARQT.NE.0).AND.(VMARQT.NE.0)) THEN
	WRITE(6,*) 'WARNING:USING MARQUARDT-CORR.MATRIX MAY BE DISTORTED'
	ENDIF
	WRITE(6,7)
      IA=1
      LIM=19
   38 LIM=MIN0(MAXS,LIM)
      WRITE(6,8)(I,I=IA,LIM)
      DO 39 I=1,MAXS
          L=0
          X=RJAC2(I,I)
          DO J=IA,LIM
              L=L+1
            YY=RJAC2(J,J)*X
            IF (ABS(YY).LE.1e-32) YY=1e10
		  KS(L)=100.*RJAC2(I,J)/(SQRT(ABS(YY))*SIGN(1.,YY))+0.5
          ENDDO
   39     WRITE(6,12)I,(KS(J),J=1,L)
          IF(LIM.GE.MAXS)GOTO 37
          IA=LIM+1
          LIM=LIM+19
          GOTO 38
   37 CONTINUE
    7 FORMAT(' CORRELATION MATRIX=')
    8 FORMAT('     ',19I6)
   12 FORMAT(I5,19I6)
C
      WRITE(6,10)
   10 FORMAT(' AVERAGE INTENSITY DIFFERENCE FOR PATTERN,',/,
     1' GIVEN FOR BLOCKS OF 20 OBSERVATIONS.')
      DO 15 I=1,NPTS(JDS),200
      DO 14 J=1,10
      J20=20*(J-1)
      DEL(J)=0
      DO 13 K=1,20
      J20IK=J20+I+K-1                                                  
   13 DEL(J)=DEL(J)+Y(JDS,J20IK)-BK(JDS,J20IK)-YC(JDS,J20IK)
      KI(J)=J+I/20
      DEL(J)=DEL(J)/20.
      IF(DEL(J).GT.999.9) DEL(J)=999.9
      IF(DEL(J).LT.-99.9) DEL(J)=-99.9
      IF(KI(J)*20.GE.NPTS(JDS))GOTO 15
   14 CONTINUE
      J=10
   15 WRITE(6,20)(KI(JJ),DEL(JJ),JJ=1,J)
   20 FORMAT(' ',6X,10(I4,2X,F5.1))
  370 CONTINUE                                                                !CALC & REFINEMENT
C
      ICZ=0
      DO 300 II=1,NPHASE
  300 ICZ=ICZ+IC(JDS,II)                                                  !ICZ = NUMBER OF REFELCTIONS FOR ALL PHASES
C
      DO 47 I=1,NPTS(JDS)                                                     
      YC(JDS,I)=YC(JDS,I)+BK(JDS,I)
   47 IF(ISCALC(JOBTYP(JDS))) Y(JDS,I)=YC(JDS,I)
c
c		write out integrated intensities, rbragg and fourier
      IF(IPC.EQ.0)GOTO 4000
      LEBAIL = .FALSE.
	DO K=1,NPHASE
	  IF (IPTYPE(K).EQ.1) LEBAIL = .TRUE.
      ENDDO
	IF ((LEBAIL).AND.(JDS.EQ.1)) THEN
	  OPEN(unit=21,file=fname(1:LC)//'.HKL',status='UNKNOWN',ERR=4112)             !HKL file
      ENDIF
      DO 400 K=1,NPHASE
      T2OBS=0.
      TDOBS=0.
      IF (IPTYPE(K).EQ.1) THEN
          WRITE(21,'(A80)') TITLE
      ENDIF
      IF (IFOUR.GT.0) WRITE(20,'(A1,A80)') '>',PHSNM(K)
      IF (IFOUR.EQ.1) THEN
          WRITE(20,'(6F9.5,2I4)') (SAVE(K,I),I=1,6),MLT(K),ICET(K)
          DO 411 II=1,MLT(K)
          DO 4110 J=1,3
              IV = MOD(IVEC(K,II)/32768/32**(3-J),32)    
              SM(J,1)=IV/9-1                                                    
              SM(J,2)=MOD(IV/3,3)-1
              SM(J,3)=MOD(IV,3)-1
 4110     T(J)=FLOAT(MOD(IVEC(K,II)/32**(3-J),32)-16)/12.0                
  411     WRITE(20,'(12F5.2)') ((SM(I,J),I=1,3),T(J),J=1,3)
      ENDIF
      IXX=0
      DO 481 IX=1,ICZ
      IF(K.NE.IREFS(JDS,IX)/256/256/256/4)GOTO 481
      DO 485 J=1,NEXCRG(JDS)
      IF((REFS(JDS,IX,2)+ZER).GT.ALOW(JDS,J).AND.(REFS(JDS,IX,2)+ZER).LT
     >  .AHIGH(JDS,J)) GO TO 481
  485 CONTINUE
      IXX=IXX+1
      IRL=MOD(IREFS(JDS,IX),256)-128
      IRK=MOD(IREFS(JDS,IX)/256,256)-128
      IRH=MOD(IREFS(JDS,IX)/256/256,256)-128
      IRC=MOD(IREFS(JDS,IX)/256/256/256,4)
C        NEW BRAGG CODE                                           
      JPG = (JDS-1)*MAXIGL
c         converts FF into Intensity = FF*L*M*Scale/step
c         same with COBS
      FF(JDS,IX)=FF(JDS,IX)*REFS(JDS,IX,3)*PAR(K,1)*GLB(14+JPG)/
     *                STEP(JDS)
      IF (SOMEGA(JDS,IX).NE.0) THEN                                                   !CATCHES PROBLEMS IN TOF WHEN
       COBS(JDS,IX)=COBS(JDS,IX)*REFS(JDS,IX,3)*PAR(K,1)*GLB(14+JPG)                   !WDT IS LARGE
     *                /(STEP(JDS)*SOMEGA(JDS,IX))
       CESD=SIGN(1.0,VAR(JDS,IX))*SQRT(ABS(VAR(JDS,IX)))*REFS(JDS,IX,3)*
     *            PAR(K,1)*GLB(14+JPG)/(STEP(JDS)*SOMEGA(JDS,IX))
       DIF=COBS(JDS,IX)-FF(JDS,IX)
      ELSE
       COBS(JDS,IX) = 0.0
       CESD = 0.0
       DIF = 0.0
      ENDIF
      T2OBS=T2OBS+COBS(JDS,IX)
      TDOBS=TDOBS+ABS(COBS(JDS,IX)-FF(JDS,IX))
      HW=REFS(JDS,IX,1)
      GO TO (91,91,93,91,93), NPROF(JDS)
C
   93 IF (MOD(IXX-1,50).EQ.0) WRITE(6,482)
  482 FORMAT(' NO.  CODE     H   K   L   HW    ',
     *'  POSN      ICALC ',4X,'COBS ',6X,'DIFF',7X,'ESD',/)
      IF (.NOT.TOF) THEN
          TT=TAN(REFS(JDS,IX,2)/114.5915590262)
      ELSE
          TT = REFS(JDS,IX,2)
      ENDIF
      HW=VHALF(K,TT,IRH,IRK,IRL,JDS,NPROF(JDS))
      WRITE(6,470)IXX,IRC,IRH,IRK,IRL,HW,REFS(JDS,IX,2),FF(JDS,IX)
     *,COBS(JDS,IX),DIF,CESD
  470 FORMAT(1X,2I4,3X,3I4,2F8.3,2F10.0,2F10.1)
      GO TO 29
C
   91 IF(MOD(IXX-1,50).EQ.0) WRITE(6,479)
  479 FORMAT(' NO.  CODE    H   K   L   HW     SHAPE ',
     *'   POSN      ICALC ',4X,'COBS' ,6X,'DIFF',7X,'ESD',/)
      WRITE(6,471)IXX,IRC,IRH,IRK,IRL,HW,REFS(JDS,IX,4),REFS(JDS,IX,2),
     >    FF(JDS,IX),COBS(JDS,IX),DIF,CESD
  471 FORMAT(1X,2I4,3X,3I4,3F8.3,2F10.0,2F10.1)
   29 CONTINUE
C       CODE FOR FOURIER TAPE
      IF ((IFOUR.EQ.0).AND.(IPTYPE(K).EQ.0)) GOTO 4810
C
      JPG = (JDS-1)*MAXIGL
      COSA=COS(PHASE(IX))
      SINA=SIN(PHASE(IX))
      SINTL=SIN(REFS(JDS,IX,2)/114.5915590262)/LAMDA(JDS,IRC)
      FCALC=FF(JDS,IX)*STEP(JDS)/( REFS(JDS,IX,3)*PAR(K,1)*GLB(14+JPG) )
      IF(COBS(JDS,IX).LT.0.0) COBS(JDS,IX)=0.0
      FOBS=COBS(JDS,IX)*STEP(JDS)/( REFS(JDS,IX,3)*PAR(K,1)*GLB(14+JPG))
      FDIF=FOBS-FCALC
      NN=0
      FESD=CESD*STEP(NDS)/( REFS(JDS,IX,3)*PAR(K,1)*GLB(14+JPG) )
      IF (IFOUR.EQ.1) THEN
          WRITE(20,9000)IRH,IRK,IRL,FOBS,FESD
c          WRITE(20,9000)IRH,IRK,IRL,FOBS,SOMEGA(JDS,IX)
C          WRITE(20,9000)IRH,IRK,IRL,FOBS,FCALC,COSA,SINA,FOBS-FCALC
      ENDIF
      IF (IFOUR.EQ.2) THEN
          IF (ISXRAY(JOBTYP(JDS))) THEN                                           !FOR XRAYS PUT F8.0
              WRITE(20,444) IRH,IRK,IRL,FOBS,FESD
          ELSE
              WRITE(20,4444) IRH,IRK,IRL,FOBS,FESD                                !FOR NEUTRONS PUT F8.2
          ENDIF          
      ENDIF
      IF (IFOUR.EQ.3) THEN
          WRITE(20,'(3I4,2F8.3)')IRH,IRK,IRL,FOBS,PHASE(IX)
      ENDIF
      IF (IFOUR.EQ.4) THEN
          WRITE(20,'(3I4,2F15.5)')IRH,IRK,IRL,FCALC,PHASE(IX)
      ENDIF
      IF (IFOUR.EQ.5) THEN
          WRITE(20,'(3I4,2F15.5)')IRH,IRK,IRL,sqrt(FOBS),sqrt(FCALC)
      ENDIF
      IF (IFOUR.EQ.6) THEN
          WRITE(20,'(3I4,2F15.4)')IRH,IRK,IRL,HW,FOBS
      ENDIF
C
 4810 IF (IPTYPE(K).EQ.1) THEN
          WRITE(21,'(4I4,F15.5)')IRH,IRK,IRL,IRC,FOBS
      ENDIF

  444 FORMAT(3I4,2F8.0)
 4444 FORMAT(3I4,2F8.2)
  443 FORMAT(' SHELX FOURIER FOR HISTOGRAM = ',I2,', PHASE = ',I2)
9000  FORMAT(3I4,5F8.3)
C       END CODE FOR FOURIER TAPE
  481 CONTINUE
      IF(ISCALC(JOBTYP(JDS))) T2OBS=TDOBS
      TDOBS=100.*TDOBS/T2OBS
      WRITE(6,483)TDOBS
  483 FORMAT('  DERIVED BRAGG R-FACTOR=  ',F8.2)
      WRITE(7,484)TDOBS
	THEBRA(K,JDS) = TDOBS
  484 FORMAT(' BRAGG R-FACTOR = ',F8.2)
C
 400  CONTINUE
C         END OF LOOP OVER PHASES
      IF (JDS.EQ.NDS) CLOSE(21)
      GOTO 4000
 4112 ERROR=70
      RETURN
C
C      REWRITE UNIT 8 NOW HERE.
 4000 DO 1100 KK=1,NDS
 1100     NEXCRG(KK)=NEXCRG(KK)-2
      IF(NXT.NE.0.AND.(JDS.EQ.NDS))CALL REWRIT(ISCALE,
     *IDIF,IFY,IFYC,IFM,IFD,EXPAND,NDS)
      DO 1110 KK=1,NDS
 1110     NEXCRG(KK)=NEXCRG(KK)+2
C
   36 IF(IOT.EQ.0)GOTO 30
      NP=NPTS(JDS)/250
      DO 31 I=1,NPTS(JDS)
   31 BK(JDS,I)=THMIN(JDS)+FLOAT(I-1)*STEP(JDS)
      WRITE(6,101)(((BK(JDS,250*N-300+50*I+J),                          
     >        Y(JDS,250*N-300+50*I+J),
     >        YC(JDS,250*N-300+50*I+J),I=1,5),J=1,50),N=1,NP)
 101  FORMAT(('  ',5('2THETA',3X,'YOBS',4X,'YCALC',4X),/,50(5(1X,F8.4,
     >2F8.0,1X),/)))
      NPTS2=NPTS(JDS)-NP*250
      IF(NPTS2.EQ.0)GOTO 30
      NCOL=NPTS2/50
      WRITE(6,103)
 103  FORMAT(2H1 ,5(6H2THETA,3X,4HYOBS,4X,5HYCALC,4X))
      NLINES=NPTS2-NCOL*50
      IF(NLINES.EQ.0)GOTO 33
      NCOL1=NCOL+1
      NP=250*NP-50
      DO 34 J=1,NLINES
 34   WRITE(6,102)(BK(JDS,NP+50*I+J),Y(JDS,NP+50*I+J),
     >            YC(JDS,NP+50*I+J),I=1,NCOL1)
 102  FORMAT(5(1X,F8.4,2F8.0,1X))
      NP=NP+NLINES
      NLINES=50-NLINES
   33 DO 35 J=1,NLINES
 35   WRITE(6,102)(BK(JDS,NP+50*I+J),Y(JDS,NP+50*I+J),
     >            YC(JDS,NP+50*I+J),I=1,NCOL)
 30   IF(IPL.EQ.0)GOTO 45         
      DO 210 I=1,124
  210 LABEL(I)=10*I*ISCALE
      WRITE(6,100) TITLE,LABEL
  100 FORMAT(1H1,30X,A80//1X,12I10)
      DO 11 I=1,12
   11 LABEL(I)=-60*IDIF+10*I*IDIF
      WRITE(6,203) LABEL
  203 FORMAT(1H ,12I10)
      DO 60 I=1,NPTS(JDS)
    1 DO 3 J=1,120
    3 IOUT(J)=ISPACE
      IOUT(1)=IDOT
      IOUT(61)=IDOT
      IOUT(120)=IDOT
  200 IY=INT(Y(JDS,I))/ISCALE+2
      IY=MAX0(MIN0(IY,120),2)
      IOUT(IY-1)=IBAR
      IOUT(IY)=IPLUS
      IF(IY.LE.119)IOUT(IY+1)=IBAR
      IY=INT(YC(JDS,I))/ISCALE+2
      IY=MAX0(MIN0(IY,120),2)
      IOUT(IY)=IMINUS
      IY=INT(Y(JDS,I)-YC(JDS,I))/IDIF+61
      IY=MAX0(MIN0(IY,120),2)
      IOUT(IY)=ISTAR
      IF(MOD(I-1,10).NE.0) GOTO 55
      TLABEL=THMIN(JDS)+STEP(JDS)*FLOAT(I-1)
      WRITE(6,104)(IOUT(J),J=1,113),TLABEL,IOUT(120)
  104 FORMAT(1X,113A1,F6.2,A1)
      GO TO 60
   55 WRITE(6,201) (IOUT(J),J=1,120)
  201 FORMAT(1X,120A1)
   60 CONTINUE
   45 IF(ISDATA(JOBTYP(JDS)))GOTO 72                                   !DO NOT WRITE OUT IF REAL DATA
C      REWIND 4               REMOVED SO THAT A CALC DOESN'T OVERWRITE A REAL DATASET OR ANOTHER CALC DATASET
      OPEN(UNIT=4,FILE=FNAME(1:LC)//'.clc',STATUS='UNKNOWN')
      IF (LSYNC.EQ.0) THEN
         WRITE(4,70)THMIN(JDS),STEP(JDS),THMAX(JDS)
      ELSE   
         WRITE(4,7001)THMIN(JDS),STEP(JDS),THMAX(JDS)
      ENDIF
      WRITE(4,'(10I8)')(INT(YC(JDS,I)),I=1,NPTS(JDS))                 
      CLOSE(UNIT=4)
   70 FORMAT(3F8.4)
 7001 FORMAT(3F12.6)
c                             EXTERNAL PLOTTING FILE ROUTINUES
C      MODIFICATION TO ALLOW PLOT INFORMATION TO BE WRITTEN TO A FILE
 2001 FORMAT(A80)
 2002 FORMAT(4I1,2F9.4)
 2003 FORMAT(5(1X,F12.6))
 2033 FORMAT(5(1X,F15.6))
 2004 FORMAT(I3,I5,I5)
 2005 FORMAT(8I5)
 2006 FORMAT(8I10)
 2007 FORMAT(10F8.3)
 2010 FORMAT(4(F15.5,1X),F4.0)                    
   71 FORMAT(10F8.0)
  710 FORMAT(10I8)
   72 CONTINUE
C     FIND MAX OF THE OBS & CALC DATA - NOT USED IN ALL PLOTTING BUT BETTER TO HAVE IT HERE THAN ELSEWHERE
c      CALL PLOTFILE(JDS,IPL2)
      HI=Y(JDS,1)
      DO 50 I=1,NPTS(JDS)
          IF(Y(JDS,I).GT.HI)HI=Y(JDS,I)                                                     
          IF(KR(JDS,I).EQ.1) GO TO 50
          IF(YC(JDS,I).GT.HI)HI=YC(JDS,I)                                                   
   50 CONTINUE
      IF (IPL2.EQ.1) THEN                                                  !KALEDIA/GENERAL/ALL INFO FILE
          WRITE(9,2001) TITLE                                              !useful for Kalaediagraph, Origin, Axum, Excel etc
          DO 1030 I=1,NPTS(JDS)                                                 !Output:
              THTEMP = THMIN(JDS)+STEP(JDS)*(I-1)                          !  2theta, Yobs, Ycalc, d(hkl), phase # for d value
              IF(I.GT.ICZ) THEN                                            ! you can use phase # to set how far the marker is
               WRITE(9,2010) THTEMP,Y(JDS,I),YC(JDS,I)                     ! plotted below the data
              ELSE                  
               YMV = 1.0*(IREFS(JDS,I)/256/256/256/4)
               WRITE(9,2010) THTEMP,Y(JDS,I),YC(JDS,I),REFS(JDS,I,2)+
     *                            GLB(1+(JDS-1)*MAXIGL),YMV
              ENDIF
 1030     CONTINUE                  
      ENDIF
      IF(IPL2.EQ.2) THEN                                                  !IPL = 2 == ILL TYPE PLOT
          WRITE(9,2001)TITLE
          WRITE(9,2002)IFY,IFYC,IFM,IFD,EXPAND,ZER                        !OUT ZERO VALUE
          IF (LSYNC.EQ.0) THEN
              WRITE(9,2003)THMAX(JDS),THMIN(JDS),STEP(JDS),LAMDA(JDS,1),
     *                     LAMDA(NDS,2)
          ELSE
              WRITE(9,2033)THMAX(JDS),THMIN(JDS),STEP(JDS),LAMDA(JDS,1),
     *                     LAMDA(NDS,2)
          ENDIF      
          WRITE(9,2004)NPHASE,NPTS(JDS),NDS                              !OUT NUMBER OF PHASES, POINTS, HIST#
          WRITE(9,2005)(IC(JDS,I),I=1,NPHASE)                            !OUT NUMBER OF MARKERS PER PHASE
          WRITE(9,710)(INT(Y(JDS,J)),J=1,NPTS(JDS))                            !OUT OBS VALUES
          WRITE(9,710)(INT(YC(JDS,J)),J=1,NPTS(JDS))                           !OUT CALC VALUES
c          WRITE(9,71)(Y(JDS,J)-BK(JDS,J),J=1,NPTS(JDS))                            !OUT OBS VALUES
c          WRITE(9,71)(YC(JDS,J)-BK(JDS,J),J=1,NPTS(JDS))                           !OUT CALC VALUES
          WRITE(9,2006)(IREFS(JDS,J),J=1,ICZ)                            !OUT HKL VALUES
          WRITE(9,2007)(REFS(JDS,J,2),J=1,ICZ)                           !OUT 2THETA MARKERS
      ENDIF
      IF((IPL2.EQ.3).OR.(IPL2.EQ.4)) THEN                                             !Plot (SJK)
          WRITE(9,2001) TITLE
          WRITE(9,*) THMIN(JDS),THMAX(JDS)
          WRITE(9,*) 0.0,  HI
          WRITE(9,*)  NPTS(JDS), NPHASE
          DO 1170 JJ=1,NPTS(JDS)
              YDIF(JJ) = Y(JDS,JJ)-YC(JDS,JJ)
 1170         IF(YC(JDS,JJ).EQ.0.0) YDIF(JJ) = 0.0
C                 NON-NORMALIZED GENERAL PLOT
      IF (IPL2.EQ.3) THEN                                                             !IPL = 3 NORMALIZED
              WRITE(9,*) (THMIN(JDS)+STEP(JDS)*(J-1),Y(JDS,J)/HI,
     *YC(JDS,J)/HI,(YDIF(J)/HI-.075*(NPHASE+1)), J=1,NPTS(JDS))
          ELSE
C                 GENERAL PLOT NOT-NORMALIZED
              WRITE(9,*) (THMIN(JDS)+STEP(JDS)*(J-1),Y(JDS,J),                        !IPL = 4 non-NORMALIZED
     *YC(JDS,J),(YDIF(J)-HI*.075*(NPHASE+1)), J=1,NPTS(JDS))
          ENDIF
CSJK
      ICTOTAL = 0
      DO 1180 L=1,NPHASE 
 1180     ICTOTAL = ICTOTAL+ IC(JDS,L)
          DO 1190 L=1,NPHASE
              WRITE(9,*) IC(JDS,L)
              DO 1190 K=1,ICTOTAL
                  IF(TOF) THEN
                  WRITE(9,*) TVAL(REFS(JDS,K,2),LAMDA(JDS,1),
     *                        LAMDA(JDS,2),GLB(1+(JDS-1)*MAXIGL))                      !put the zero value in
                  ELSE  
                  OTBIT =  GLB(1+(JDS-1)*MAXIGL)  
      IF(L.EQ.IREFS(JDS,K)/256/256/256/4) WRITE(9,*) REFS(JDS,K,2)+OTBIT            
                  ENDIF
 1190     CONTINUE
      END IF
      RETURN
      END                                                                      
c
c**********************************************************************************
c
      SUBROUTINE REWRIT(ISCALE,IDIF,IFY,IFYC,IFM,IFD,EXPAND,NDS)
      include 'param.inc'
      REAL LAMDA
      INTEGER PTR,NDS,JG,TEMPPH
      COMMON/DC/SAVE(NUPH,6),NSAVE
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS),TEMPAT1,TEMPAT2
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      CHARACTER SYMB(NUPH,20)*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      COMMON/JNK2/WEIDS(MAXDS)
      COMMON/QUANT/NZF(NUPH),WATOM(NATS)
      COMMON/CTOF/AIV(MAXDS,9),PALP(2),PBET(2)
      COMMON/FORMF/ADFP(MAXDS,MAXFF,2),LDFP(MAXDS,MAXFF,2)
      CHARACTER*4 NAM(MAXDS,MAXFF)
      COMMON/COEFC/NAM
      COMMON/MAGN/MAGOPT(NATS,2)
	COMMON/DISRES/ATOMATOM(MAXRES,7)
      LOGICAL ISXRAY,ISCW,ISCALC,CONLY,LEBAIL
c
      WRITE(7,*) 'Creating Update file...'
      WRITE(8,1)TITLE
   1  FORMAT(A80)
C      JOBTYP(1)=JOBTYP(1)-1
      CONLY = ISCALC(JOBTYP(1))
      WRITE(8,2)JOBTYP(1)+(NDS-1)*10-1,NPROF(1),NPHASE,
     >    NBCKGD(1),NEXCRG(1),NSCAT(1),IWT(1),IABSCOR(1),IFULLILL(1),
     >    IGEOM(1),NMOLE,NRES
      DO 1000 J=2,NDS                      
C      JOBTYP(J) = JOBTYP(J) - 1
      CONLY= CONLY.AND.ISCALC(JOBTYP(J))
 1000 WRITE(8,2) JOBTYP(J)-1,NPROF(J),NPHASE,NBCKGD(J),
     >      NEXCRG(J),NSCAT(J),IWT(J),IABSCOR(J),IFULLILL(J),IGEOM(J)
   2  FORMAT(12I4)
C
      LEBAIL = .FALSE.
      DO I=1,NPHASE
        IF (IPTYPE(I).EQ.1) LEBAIL = .TRUE.
      ENDDO
C
      IF (LEBAIL) IDSBB = 1													!IF LEBAIL MAKE
C																			!DEFAULT = RECYCLE
      WRITE(8,14)IOT,IPL,IPC,MAT,NXT,LST1,LST2,LST3,IPL1,IPL2,
     *IFOUR,NFMT,LSYNC,LMR,IDSBB,IBCK,IPREF,ITHER,IMARQT,
     *RADMIN,RADMAX,VMARQT
  14  FORMAT(19I1,1X,2F8.3,F8.5)        
      DO 1010 J =1,NDS
      IF (ISCW(JOBTYP(J))) THEN
          WRITE(8,23)LAMDA(J,1),LAMDA(J,2),RATIO(J,2),WEIDS(J),WDT(J),
     *           CTHM(J),TMV(J),RLIM,FFLIM(J)
      ELSE
          IF (LAMDA(J,1).GE.10000.0) THEN
          WRITE(8,2312)LAMDA(J,1),LAMDA(J,2),RATIO(J,2),WEIDS(J),WDT(J),
     *           CTHM(J),TMV(J),RLIM,FFLIM(J)
          ELSE
          WRITE(8,230)LAMDA(J,1),LAMDA(J,2),RATIO(J,2),WEIDS(J),WDT(J),
     *           CTHM(J),TMV(J),RLIM,FFLIM(J)
          ENDIF
          WRITE(8,2311) (AIV(J,I),I=1,9)
      ENDIF          
 1010 CONTINUE
  23  FORMAT(2F8.5,7F8.4)
  230 FORMAT(2F8.3,7F8.4)
 2312 FORMAT(2F8.2,7F8.4)
 2311 FORMAT(9E9.3)
C
      N=0
      DO 121 I=1,NPHASE
  121 N=N+ABS(NATOM(I))
      DO 84 I=1,N
      DO 84 J=1,11
  84  A(I,J)=SIGN(1.,A(I,J))*(FLOAT(10*LP(I,J))+ABS(A(I,J)))
      DO 87 I=1,NPHASE
      DO 88 J=1,6
   88 PAR(I,J+5)=SAVE(I,J)
      DO 87 J=1,MAXIPAR*NDS
  87  APAR( I,J)=SIGN(1.,APAR(I,J))*(FLOAT(10*LPAR(I,J))+ABS(APAR(I,J)))
      DO 89 J=1,MAXIGL*NDS
  89  AGLB(J)=SIGN(1.,AGLB(J))*(FLOAT(10*LGLB(J))+ABS(AGLB(J)))
C
      IF (LSYNC.EQ.0) THEN
        IF (ISCW(JOBTYP(1))) THEN
        WRITE(8,30)MCYCLE,EPS,RELAX,THMIN(1),STEP(1),THMAX(1),AGLB(15)
     >    ,AGLB(16)
        ELSE
        WRITE(8,3003)MCYCLE,EPS,RELAX,THMIN(1),STEP(1),THMAX(1),AGLB(15)
     >    ,AGLB(16)
         ENDIF
      ELSE
        WRITE(8,3002)MCYCLE,EPS,RELAX,THMIN(1),STEP(1),THMAX(1),AGLB(15)
     >    ,AGLB(16)
      ENDIF
  30  FORMAT(1I4,5F4.2,3F8.3,2F8.2)
 3003 FORMAT(1I4,5F4.2,3F8.1,2F8.2)
 3002 FORMAT(1I4,5F4.2,3F12.6,2F8.2)
      DO 1040 J=2,NDS
 1040     WRITE(8,3102) THMIN(J),STEP(J),THMAX(J),
     >    GLB(14+(J-1)*MAXIGL),AGLB(14+(J-1)*MAXIGL),
     >    AGLB(15+(J-1)*MAXIGL),AGLB(16+(J-1)*MAXIGL)     
 3102 FORMAT(3(F12.6,1X),4(G10.4,1X))
      DO 120 J=1,NDS
          IF(NBCKGD(J).LT.2)GOTO 120
          WRITE(8,34)(POS(J,I),BCK(J,I),I=1,NBCKGD(J))
  120 CONTINUE
  34  FORMAT(2F8.2)
      DO 122 J=1,NDS
          IF(NEXCRG(J).LE.0)GOTO 122
          WRITE(8,'(2F8.4)')(ALOW(J,I),AHIGH(J,I),I=1,NEXCRG(J))
 122  CONTINUE
 38   FORMAT(A4,2F8.4,2F8.3)
 39   FORMAT(F8.5,8F9.5)
      DO 124 J=1,NDS
          IF(NSCAT(J).LE.0)GOTO 124
          DO 125 I=1,NSCAT(J)
              IF(ISXRAY(JOBTYP(J))) THEN
                  WRITE(8,38)NAM(J,I),DFP(J,I,1),DFPP(J,I),
     *     LDFP(J,I,1)*10.0 + ADFP(J,I,1),LDFP(J,I,2)*10.0 + ADFP(J,I,2)
                  IF (AC(J,3,I).EQ.0) THEN
                      II = 1
 5102                 WRITE(8,'(F8.3,F9.4)') POSI(II,I),SCAT(II,I)
                      II = II + 1
                      IF(((POSI(II,I).EQ.0).AND.(SCAT(II,I).EQ.0.0)).
     *                                            OR.(II.EQ.MFCO))THEN
                          WRITE(8,'(F8.3)') -100.0
                          GOTO 5101
                      ENDIF
                      GOTO 5102
 5101                     CONTINUE
                  ELSE
                      WRITE(8,39)(AC(J,KK,I),KK=1,9)
                  ENDIF                  
              ELSE
                  WRITE(8,38)NAM(J,I),DFP(J,I,2),DFPP(J,I),
     *     LDFP(J,I,1)*10.0 + ADFP(J,I,1),LDFP(J,I,2)*10.0 + ADFP(J,I,2)
              ENDIF
 125      CONTINUE
  124 CONTINUE
      WRITE(8,43)MAXS
   43 FORMAT(I8)
C
      WRITE(8,45) (GLB(1+(J-1)*MAXIGL),AGLB(1+(J-1)*MAXIGL),J=1,NDS)
      
      DO J=1,NDS
      IF (IGEOM(J).EQ.1) THEN
      WRITE(8,'(F10.7,F8.3)') GLB((J-1)*MAXIGL+17),AGLB((J-1)*MAXIGL+17)
	ENDIF
      ENDDO

   45 FORMAT(10F8.3)
C                                         
      DO 1060 I=1,NDS
      IF (NBCKGD(I).GE.1) GOTO 1060
        JG = (I-1)*MAXIGL +1
        WRITE(8,46) (GLB(JG+J),J=1,(IBCK+1)*6)
        WRITE(8,461) (AGLB(JG+J),J=1,(IBCK+1)*6)
 1060 CONTINUE
   46 FORMAT(6G12.6)
  461 FORMAT(6F12.6)
 477  DO 81 K=1,NPHASE
      IOF=0
      IF(K.GT.1) THEN
      DO 100 KK=1,K-1
  100 IOF=IOF+ABS(NATOM(KK))
      ENDIF
      WRITE(8,465)PHSNM(K)
  465 FORMAT(A80)
      DO 1070 J=1,NDS
C      IF (IAP(J).EQ.0) THEN
C          WRITE(8,48) NATOM(K),(PREF(J,K,I),I=1,3)
C      ELSE
          WRITE(8,481) NATOM(K),NZF(K),(PREF(J,K,I),I=1,3),
     *                 (ANHKL(J,K,I),I=1,3)
C      ENDIF                      
 1070 CONTINUE
   48 FORMAT(I4,8X,3F4.2)
  481 FORMAT(2(I4,2X),3F4.2,8X,3F4.2)
      N=ABS(NATOM(K))
      WRITE(8,460)(SYMB(K,I),I=1,20)
  460 FORMAT(20A1)
      IF (N.GT.0) THEN
      DO I=1,N
          DUM1 = ' '
          DUM2 = ' '
          IF (MAGOPT(I+IOF,1).EQ.1) DUM1 = 'M'
          IF (MAGOPT(I+IOF,2).EQ.1) DUM1 = 'I'
          WRITE(8,65) ATEXT(I+IOF),NTYP(I+IOF),DUM1,DUM2,
     *                (XL(I+IOF,J),J=1,11)
          IF (MAGOPT(I+IOF,1).EQ.1) WRITE(8,651) (XL(I+IOF,J),J=12,14) 
      ENDDO
      ENDIF
   65 FORMAT(2A4,1X,2A1,5X,5F8.5/6F8.5)
  651 FORMAT(3F8.5)
      IF (NPROF(1).LE.6) THEN
          WRITE(8,50)(PAR(K,I),I=1,5),PAR(K,19),(PAR(K,I),I=6,14),
     *    PAR(K,20),(PAR(K,I),I=15,18)
      ELSE
          WRITE(8,504)(PAR(K,I),I=1,5),PAR(K,19),(PAR(K,I),I=21,24),
     *                (PAR(K,I),I=6,18)
      ENDIF
      IF (IABSCOR(1).EQ.1) WRITE(8,'(2F8.4)') (PAR(K,I),I=25,26)
   50 FORMAT(G12.6,4X,F8.5,/,4F8.5,/,6F8.4,/,4F8.5,/,F8.4,F8.5,F8.6,
     *F8.5)                      
  504 FORMAT(G12.6,4X,F8.5,/,4F8.3,/,4F8.5/,6F8.4,/,3F8.5,/,F8.4,F8.5,
     *F8.6,F8.5)                      
      DO 1080 J=2,NDS                 
          JP = (J-1)*MAXIPAR
          IF(NPROF(J).LE.6) THEN
          WRITE(8,501) (PAR(K,I+JP),I=3,5),PAR(K,19+JP),
     >          (PAR(K,I+JP),I=12,14),PAR(K,20+JP),(PAR(K,I+JP),I=15,18)
          ELSE
          WRITE(8,5010)(PAR(K,I+JP),I=3,5),PAR(K,19+JP),
     *                (PAR(K,I+JP),I=21,24),(PAR(K,I+JP),I=6,18)
          ENDIF    
      IF (IABSCOR(J).EQ.1) WRITE(8,'(2F8.4)') (PAR(K,I+JP),I=25,26)
 1080 CONTINUE   
  501 FORMAT(4F8.5,/,4F8.5,/,F8.4,F8.5,F8.6,F8.5)
 5010 FORMAT(4F8.3,/,3F8.5,/,F8.4,F8.5,F8.6,F8.5)
      IF ((N.GT.0).AND.(.NOT.CONLY)) THEN
          WRITE(8,861)((A(I+IOF,J),J=1,11),I=1,N)
      ENDIF
  861 FORMAT(5F8.3,/,6F8.3)
C             WRITE OUT ONLY IF CALCULATION
      IF (.NOT.CONLY) THEN
      IF (NPROF(1).LE.6) THEN
          WRITE(8,86)(APAR(K,I),I=1,5),APAR(K,19),(APAR(K,I),I=6,14),
     *                APAR(K,20),(APAR(K,I),I=15,18)
      ELSE
          WRITE(8,862)(APAR(K,I),I=1,5),APAR(K,19),(APAR(K,I),I=21,24),
     *               (APAR(K,I),I=6,18)
      ENDIF
      IF (IABSCOR(1).EQ.1) WRITE(8,'(2F8.3)') (APAR(K,I),I=25,26)
   86 FORMAT(F12.6,4X,F8.3,/,4F8.3,/,6F8.3,/,4F8.3,/,4F8.3)
  862 FORMAT(F12.6,4X,F8.3,/,4F8.3,/,4F8.3,/,6F8.3,/,3F8.3,/,4F8.3)
      DO 1090 J=2,NDS                 
          JP = (J-1)*MAXIPAR
          IF (NPROF(J).LE.6) THEN
          WRITE(8,502) (APAR(K,I+JP),I=3,5),APAR(K,19+JP),
     >       (APAR(K,I+JP),I=12,14),APAR(K,20+JP),(APAR(K,I+JP),I=15,18)

          ELSE
          WRITE(8,502) (APAR(K,I+JP),I=3,5),APAR(K,19+JP),
     >                 (APAR(K,I+JP),I=21,24),(APAR(K,I+JP),I=12,18)
          ENDIF
      IF (IABSCOR(J).EQ.1) WRITE(8,'(2F8.3)') (APAR(K,I+JP),I=25,26)
 1090 CONTINUE
      ENDIF
  502 FORMAT(4F8.3,/,4F8.3,/,4F8.3)
 5020 FORMAT(4F8.3,/,4F8.3,/,3F8.3,/,4F8.3)
   81 CONTINUE
c
c         write out restraints
  503 FORMAT(I2,2X,2A4,2F8.3)
      IF(NRES.NE.0) THEN
	    DO I=1,NRES 
             TEMPPH = INT(ATOMATOM(I,1))
             IOF=0
             IF(TEMPPH.GT.1) THEN
                DO KK=1,TEMPPH-1
                  IOF=IOF+ABS(NATOM(KK))
                ENDDO
             ENDIF
	       TEMPAT1 = ATEXT(IOF + INT(ATOMATOM(I,2)))
	       TEMPAT2 = ATEXT(IOF + INT(ATOMATOM(I,3)))
             WRITE(8,503) TEMPPH,TEMPAT1,TEMPAT2,(ATOMATOM(I,J),J=4,5)
	    ENDDO
	ENDIF
c
      IF(IPL.NE.0)WRITE(8,191)ISCALE,IDIF
  191 FORMAT(2I8)
      IF(IPL2.NE.0)WRITE(8,171)IFY,IFYC,IFM,IFD,EXPAND
  171 FORMAT(4I1,4X,F8.4)
  151 RETURN
      END
c
c**********************************************************************************
c
      SUBROUTINE OUTPTR(ICYCLE,NDS)
      include 'param.inc'
      REAL LAMDA,LAMOLD,STOT,CELLV,CELLVE,RAD                  
      REAL QPHASE(NUPH),QPHASEE(NUPH),QTOT,QMTOT,MW(NUPH),DENSITY(NUPH)
      REAL QTOTE,QMTOTE
      REAL ASTAR,BSTAR,CSTAR,DELCEL(6)
      INTEGER NDS,NUMT,ITEMP,LTEMP                            
      LOGICAL MWNZERO,ISCW,ISTOF,ISDATA
      COMMON/DC/SAVE(NUPH,6),NSAVE
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      CHARACTER SYMB(NUPH,20)*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/G3/COND,IORD1,IORD2,TH,NUM(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/G2/S1(MAXDS),S2(MAXDS),S3(MAXDS),D1(MAXDS),D2(MAXDS),
     &          R1(MAXDS),R2(MAXDS),R3(MAXDS),DWD(MAXDS),WDWD(MAXDS),
     &          R1TOT,R2TOT,R3TOT
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U11(MAXDS),
     &  V11(MAXDS),W11(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      COMMON/F1/RJAC(MSZ2),V(MSZ),OCHI
      COMMON/F3/SMM(MSZ,MSZ)
      COMMON/F2/SIGCEL(NUPH,6),SIGATOM(NATS,3)
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      COMMON/FORMF/ADFP(MAXDS,MAXFF,2),LDFP(MAXDS,MAXFF,2)
      CHARACTER*4 NAM(MAXDS,MAXFF)
      COMMON/COEFC/NAM
      COMMON/QUANT/NZF(NUPH),WATOM(NATS)
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      COMMON/PARVAL/IPNUM(MSZ),PVAL(MSZ),PERR(MSZ),NPAR
	COMMON/PRSTU/TPAR(NUPH,6),TERR(NUPH,6),TPR(NUPH,NATS,2,5),
     *SOTHER(NUPH,NATS,2,11),THERS(MAXDS,4)
      DIMENSION SY(MSZM),SZ(MSZM),DCSM(6,6),DCV(6)
      DIMENSION SYG(MSZM),SZG(MSZM)
C
      BCON =  0.05066059182117                                                    !1/(2*PI*PI)
      RAD = 0.01745329251994
      WRITE(6,1)ICYCLE
      WRITE(7,111)ICYCLE
  111 FORMAT(/,' CYCLE NUMBER',I3)
    1 FORMAT(1H ,120(1H+)//14H CYCLE NUMBER=,I4)
c
C                 START A LOOP OVER THE PHASES
      NPAR = 0
      DO I=1,MSZ
        IPNUM(I) = 0
        PVAL(I) = 0.0
        PERR(I) = 0.0
      ENDDO
C
      DO 10 IP=1,NPHASE
      IOF=0
      IF(IP.NE.1) THEN
        DO KK=1,IP-1
          IOF=IOF+ABS(NATOM(KK))
        ENDDO
      ENDIF
      IF (ITHER.EQ.0) WRITE(6,3)IP,PHSNM(IP)
	IF (ITHER.EQ.1) WRITE(6,300)IP,PHSNM(IP)
    3 FORMAT(/,' PHASE ',I2,2H: ,A80,/' NEW PARAMETERS, SHIFTS, AND ',
     *'STANDARD DEVIATIONS='//5H ATOM,6X,1HX,7X,2HDX,6X,2HSX,7X,1HY,7X,
     *2HDY,6X,2HSY,7X,1HZ,7X,2HDZ,6X,2HSZ,6X,1HB,6X,2HDB,5X,2HSB,
     *6X,1HN,6X,2HDN,5X,2HSN)
  300 FORMAT(/,' PHASE ',I2,2H: ,A80,/' NEW PARAMETERS, SHIFTS, AND ',
     *'STANDARD DEVIATIONS='//5H ATOM,6X,1HX,7X,2HDX,6X,2HSX,7X,1HY,7X,
     *2HDY,6X,2HSY,7X,1HZ,7X,2HDZ,6X,2HSZ,6X,1HU,6X,2HDU,5X,2HSU,
     *6X,1HN,6X,2HDN,5X,2HSN)
      N=ABS(NATOM(IP))                                             
c
C             CALC SHIFTS/ERRORS IN Lattice Parameters
C
      DO 170 J=6,11          
          KM=LPAR(IP,J)
          IF(KM.NE.0)GOTO 180
          SY(J)=0.
          SZ(J)=0.
          GOTO 170
  180     SZ(J)=SQRT(ABS(SMM(KM,KM)))*ABS(APAR(IP,J))
          SY(J)=V(KM)*APAR(IP,J)*RELAX(3)
          PAR(IP,J)=PAR(IP,J)+SY(J)
          IF (IPNUM(KM).EQ.0) THEN
              NPAR=NPAR+1
              ITEMP = MOD(J,MAXIPAR)
              IF (ITEMP.EQ.0) ITEMP = 0
              LTEMP = INT(J/MAXIPAR)+1
              IPNUM(KM) = ITEMP-1 + (IP-1)*26 + (LTEMP-1)*26*17 + 256*32
              PVAL(KM) = PAR(IP,J)
              PERR(KM) = SZ(J)
          ENDIF
  170 CONTINUE
c
      CALL DIRECT(DCSM,DCV,IP)
      DO 30 I=1,6
          SIGCEL(IP,I) = DCSM(I,I)
          DELCEL(I)=DCV(I)-SAVE(IP,I)
   30 SAVE(IP,I)=DCV(I)
C              SOME RECIPROCAL LATTICE CALCULATIONS
      COSA = COS(DCV(4)*RAD)
      COSB = COS(DCV(5)*RAD)
      COSC = COS(DCV(6)*RAD)
      SINA=SQRT(1.0-COSA**2)
      SINB=SQRT(1.0-COSB**2)
      SINC=SQRT(1.0-COSC**2)
      COSASR=(COSB*COSC-COSA)/(SINB*SINC)
      COSBSR=(COSA*COSC-COSB)/(SINA*SINC)
      COSCSR=(COSA*COSB-COSC)/(SINA*SINB)
      SINASR=SQRT(1.0-COSASR**2)
      SINBSR=SQRT(1.0-COSBSR**2)
      ASTAR=1.0/(DCV(1)*SINC*SINBSR)
      BSTAR=1.0/(DCV(2)*SINC*SINASR)
      CSTAR=1.0/(DCV(3)*SINA*SINBSR)
C
C
C             CALC THE SHIFTS/ERRORS IN ATOMIC COORDINATES
c
      MW(IP) = 0.0
      MWNZERO = WATOM(1+IOF).NE.0.0            
      DO  4 I=1,N
          DO 1000 J=1,3
 1000         SIGATOM(I,J) = 0.0
          DO  5 J=1,5
              KM=LP(I+IOF,J)
              IF(KM.NE.0)GOTO  6
              SY(J)=0.
              SZ(J)=0.
              GOTO  5
    6         SZ(J)=SQRT(ABS(SMM(KM,KM)))*ABS(A(I+IOF,J))
              SY(J)=V(KM)*A(I+IOF,J)*RELAX(1)
              XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
              IF (J.LE.3) SIGATOM(I,J) = SZ(J)
              IF (IPNUM(KM).EQ.0) THEN
                  NPAR=NPAR+1
                  IPNUM(KM) = (J-1) + (IP-1)*11 + (I-1)*17*11 + 256*256
                  PVAL(KM) = XL(I+IOF,J)
                  PERR(KM) = SZ(J)
              ENDIF
    5     CONTINUE            
          MWNZERO = MWNZERO.AND.(WATOM(I+IOF).NE.0.0)
          MW(IP) = MW(IP) + WATOM(I+IOF)*XL(I+IOF,5)*MLT(IP)
	Do 238 ILL = 1,5
		   TPR(IP,I+IOF,1,ILL) = XL(I+IOF,ILL)
		   TPR(IP,I+IOF,2,ILL) = SZ(ILL)
  238 CONTINUE 
      IF (ITHER.EQ.0) THEN
         WRITE(6,100)ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=1,5)
      ELSE
         WRITE(6,100)ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=1,3),
     *    XL(I+IOF,4)/78.95684,SY(4)/78.95684,SZ(4)/78.95684,
     *    XL(I+IOF,5),SY(5),SZ(5)
      ENDIF
    4 CONTINUE
      IF (.NOT.MWNZERO) MW(IP) = 0.0 
  100 FORMAT(1X,A4,2X,3(3F8.5,1X),2(3F7.4,1X))
      IF (ITHER.EQ.0) WRITE(6,101)
      IF (ITHER.EQ.1) WRITE(6,201)
  101 FORMAT(5H ATOM,7X,3HB11,6X,4HDB11,6X,4HSB11,7X,3HB22,6X,4HDB22,6X,
     *4HSB22,7X,3HB33,6X,4HDB33,6X,4HSB33,/,12X,3HB12,6X,4HDB12,6X,
     *4HSB12,7X,3HB13,6X,4HDB13,6X,4HSB13,7X,3HB23,6X,4HDB23,6X,4HSB23)
  201 FORMAT(' ATOM',7X,'U11',6X,'DU11',6X,'UB11',7X,'U22',6X,'DU22',6X,
     *'SU22',7X,'U33',6X,'DU33',6X,'SU33',/,12X,'U12',6X,'DU12',6X,
     *'SU12',7X,'U13',6X,'DU13',6X,'SU13',7X,'U23',6X,'DU23',6X,'SU23')
C
C         CALC THE SHIFTS/ERROR IN THERMAL PARAMETERS
C
      DO  7 I=1,N
          DO  8 J=6,11
              KM=LP(I+IOF,J)
              IF(KM.NE.0)GOTO 9
              SY(J)=0.
              SZ(J)=0.
              GOTO  8
    9         SZ(J)=SQRT(ABS(SMM(KM,KM)))*ABS(A(I+IOF,J))
              SY(J)=V(KM)*A(I+IOF,J)*RELAX(2)
              XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
              IF (IPNUM(KM).EQ.0) THEN
                   NPAR=NPAR+1
                   IPNUM(KM) = (J-1) + (IP-1)*11 + (I-1)*17*11 + 256*256
                   PVAL(KM) = XL(I+IOF,J)
                 PERR(KM) = SZ(J)
              ENDIF
    8     CONTINUE
		Do 239 ILL = 6,11
		   SOTHER(IP,I+IOF,1,ILL) = XL(I+IOF,ILL)
		   SOTHER(IP,I+IOF,2,ILL) = SZ(ILL)
  239	  CONTINUE
          WRITE(6,102)ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=6,11)
          IF (ITHER.EQ.1) THEN
          WRITE(6,1020) XL(I+IOF,6)*BCON/(ASTAR*ASTAR),
     * SY(6)*BCON/(ASTAR*ASTAR),SZ(6)*BCON/(ASTAR*ASTAR),
     * XL(I+IOF,7)*BCON/(BSTAR*BSTAR),SY(7)*BCON/(BSTAR*BSTAR),
     * SZ(7)*BCON/(BSTAR*BSTAR),XL(I+IOF,8)*BCON/(CSTAR*CSTAR),
     * SY(8)*BCON/(CSTAR*CSTAR),SZ(8)*BCON/(CSTAR*CSTAR),
     * XL(I+IOF,9)*BCON/(ASTAR*BSTAR),SY(9)*BCON/(ASTAR*BSTAR),
     * SZ(9)*BCON/(ASTAR*BSTAR),XL(I+IOF,10)*BCON/(ASTAR*CSTAR),
     * SY(10)*BCON/(ASTAR*CSTAR),SZ(10)*BCON/(ASTAR*CSTAR),
     * XL(I+IOF,11)*BCON/(BSTAR*CSTAR),
     * SY(11)*BCON/(BSTAR*CSTAR),SZ(11)*BCON/(BSTAR*CSTAR)
          ENDIF
    7 CONTINUE
  102 FORMAT(1X,A4,9F10.6,/,5X,9F10.6)
 1020 FORMAT(1X,' U: ',9F10.6,/,5X,9F10.6)
C 1020 FORMAT('  U:',6F10.6)
C
C         CALC SHIFTS IN FORM FACTORS
C
      DO 1010 K =1,NDS
      DO 1010 J=1,MAXFF
      DO 1010 KI=1,2          
          KM=LDFP(K,J,KI)
          IF(KM.EQ.0) THEN
              SY(J)=0.
              SZ(J)=0.
          ELSE
              SZ(J)=SQRT(ABS(SMM(KM,KM)))*ABS(ADFP(K,J,KI))
              SY(J)=V(KM)*ADFP(K,J,KI)*RELAX(3)
              IF (KI.EQ.1) THEN
                  DFP(K,J,1)=DFP(K,J,1)+SY(J)
                  WRITE(6,1030) NAM(K,J),K,DFP(K,J,1), SY(J), SZ(J)     
              ELSE
                  DFPP(K,J)=DFPP(J,J)+SY(J)
                  WRITE(6,1031) NAM(K,J),K,DFPP(K,J), SY(J), SZ(J)     
              ENDIF         
              IF (IPNUM(KM).EQ.0) THEN
                    NPAR=NPAR+1
                  ITEMP = MOD(J,MAXIPAR)
                  IF (ITEMP.EQ.0) ITEMP = 0
                  LTEMP = INT(J/MAXIPAR)+1
                  IPNUM(KM) = KI-1 + (J-1)*2 + (K-1)*MAXFF+ 128*17
                    IF (KI.EQ.1) THEN
                      PVAL(KM) = DFP(K,J,KI)
                  ELSE
                      PVAL(KM) = DFPP(K,J)
                    ENDIF
                  PERR(KM) = SZ(J)
                ENDIF
          ENDIF                     
 1010 CONTINUE
 1030 FORMAT(' DFP  FOR ATOM ',A4,' IN HISTOGRAM ',I2,' IS ',3F8.4)
 1031 FORMAT(' DFPP FOR ATOM ',A4,' IN HISTOGRAM ',I2,' IS ',3F8.4)
c
C             CALC SHIFTS/ERRORS IN GLOBAL VALUES
C
      DO 17 J=1,MAXIPAR*NDS          
          IF ((J.GE.6).AND.(J.LE.11)) GOTO 17                                         !SKIP THE LATTICE PARAMETERS
          KM=LPAR(IP,J)
          IF(KM.NE.0)GOTO 18
          SY(J)=0.
          SZ(J)=0.
          GOTO 17
   18     SZ(J)=SQRT(ABS(SMM(KM,KM)))*ABS(APAR(IP,J))
          SY(J)=V(KM)*APAR(IP,J)*RELAX(3)
          PAR(IP,J)=PAR(IP,J)+SY(J)
          IF (IPNUM(KM).EQ.0) THEN
              NPAR=NPAR+1
              ITEMP = MOD(J,MAXIPAR)
              IF (ITEMP.EQ.0) ITEMP = 0
              LTEMP = INT(J/MAXIPAR)+1
              IPNUM(KM) = ITEMP-1 + (IP-1)*26 + (LTEMP-1)*26*17 + 256*32
              PVAL(KM) = PAR(IP,J)
              PERR(KM) = SZ(J)
          ENDIF
   17 CONTINUE
C
C             WRITE OUT ALL THE PHASE INFORMATION
C
      ABG = 1.0 + 2.0*COS(DCV(4)*RAD)*COS(DCV(5)*RAD)*COS(DCV(6)*RAD) 
     *    - COS(DCV(4)*RAD)**2 - COS(DCV(5)*RAD)**2 - COS(DCV(6)*RAD)**2
      CELLV = DCV(1)*DCV(2)*DCV(3)*SQRT(ABG)
C             NOTE: CELL VOLUME ERROR IGNORES CROSS-CORRELATIONS (sorry folks!)
      CELLVE = 0.0
      DO 31 I=1,3
          CELLVE = CELLVE + ( SIN(DCV(MOD(I,3)+4)*RAD)*
     *       (COS(DCV(MOD(I,3)+4)*RAD) - COS(DCV(MOD(I+1,3)+4)*RAD)*
     *        COS(DCV(MOD(I+2,3)+4)*RAD))*DCSM(I+3,I+3)/ABG)**2
   31     CELLVE = CELLVE + (DCSM(I,I)/DCV(I))**2
      CELLVE = CELLV*SQRT(CELLVE)                  
C             QUANTATIVE PHASE VALUE S*V*Z USED IN PHASE ANALYSIS
      QPHASE(IP) = PAR(IP,1) * CELLV
C      QPHASE(IP) = PAR(IP,1) * CELLV * NZF(IP)
      QPHASEE(IP) =  SQRT( (CELLVE*PAR(IP,1))**2 + (CELLV*SZ(1))**2) 
c      QPHASEE(IP) = QPHASEE(IP)
C      QPHASEE(IP) = QPHASEE(IP) * NZF(IP)
      DENSITY(IP) = MW(IP)/CELLV*1.6598                                               !1amu = 1.6598 x 10^-27 kg
C      
      WRITE(6,103) IP,(PAR(IP,I),SY(I),SZ(I),I=1,2),
     * (DCV(I),DELCEL(I),DCSM(I,I),I=1,6),ASTAR,BSTAR,CSTAR,
     * ACOS(COSASR)/RAD,ACOS(COSBSR)/RAD,ACOS(COSCSR)/RAD,
     * CELLV,CELLVE,QPHASE(IP),QPHASEE(IP),MW(IP),DENSITY(IP)
      IF ((DENSITY(IP).GT.20.0).OR.(DENSITY(IP).LT.0.01)) WRITE(6,1103)
      WRITE(6,1104) 1/(LAMDA(NDS,1)**3)*8*3.1416*DENSITY(IP)*CELLV*
     *                 CELLV*PAR(IP,1)/STEP(NDS)
C
  103 FORMAT(/,'+----------------------------------------------------+',
     *       /,'|                Phase: ',i2,
     *       '                           |',
     *       /,'+----------------------------------------------------+', 
     */,1X,'PHASE SCALE FACTOR   = ',3G12.6,/,
     *1X,'OVERALL TEMP. FACTOR = ',3F10.6,/,
     *1X,'CELL PARAMETERS      = ',3F11.6,/,5(24X,3F11.6,/),
     *1X,'RECIPROCAL CELL      = ',6(F6.3,2X),/,
     *1X,'CELL VOLUME          = ',2F11.6,/,
     *1x,'SCALE * VOLUME       = ',2F11.6,/,
     *1X,'MOLECULAR WEIGHT     = ',F11.3,/,
     *1X,'DENSITY              = ',F11.3)
 1103 FORMAT(' NOTE: CHECK Z VALUE or N''s- DENSITY NOT PHYSICAL')
 1104 FORMAT(' ABSOLUTE PHASE VALUES:',/,
     *       '     INC  = NEUTRONS ON SAMPLE/CM^2 ( in cm^-2)',/,
     *       '     MASS = MASS OF PHASE IN BEAM (in g)',/,
c*       '     VOLS = VOLUME OF ENTIRE SAMPLE IN BEAM (in cm^3)',/
     *       '     ls/R = RATIO OF DETECTOR HEIGHT TO SAMPLE-DETECTOR',
     *     /,' Then:',/,
     *       '     INC*MASS*ls/R = ',G12.6)
C
C         CALC SHIFT/ERROR IN GLOBAL PARAMETERS  (once only)
C
      IF (IP.EQ.1) THEN
      DO 19 J=1,MAXGP
          KM=LGLB(J)
          IF(KM.NE.0)GOTO 20
          SYG(J)=0.
          SZG(J)=0.
          GOTO 19
   20     SZG(J)=SQRT(ABS(SMM(KM,KM)))*ABS(AGLB(J))
          SYG(J)=V(KM)*AGLB(J)*RELAX(4)
C          IF ((MOD(J,MAXIGL).NE.15).AND.(MOD(J,MAXIGL).NE.0)) GLB(J)=
C     >                                GLB(J)+SYG(J)
          GLB(J)=GLB(J)+SYG(J)
          IF ((MOD(J,MAXIGL).EQ.15).AND.(KM.LE.MAXS)) THEN                !WAVELENGTH 1 AND DIFC
              JDS =INT((MAXIGL-15+J)/MAXIGL)                      
              LAMOLD = LAMDA(JDS,1)
              LAMDA(JDS,1) = LAMOLD + SYG(J)
              IF (ISCW(JOBTYP(JDS))) LAMDA(JDS,2) = LAMDA(JDS,2)*          !FOR CW CHANGE LAMDA2 AS WELL
     *                              LAMDA(JDS,1)/LAMOLD
              
          ENDIF
          IF ((MOD(J,MAXIGL).EQ.16).AND.(KM.LE.MAXS)) THEN
              JDS =INT((MAXIGL-16+J)/MAXIGL)                      
              IF(ISTOF(JOBTYP(JDS))) THEN                                   !DIFA - FOR TOF ONLY
                  LAMDA(JDS,2) = LAMDA(JDS,2) + SYG(J)
              ENDIF
          ENDIF
          IF (IPNUM(KM).EQ.0) THEN
              NPAR=NPAR+1
              IPNUM(KM) = J-1
              PVAL(KM) = GLB(J)
              PERR(KM) = SZG(J)
          ENDIF
   19 CONTINUE         
      ENDIF
C
C         START LOOP OVER HISTOGRAMS
C
      DO 1920 JJ=1,NDS
C             WRITE OUT HISTOGRAM INFORMATION
      IF (ISDATA(JOBTYP(JJ))) THEN
          JP = (JJ-1)*MAXIPAR
          JPG = (JJ-1)*MAXIGL 
          WRITE(6,40) JJ,GLB(14+JPG),SYG(14+JPG),SZG(14+JPG),
     *                    GLB(1+JPG),SYG(1+JPG),SZG(1+JPG)                     !HIST.SCALE/ZERO
          IF (LGLB(15+JPG).NE.0) WRITE(6,129) LAMDA(JJ,1),SYG(15+JPG),
     *                                                   SZG(15+JPG)           !WAVELENGTH 1
          IF (LGLB(16+JPG).NE.0) WRITE(6,1291) LAMDA(JJ,2),SYG(16+JPG),
     *                                                   SZG(16+JPG)           !WAVELENGTH 2
          IF (LGLB(17+JPG).NE.0) WRITE(6,1292) GLB(17+JPG),SYG(17+JPG),
     *                                                   SZG(17+JPG)           !SAMPLE DISPLACEMENT
          IF(NBCKGD(JJ).LE.0) THEN
              DO 1110 JL = 2,7+IBCK*6
 1110             IF ((LGLB(JPG+JL).NE.0).OR.(GLB(JPG+JL).NE.0)) 
     *            WRITE(6,84) JL-2,GLB(JPG+JL),SYG(JPG+JL),SZG(JPG+JL)         !BACKGROUND
          ENDIF
          WRITE(6,105)(PAR(IP,I+JP),SY(I+JP),SZ(I+JP),I=12,14),
     &             PAR(IP,20+JP),SY(20+JP),SZ(20+JP),
     &            (PAR(IP,I+JP),SY(I+JP),SZ(I+JP),I=3,5)
      IF (IAP(JJ).NE.0) WRITE(6,1922) PAR(IP,19+JP),SY(19+JP),SZ(19+JP)
      IF ((NPROF(JJ).EQ.3).OR.(NPROF(JJ).EQ.5)) THEN
          WRITE(6,203)  PAR(IP,15+JP),SY(15+JP),SZ(15+JP),
     *                  PAR(IP,16+JP),SY(16+JP),SZ(16+JP),
     *                  PAR(IP,17+JP),SY(17+JP),SZ(17+JP)
          IF(PAR(IP,15).NE.0.) THEN
              PARSIZ=57.29577951*LAMDA(JJ,1)/PAR(IP,15)
              WRITE(6,70) PARSIZ
          ENDIF
      ELSE
          DO 1120 JL=15,17
 1120          WRITE(6,202)JL-15,PAR(IP,JL+JP),SY(JL+JP),SZ(JL+JP)
          IF (NPROF(JJ).EQ.7) WRITE(6,204) (PAR(IP,JP+JL),SY(JL+JP),
     *                                      SZ(JL+JP),JL=21,24)
      ENDIF
      WRITE(6,5000) PAR(IP,18+JP),SY(18+JP),SZ(18+JP)
      IF (IABSCOR(JJ).EQ.1) WRITE(6,5001) (PAR(IP,I+JP),SY(I+JP),
     *                                     SZ(I+JP),I=25,26)
      ENDIF
C               END OF LOOP OVER HISTOGRAMS
 1920 CONTINUE
   10 CONTINUE
C
C             END OF LOOP OVER PHASES      
C
   40 FORMAT(/,'+----------------------------------------------------+',
     *       /,'|               Histogram:',I2,
     *       '                         |',
     *      /,'+----------------------------------------------------+'/,
     *1X,'SCALE FACTOR                 = ',3G10.5,/,
     *1X,'ZEROPOINT                    = ',3F10.5,/)
  129 FORMAT(1X,'WAVELENGTH                   = ',3F15.6,/)
 1291 FORMAT(1X,'DIFA                         = ',3F15.6,/)
 1292 FORMAT(1X,'SAMPLE DISPLACEMENT          = ',3F10.5,/)
   84 FORMAT(1X,'BACKGROUND PARAMETER B',I2,'     = ',3G15.6)
  105 FORMAT(
     *1X,'PREFERRED ORIENTATION        = ',3F10.5,/,
     *1X,'ABSORPTION R                 = ',3F10.5,/,
     *1X,'ASYMMETRY PARAMETERS         = ',3F10.5,/,32X,3F10.5,/
     *1X,'HALFWIDTH PARAMETERS U       = ',3F15.6,/,
     *1X,'                     V       = ',3F15.6,/
     *1X,'                     W       = ',3F15.6)
 5000 FORMAT(1X,'EXTINCTION PARAMETER         = ',3F10.6,/)
 5001 FORMAT(1X,'ABOSRPTION PARAMETER C1      = ',3F10.6,/,
     *1X,'ABOSRPTION PARAMETER C1      = ',3F10.6)
  202 FORMAT(1X,'PEAK SHAPE PARAMETER  Gam',I1,'   = ',3F10.6)
  203 FORMAT(1X,'LORENZTIAN COMPONENTS       = ',3F10.6,2(/,31X,3F10.6)) 
  204 FORMAT(1X,'JORGENSEN ALPHA-0            = ',3F10.6,/,
     *1X,'JORGENSEN ALPHA-1            = ',3F10.6,/, 
     *1X,'JORGENSEN BETA-0             = ',3F10.6,/, 
     *1X,'JORGENSEN BETA-1             = ',3F10.6) 
   70 FORMAT(1X,'EQUIVALENT TO A PARTICLE SIZE OF ',F10.1,' ANGSTROMS'/)
 1922 FORMAT(1X,'ANISOTROPIC GAUSSIAN BROADENING = ',3F15.6)
      NUMT = 0            
      STOT = 0.0
C                 
C             Quantative Phase analysis section
C     
      IF (NPHASE.GT.1) THEN   
          QTOT = 0.0
          QMTOT = 0.0
          QTOTE = 0.0
          QMTOTE = 0.0
          DO 2000 J=1,NPHASE
              QMTOT = QMTOT + QPHASE(J)*MW(J)
              QMTOTE = QMTOTE + (QPHASEE(J)*MW(J))**2
              QTOTE = QTOTE + (QPHASEE(J)*NZF(J))**2
 2000         QTOT = QTOT + QPHASE(J)*NZF(J)
          IF (.NOT.MWNZERO) QMTOT = 1.0
          WRITE(6,2003) 
          DO 2001 J=1,NPHASE
              IF (QTOT.LE.0.0) QTOT = 1.0
              IF (QMTOT.LE.0.0) QTOT = 1.0
 2001         WRITE(6,2002) J,QPHASE(J)*NZF(J)/QTOT*100,
     *   100*SQRT( (QPHASEE(J)*NZF(J))**2 + 
     *              QTOTE*(QPHASE(J)*NZF(J)/QTOT)**2)/QTOT,
     *                        QPHASE(J)*MW(J)/QMTOT*100,
     *   100*SQRT( (QPHASEE(J)*MW(J))**2 + 
     *              QMTOTE*(QPHASE(J)*MW(J)/QMTOT)**2)/QMTOT
      ENDIF
 2002 FORMAT(1X,'PHASE ',I2,':   ',F6.2,2X,F6.2,12X,F6.2,2X,F6.2)
 2003 FORMAT(1X,'MOLAR PERCENTAGE OF PHASES:      ',
     *          'WEIGHT PERCENTAGE OF PHASES:')
c
c             R-Factor section
C    
      WRITE(6,*)
      WRITE(6,621)
      DO 630 J =1,NDS
      IF (ISDATA(JOBTYP(J))) THEN            
          X=100.*SQRT((FLOAT(NUM(J))-FLOAT(MAXS))*1./D2(J))
   60     I=NUM(J)-MAXS
          NUMT = NUM(J) + NUMT
          WRITE(6,62) J,R2(J),R3(J),X,DWD(J),WDWD(J),I
          S2(J)=S2(J)/FLOAT(I)
          STOT = STOT + S2(J)
          WRITE(7,59) J,R2(J),R3(J),S2(J)
		THERS(J,1) = R2(J)
		THERS(J,2) = R3(J)
		THERS(J,3) = X
      ENDIF
  630 CONTINUE
c
      WRITE(6,631)
      DO 1130 J=1,NDS
	   THERS(J,4) = S2(J)
 1130    WRITE(6,63) S1(J),D1(J),S3(J),D2(J),S2(J),COND
      WRITE(6,632)
C
      IF (NDS.GT.1) THEN
          WRITE(7,*)'--------------------------------------------------'
          WRITE(7,590) R2TOT, R3TOT,STOT
          WRITE(6,591) R2TOT, R3TOT,STOT
      ENDIF
c
   59 FORMAT(' HIST:',I2,'   RP = ',F6.2,'   RWP = ',F6.2,'   GOF = ',
     *        F6.2)
  590 FORMAT(' TOTALS:   RP = ',F6.2,'   RWP = ',F6.2,'   GOF = ',F6.2)
  591 FORMAT(' TOTALS R-FACTORS:',/,10X,'RP = ',F6.2,'   RWP = ',F6.2,
     *       '   GOF = ',F6.2)
   62 FORMAT('|',2X,I4,2X,3('|',F7.2,1X),2('|',F11.3,2X),'|',I6,2X,'|')
   63 FORMAT(6(1H|,E11.4),1H|)
  621 FORMAT('+',72('-'),'+',/,'|  Hist  |   Rp   |   Rwp  |   Rexp |',
     *'Durbin Unwght| Durbin Wght |   N-P  |',/,'+',72('-'),'+')
  631 FORMAT(1H+,71(1H-),1H+,/,'|  SUMYDIF  |  SUMYOBS  |  SUMYCALC |',
     *' SUMWYOBSSQ |    GOF   | CONDITION |',/,'+',71('-'),'+')
  632 FORMAT('+',71('-'),'+',/)
      RETURN
      END
c
      SUBROUTINE DIRECT(SM,V,IPH)
      include 'param.inc'
C      COMMON/F1/RJAC(MSZ2),VX(MSZ),OCHI
      COMMON/F3/SMM(MSZ,MSZ)
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      DIMENSION V(6),SM(6,6)
      DO 1 J=1,6
          V(J)=PAR(IPH,J+5)
          K=LPAR(IPH,J+5)
          X=APAR(IPH,J+5)
          IF(K.EQ.0)X=0.
          DO 1 L=J,6
              M=LPAR(IPH,L+5)
              SM(L,J)=0.
              IF((M.EQ.0).OR.(K.EQ.0))GOTO 1
              SM(L,J)=SMM(M,K)*X*APAR(IPH,L+5)
    1 SM(J,L)=SM(L,J)
      CALL ESD(SM,V,1.)
      RETURN
      END
c
c**********************************************************************************
c
c        Generates the new calculated pattern
      SUBROUTINE SUMMAT(IPM,NDS,ERROR)
      include 'param.inc'
      REAL LAMDA,DVALUE,RAD                                                      
      INTEGER PTR,NDS,ERROR
      COMMON/F1/RJAC(MSZ2),V1(MSZ),OCHI
      INTEGER, Pointer::  IREFS(:,:),IC(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,IC
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      CHARACTER SYMB(NUPH,20)*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      CHARACTER*4 NAM(MAXDS,MAXFF)
      COMMON/COEFC/NAM
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      COMMON/G3/COND,IORD1,IORD2,TH,NUM(MAXDS)
      COMMON/G4/TANN(NIPOI),DERSTO(NIPOI,MSZ)
      COMMON/PRFX/TANTH,TL,GAM,PASYM,PASYM2,DERHW,DERGAM,DERASY,DERZ,
     *    DERTTB,DERASY2
      COMMON/PRTOF/ALPHA,BETA,DERALPHA,DERBETA,RV,DERRV
      REAL, POINTER:: COBS(:,:),SOMEGA(:,:),VAR(:,:)
      COMMON/RBRAGG/COBS,SOMEGA,VAR
      DIMENSION DERIV(MSZ), BDERIV(24)
      DIMENSION DUMP(NIPOI),SOME(NIPOI)
      LOGICAL VERT,TOF,CALC,ISCALC,ISTOF                      
C
      ERROR = 0
	RAD = 3.141592654/180
      JP = (NDS-1)*MAXIPAR
      JG = (NDS-1)*MAXIGL
      TOF = ISTOF(JOBTYP(NDS))
      CALC = ISCALC(JOBTYP(NDS))
      DO 2 J=1,MAXS
    2   DERIV(J)=0.
      YCALC=0.
C-----CALCULATE THE CONTRIBUTION OF THE REFLECTIONS ORD1 TO ORD2 TO THE
C-----DERIVATIVES W.R.T. THE PROFILE INTENSITY YOBS
      IF(IORD1.EQ.0)GOTO 12
      DO 33 I=IORD1,IORD2   
      IPH=IREFS(NDS,I)/256/256/256/4
      J=MOD(I,NIPOI)+1
      ICZ=MOD(IREFS(NDS,I)/256/256/256,4)
C
      DVALUE = REFS(NDS,I,2)                                                  
      IF (NPROF(NDS).EQ.7) THEN
          IF (TOF) THEN
              ALPHA = PAR(IPH,JP+21) + PAR(IPH,JP+22)/DVALUE              !ALPHA AND BETA FOR JORGENSEN PEAK SHAPE
              BETA = PAR(IPH,JP+23) + PAR(IPH,JP+24)/DVALUE**4            !
          ELSE
              ALPHA = PAR(IPH,JP+21) + PAR(IPH,JP+22)*DVALUE              !ALPHA AND BETA FOR JORGENSEN PEAK SHAPE
              BETA = PAR(IPH,JP+23) + PAR(IPH,JP+24)*DVALUE               !
          ENDIF
      ENDIF
C                         -----VERT=.TRUE. IF RIETVELD ASYMMETRY CORRECTION IS TO BE APPLIED
      VERT=(REFS(NDS,I,2).LE.RLIM).AND.(NPROF(NDS).LT.4)
C
      IF (TOF) THEN
        DELTA=TH-TVAL(REFS(NDS,I,2),LAMDA(NDS,1),LAMDA(NDS,2),GLB(1+JG))      !TOF AWAY FROM REFLECTION
      ELSE
        DELTA=TH-REFS(NDS,I,2)-GLB(1+JG)										!ANGLE AWAY FROM REFLECTION
        IF(IGEOM(NDS).EQ.1) THEN
	      DELTA=DELTA-SDISP(REFS(NDS,I,2)*RAD,GLB(17+JG))		          !sample displacement
        ENDIF
      ENDIF               
      DELT=DELTA*DELTA
      TANTH=TANN(J)                                                       !2THETA POSITION OR TOF POSITION (NOT D VALUE)
      TL=REFS(NDS,I,1)                                                    !GAUSS WIDTH
      GAM=REFS(NDS,I,4)                                                   !SHAPE FOR PSEDUO/PEARSON
C     IF(NPROF(NDS).EQ.3.OR.NPROF(NDS).EQ.5) THEN
C	GAM=(PAR(IPH,15+JP)+PAR(IPH,17+J))*SQRT(1+TANTH*TANTH) + 		!SHAPE FOR VOIGT
C    *         PAR(IPH,16+JP)*TANTH
C     ENDIF
C	IF(NPROF(NDS).EQ.3)GAM=PAR(IPH,15+JP)*SQRT(1+TANTH*TANTH)           !OLD SHAPE FOR VOIGT
      PASYM=PAR(IPH,14+JP)                                                 !ASYM
      PASYM2=PAR(IPH,20+JP)                                                !ASYM 2
      IF(.NOT.VERT)GOTO 4                                                 
          YX=DELT*SIGN(1.,DELTA)                                          !ONLY FOR RIETVELD ASYM
          Z=1.0 - PAR(IPH,14+JP)*YX/TANN(J)
          IF(Z.LE.0.)Z=.0001
      GOTO 5
    4 Z=1.                                                                !PAGE 2
 
    5 OMEGA=REFS(NDS,I,3)*Z*PROFIL(NPROF(NDS),DELTA)*
     *                      PAR(IPH,1)*GLB(14+JG)                          !OMEGA = SCALE(S)*LORENTZ*GPEAK
      IDUMP=I+1-IORD1
      IF (FF(NDS,I).LE.FFMIN) THEN
          DUMP(IDUMP)=OMEGA*FFMIN                                         !NEEDED WHEN YOU NEED SHELX OUTPUT
          YCALC=YCALC+OMEGA*FFMIN                                         !YCALC FOR ZERO PEAKS
      ELSE
          DUMP(IDUMP)=OMEGA*FF(NDS,I)
          YCALC=YCALC+OMEGA*FF(NDS,I)                                     !YCALC = S*L*G*FF
      ENDIF
      SOME(IDUMP)=OMEGA
      IF(CALC)GOTO 33                                                   !if calc jump over the derivs
C        A CALL TO PROFIL MUST HAVE BEEN CALLED BEFORE GETTING THE DERIVS OF DERIVHW
c
      DO 3 K=1,MAXS                                                           !DERIVS
          DER=1.
          DO 6 M=3,5
              IF(K.EQ.LPAR(IPH,M+JP)) DER=DERHW                           !DER = DERIV FOR U,V,W 
    6     CONTINUE                                                        !      (CALCULATED IN PROFIL)
          X1=0.                                                           
          IF(VERT)X1=2.0*PAR(IPH,14+JP)*SIGN(1.,DELTA)/(TANN(J)*Z)          !ONLY FOR RIETVELD ASYM
          IF(K.EQ.LGLB(1+JG)) DER=DELTA*X1+DERZ                           !DERIV OF ZERO (IN PROFIL)  (FOR SUM OF 5 IT IS JUST = TO DERZ)
          IF(K.EQ.LGLB(17+JG)) DER=DERZ                                   !DERIV OF ZERO (IN PROFIL)  (FOR SUM OF 5 IT IS JUST = TO DERZ)
          IF(K.EQ.LPAR(IPH,14+JP)) DER=DERASY                             !DERIV OF ASYM
          IF(K.EQ.LPAR(IPH,14+JP).AND.VERT)DER=-YX/(TANN(J)*Z)              !   +IF RIETVELD ASYM
          IF(K.EQ.LPAR(IPH,15+JP)) DER=DERGAM                             !DERIV OF SHAPE
          IF(K.EQ.LPAR(IPH,16+JP)) DER=DERGAM                                   !"
          IF(K.EQ.LPAR(IPH,17+JP)) DER=DERGAM                                   !"
          IF(K.EQ.LPAR(IPH,19+JP)) DER=DERHW                              !FOR ANISO
          IF(K.EQ.LPAR(IPH,20+JP)) DER=DERASY2                            !FOR FINGER ASYM
          IF (NPROF(NDS).EQ.7) THEN      
              IF(K.EQ.LPAR(IPH,21+JP)) DER=DERALPHA                           !DERIV OF ALPHA
              IF(K.EQ.LPAR(IPH,22+JP)) DER=DERALPHA                           !    "
              IF(K.EQ.LPAR(IPH,23+JP)) DER=DERBETA                            !DERIV OF BETA 
              IF(K.EQ.LPAR(IPH,24+JP)) DER=DERBETA                            !    "
          ENDIF
          IF(LGLB(15+JG).EQ.K) DER=DELTA*X1+DERTTB                        !LAMBA AND DIFC (SEEMS TO WORK BUT STILL UNSURE)
          IF(LGLB(16+JG).EQ.K) DER=DELTA*X1+DERTTB                        !DIFA
    8     DO 7 M=6,11
              IF(LPAR(IPH,M).EQ.K) DER=DELTA*X1+DERTTB                    !DERIV OF A,B,C,ALPHA...
    7     CONTINUE
    3 DERIV(K)=DERSTO(J,K)*DER*OMEGA+DERIV(K)                             !MULT WITH DERIVS OF FORM FACTOR  x PROFILE
c      write(*,*) PROFIL(NPROF(NDS),DELTA),delta,derhw
   33 CONTINUE                                                            !DERSTO ARE DERIV FROM F^2
C         BACKGROUND DERIVS
   12 IF(NBCKGD(NDS).GT.0)GOTO 11
      CALL BACKDER(NDS,NBCKGD(NDS),TH,TOF,BDERIV,IBCK,ERROR)
      IF (ERROR.NE.0) RETURN
      DO 1050 I=1,6*(IBCK+1)
          KM=LGLB(JG+I+1)
 1050     IF (KM.NE.0) DERIV(KM) = BDERIV(I)
C
C-----FORM SUMS
   11 YC(NDS,IPM)=YCALC
      IF(IWT(NDS).EQ.1.AND.MCYCLE.GT.1)
     *  WT(NDS,IPM)=1.0/(YC(NDS,IPM)+BK(NDS,IPM))
      DELTA=Y(NDS,IPM)-(BK(NDS,IPM)+YCALC)
      JK = 0
      DO 9 J=1,MAXS
        X=DERIV(J)*WT(NDS,IPM)                                            ! V1= (yio-yic)*wi* dyic
        V1(J)=V1(J)+DELTA*X												!                   dxm
        DO 9 K=J,MAXS
          JK = JK + 1                                                   
   9      RJAC(JK)=RJAC(JK)+X*DERIV(K)                                    !GENERATE M MATRIX
      IF(IORD1.EQ.0) GO TO 20
C     SET UP ARRAY OF CALCULATED OBSERVATIONS
      IF(CALC) WT(NDS,IPM)=1.0/(YC(NDS,IPM)+BK(NDS,IPM))
      DO 30 I=IORD1,IORD2
          IDUMP=I-IORD1+1
          SOMEGA(NDS,I)=SOMEGA(NDS,I)+SOME(IDUMP)
          IF(NBCKGD(NDS).GE.1) GO TO 29
          FRAC=DUMP(IDUMP)/(YCALC+BK(NDS,IPM))
          COBS(NDS,I)=COBS(NDS,I)+Y(NDS,IPM)*FRAC
          VAR(NDS,I)=VAR(NDS,I)+FRAC*FRAC/WT(NDS,IPM)
c          write(*,*) I, FRAC, YCALC, BK(NDS,IPM)
          GO TO 30
   29     IF(YCALC.EQ.0) GO TO 30
          FRAC=DUMP(IDUMP)/YCALC
          COBS(NDS,I)=COBS(NDS,I)+(Y(NDS,IPM)-BK(NDS,IPM))*FRAC
          VAR(NDS,I)=VAR(NDS,I)+FRAC*FRAC/WT(NDS,IPM)
   30 CONTINUE
   20 RETURN
      END
c                                     
c         Sorts reflection list
      SUBROUTINE SORT(IPHASE,NDS,IRS)
      include 'param.inc'
      INTEGER, Pointer::  IREFS(:,:),ICX(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,ICX
      REAL, POINTER:: COBS(:,:),SOMEGA(:,:),VAR(:,:)
      COMMON/RBRAGG/COBS,SOMEGA,VAR
      DIMENSION L(IRS),TEMP(IRS),ITEMP(IRS)
C      EQUIVALENCE (ITEMP(1),TEMP(1))
      IOF=0
      IF(IPHASE.GE.2) THEN
          DO 36 I=1,IPHASE-1
   36     IOF=IOF+ICX(NDS,I)
      ENDIF
      IC=ICX(NDS,IPHASE)
      DO 2 I=1,IC
    2 L(I)=I
      M=IC-1
      DO 15 LL=1,5000                                                     !?5000 - CAN IT BE IC AND WORK THE SAME?
      K=0
      DO 10 J=1,2
      DO 10 I=J,M,2
      INP=L(I)+IOF
      INP1=L(I+1)+IOF
      R=REFS(NDS,INP1,2)-REFS(NDS,INP,2)
      IF(R) 20,10,10
   20 IZ=L(I)
      L(I)=L(I+1)
      L(I+1)=IZ
      K=K+1
   10 CONTINUE
      IF(K.EQ.0) GO TO 5
   15 CONTINUE
    5 DO 30 I=1,IC
   30 ITEMP(I)=IREFS(NDS,I+IOF)
C
      DO 31 I=1,IC
      LX=L(I)
      IREFS(NDS,I+IOF)=ITEMP(LX)
   31 CONTINUE
C
      DO 33 J=1,4
      DO 32 I=1,IC
   32 TEMP(I)=REFS(NDS,I+IOF,J)
      DO 33 I=1,IC
      LX=L(I)
   33 REFS(NDS,I+IOF,J)=TEMP(LX)
C
      DO 34 I=1,IC
   34 TEMP(I)=FF(NDS,I+IOF)
C
      DO 35 I=1,IC
      LX=L(I)
   35 FF(NDS,I+IOF)=TEMP(LX)

      DO 46 I=1,IC
   46 TEMP(I)=COBS(NDS,I+IOF)
      DO 47 I=1,IC
      LX=L(I)
   47 COBS(NDS,I+IOF)=TEMP(LX)
C
      RETURN
      END
c
c**********************************************************************************
c
c          Gets the scattering factors
      SUBROUTINE LOOKUP(K,N,NSCAT,IXRAY,FLAG,JDS,ERROR)
      include 'param.inc'
      INTEGER PTR,TBXPTR,JDS,ERROR
      CHARACTER*4 TABNC(128),TBXC(256)
      COMMON/TABCHR/TABNC,TBXC
      COMMON/TABLES/TBX(256,10),TBD(128,10),TABN(128),TABMW(128)
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      CHARACTER*4 NAM(MAXDS,MAXFF)
      COMMON/COEFC/NAM
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/DC/SAVE(NUPH,6),NSAVE
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT1(MAXDS)
      CHARACTER SYMB(NUPH,20)*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80, NTEMP*4
      COMMON/CHAR/SYMB,TITLE,PHSNM
      INTEGER FLAG,JPLUS,JMINUS
      ERROR = 0
      IOF=0
      NS=0
      IF(K.GT.1) THEN                                                     !K=PHASE NUMBER
      DO 121 I=1,K-1                                                      !N=NUMBER OF ATOMS
  121 IOF=IOF+ABS(NATOM(I))                                                    !FLAG=1 XRAYS
      ENDIF                                                               !     2 NEUTRONS
      IF ((K.GT.1).OR.(FLAG.EQ.3))NS=NSAVE                                !     3 NEUTRONS AFTER XRAYS
      IF ((FLAG.EQ.2).OR.(FLAG.EQ.3)) GOTO 70                              !3 NOT USED NOW
c         X-RAY LOOKUP
      DO 10 I=1,N
          NS=MAX0(NSCAT,NS)                                               !
          DO 20 J=1,NS                                                    !CHECK ATOM IF IT IS IN USER LIST
              IF(NTYP(I+IOF).EQ.NAM(JDS,J)) GOTO 30                       !
   20     CONTINUE
          DO 40 J=1,214
              IF(NTYP(I+IOF).EQ.TBXC(J)) GOTO 50                          !CHECK ATOM TO SEE IF IN BLOKDATA TABLE
   40     CONTINUE
          WRITE(6,41)NTYP(I+IOF)                                          !PRINT MESSAGE IF NOT FOUND ANYWHERE
   41 FORMAT(' SCATTERING COEFFICIENTS NOT FOUND FOR ',A4)
          ERROR = 50
          GOTO 998
   30     PTR(JDS,I+IOF)=J                                                !USER ATOM FOUND IN LIST-SO SET POINTER AND RETURN
          GOTO 10
   50     NS=NS+1                                                         !ADD NEW ENTRY FROM BLOKDATA TABLE
          PTR(JDS,I+IOF)=NS                                               !POINT TO IT
          DO 60 L=1,9
   60         AC(JDS,L,NS)=TBX(J,L)                                       !GET VALUES FROM TABLE
          NAM(JDS,NS)=TBXC(J)
          TBXPTR=TBX(J,10)+0.5
          DFP(JDS,NS,1)=TBD(TBXPTR,IXRAY)
          DFPP(JDS,NS)=TBD(TBXPTR,IXRAY+5)
   10 CONTINUE
      NSAVE=NS
      RETURN
C         NEUTRON LOOKUP
   70 DO 80 I=1,N
          NS=MAX0(NSCAT,NS)
          DO 90 J=1,NS                
              IF(NTYP(I+IOF).EQ.NAM(JDS,J))GOTO 100                       !FOUND IN USER LIST
   90     CONTINUE
   91 CONTINUE                                                            !88 = NUMBER OF BLOKDATA ENTRIES
          DO 110 J=1,88                                                   
              NTEMP = NTYP(I+IOF)                                         !USED WHEN JOINT X-RAY/NEUTRON
              JPLUS = INDEX(NTEMP,'+')                                    !AND X-RAY SCATTERING HAS +1,..+5 OR -1
              JMINUS = INDEX(NTEMP,'-') 
              IF (JPLUS.NE.0) NTEMP=NTEMP(1:(JPLUS-1))
              IF (JMINUS.NE.0) NTEMP=NTEMP(1:(JMINUS-1))
              IF(NTEMP.EQ.TABNC(J))GOTO 120                               !FOUND IN DATABASE
C              IF(NTYP(I+IOF).EQ.TABNC(J))GOTO 120                         !FOUND IN DATABASE (OLD LINE)
  110     CONTINUE
          WRITE(6,111)NTYP(I+IOF)
  111 FORMAT(' SCATTERING LENGTHS NOT FOUND FOR ',A4)
          ERROR = 50
          GOTO 998
  100     PTR(JDS,I+IOF)=J
          IF ((J.GT.NSCAT).AND.(FLAG.EQ.3)) GOTO 91
          GOTO 80
  120     IF (FLAG.NE.3) THEN
              NS=NS+1
              PTR(JDS,I+IOF)=NS
          ENDIF
          DFP(JDS,PTR(JDS,I+IOF),2)=TABN(J)
          NAM(JDS,PTR(JDS,I+IOF))  =TABNC(J)
   80 CONTINUE
      NSAVE=NS
  998 RETURN
      END
c
c**********************************************************************************
c
C         Get the atomic weights from the TABMW table
C
      FUNCTION GETMASS(CHATOM)
      CHARACTER CHATOM*4,CHLOOK*4    
      CHARACTER*4 TABNC(128),TBXC(256)
      COMMON/TABCHR/TABNC,TBXC
      COMMON/TABLES/TBX(256,10),TBD(128,10),TABN(128),TABMW(128)
      INTEGER JPLUS,JMINUS
      REAL MW
      CHLOOK = CHATOM
      JPLUS = INDEX(CHATOM,'+')                                    
      JMINUS = INDEX(CHATOM,'-') 
      IF (JPLUS.NE.0) CHLOOK=CHATOM(1:(JPLUS-1))
      IF (JMINUS.NE.0) CHLOOK=CHATOM(1:(JMINUS-1))
      MW = 0.0
      DO 10 I=1,128
   10     IF (CHLOOK.EQ.TABNC(I)) MW = TABMW(I)
      GETMASS = MW
      RETURN
      END
c
c**********************************************************************************
c
c       Converts a,b,c  to A,B,C used in the refinement
C
      SUBROUTINE CELL2(ERROR)
      include 'param.inc'
      COMMON/SPG/NSPGRP,K,FILL(13)
      COMMON/CELLX/A,B,C,ALPHA,BETA,GAMMA,AL(3,3)
      EQUIVALENCE (AL(1,1),ASTAR),(AL(2,2),BSTAR),(AL(3,3),CSTAR),
     *(AL(1,2),BACOSC),(AL(1,3),CACOSB),(AL(2,3),BCCOSA)
   35 FORMAT (' THE LAUE SYMMETRY IS ',A8)
      INTEGER ERROR
      CHARACTER*8 LAU(14)
      DATA LAU(1),LAU(2),LAU(3),LAU(4),LAU(5),LAU(6),LAU(7),LAU(8),
     *LAU(9),LAU(10),LAU(11),LAU(12),LAU(13),LAU(14)
     */'1BAR','2/M','MMM','4/M','4/MMM','3BAR   R','3BAR M R','3BAR',
     *'3BAR M 1','3BAR 1 M','6/M','6/MMM','M3','M3M'/
c      SIN1(A) = SIN(A*6.28318531)
      COS1(A) = COS(A*6.28318531)
      ERROR = 0
      WRITE(6,35)LAU(NSPGRP)
      IF ( K.GT.3 ) THEN
         WRITE(7,*) 'ERROR IN CELL2'
         ERROR = 51
         GOTO 998
      ENDIF
c            Tri  Mono orth  tet  tet  tri  tri  tri  tri  tri  hex  hex  cub  cub
      GO TO (1002,1071,1072,1073,1073,1074,1074,1075,1075,1075,1075,
     1 1075,1076,1076),NSPGRP
 1071 IF ( K.NE.1 ) ALPHA=90.0
      IF ( K.NE.2 ) BETA=90.0
      IF ( K.NE.3) GAMMA=90.0
      GO TO 1002
 1073 B = A
 1072 ALPHA = 90.0
      BETA = 90.0
      GAMMA = 90.0
      GO TO 1002
 1074 B = A
      C = A
      BETA = ALPHA
      GAMMA = ALPHA
      GO TO 1002
 1075 B = A
      ALPHA = 90.
      BETA = 90.0
      GAMMA = 120.0
      GO TO 1002
 1076 B = A
      C = A
      GO TO 1072
 1002 COSA = COS1(ALPHA/360.0)
  105 COSB = COS1(BETA/360.0)
 1052 COSC = COS1(GAMMA/360.0)
 1053 SINA=SQRT(1.0-COSA**2)
      SINB=SQRT(1.0-COSB**2)
      SINC=SQRT(1.0-COSC**2)
      COSASR=(COSB*COSC-COSA)/(SINB*SINC)
      COSBSR=(COSA*COSC-COSB)/(SINA*SINC)
      COSCSR=(COSA*COSB-COSC)/(SINA*SINB)
      SINASR=SQRT(1.0-COSASR**2)
      SINBSR=SQRT(1.0-COSBSR**2)
      ASTAR=1.0/(A*SINC*SINBSR)
      BSTAR=1.0/(B*SINC*SINASR)
      CSTAR=1.0/(C*SINA*SINBSR)
      BCCOSA=BSTAR*CSTAR*COSASR*2.0
      CACOSB=CSTAR*ASTAR*COSBSR*2.0
      BACOSC=BSTAR*ASTAR*COSCSR*2.0
      ASTAR=ASTAR*ASTAR
      BSTAR=BSTAR*BSTAR
      CSTAR=CSTAR*CSTAR
  998 RETURN
      END
c
c**********************************************************************************
c
      FUNCTION MULT(IH,IK,IL)
      include 'param.inc'
      COMMON/SPG/NSPGRP,K,M(10),FILL(3)
      P = 1.0
      GO TO (220,100,110,120,130,150,180,140,170,160,170,190,200,210),        !THE 14 BRAVIAS LATTICES
     *NSPGRP
  100 IF ( IH ) 220,220,101
  101 CONTINUE
      IF ( K.EQ.3 ) GO TO 1010
      IF ( IK ) 220,220,102
 1010 IF ( IL ) 220,220,102
  102 P = 2.0
      GO TO 220
  110 IF ( IH ) 112,112,111
  111 P = 2.0*P
  112 IF ( IK ) 114,114,113
  113 P = 2.0*P
  114 IF ( IL ) 220,220,115
  115 P = 2.0*P
      GO TO 220
  120 IF ( IK ) 220,220,121
  121 P = 2.0*P
      IF ( IL ) 220,220,122
  122 P = 2.0*P
      GO TO 220
  130 IF ( IK ) 220,220,131
  131 P = 2.0*P
      IF ( IH ) 134,134,132
  132 IF ( IH-IK ) 133,134,134
  133 P = 2.0*P
  134 IF ( IL ) 220,220,135
  135 P = 2.0*P
      GO TO 220
  140 IF ( IH+IABS(IK) ) 142,142,141
  141 P = 3.0*P
  142 IF ( IL ) 220,220,143
  143 P = 2.0*P
      GO TO 220
  150 IF ( IH+IK+IL ) 151,152,151
  151 P = 2.0*P
  152 IF ( IH-IK ) 153,154,153
  153 P = 3.0*P
      GO TO 220
  154 IF ( IH-IL ) 153,220,153
  160 IF ( IK ) 220,220,161
  161 P = 3.0*P
      IF ( IK-IH ) 220,220,162
  162 IF ( IH ) 220,220,135
  170 IF ( IL ) 172,172,171
  171 P = 2.0*P
  172 IF ( IH ) 174,174,173
  173 P = 3.0*P
      IF ( IK ) 220,220,135
  174 IF ( IK ) 220,220,153
  180 IF ( IH-IK ) 182,181,182
  181 IF ( IH-IL ) 183,220,183
  182 IF ( IK-IL ) 184,183,184
  183 P = P/2.0
  184 P = 3.0*P
      IF ( IH+IK+IL ) 135,220,135
  190 IF ( IK ) 194,194,191
  191 P = 6.0*P
      IF ( IH ) 192,194,192
  192 IF ( IK-IH ) 193,194,193
  193 P = 2.0*P
  194 IF ( IL ) 135,220,135
  200 IF ( IH-IK ) 203,201,203
  201 IF ( IK-IL ) 203,202,203
  202 P = 4.0
      GO TO 220
  203 P = 3.0
      IF ( IK ) 205,205,204
  204 P = 2.0*P
  205 IF ( IH ) 220,220,135
  210 IF ( IH ) 211,214,211
  211 P = 4.0
      IF ( IH-IL ) 212,220,212
  212 P = 3.0*P
      IF ( IH-IK ) 213,220,213
  213 IF ( IK-IL ) 135,220,135
  214 P = 3.0
      IF ( IK ) 215,220,215
  215 P = 2.0*P
      IF ( IK-IL ) 135,220,135
  220 MULT=P
      GO TO (1,1,2,1,1,2,2,2,2,1,2,2,1,1), NSPGRP
    1 MULT = MULT*2.0
    2 RETURN
      END
c
c**********************************************************************************
c
C     some additional routinues for those extravagent frills
      SUBROUTINE HPSORT(N,RA,NP)
      DIMENSION RA(N)
      L=NP/2+1
      IR=NP
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END                        
c
c**********************************************************************************
c
C       RETURNS A SKEWED MEAN VALUE OF THE DATASET (~BACKGROUND)
      FUNCTION YMEAN(J,IDSZ,NP)
      INCLUDE 'param.inc'
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      DIMENSION YM(IDSZ)
      INTEGER J,I
      DO 1000 I = 1,NP
 1000     YM(I) = Y(J,I)
      CALL HPSORT(IDSZ,YM,NP)                                                 !WHY DIVIDE BY 4? - BECAUSE IT MISSES
      YMEAN = YM(INT(NP/4))                                                   !THE DEVIANT LOW POINTS AND THE BRAGG
      RETURN                                                                  !PEAKS
      END     
c
c**********************************************************************************
c
C         FUNCTION TO CONVERT TO D FROM TOF
      FUNCTION DVAL(TOFV,DIFC,DIFA,ZERO)
      REAL TOFV,DIFC,DIFA,ZERO,DV  
c      IF (DIFA.NE.0) THEN
c          DVAL = (-DIFC + SQRT(DIFC*DIFC - 4*DIFA*(ZERO-TOFV)))/2*DIFA        
c      ELSE
c          DVAL = (TOFV-ZERO)/DIFC
c      ENDIF
c             simple approximation (WORKS FOR DIFA ~ 0)
      DV = (TOFV-ZERO)/DIFC
      DVAL = (TOFV-ZERO)/(DIFC - DIFA*DV)
      RETURN
      END
c
c**********************************************************************************
c
C         FUNCTION TO CONVERT FROM D TO TOF
      FUNCTION TVAL(DV,DIFC,DIFA,ZERO)
      REAL DV,DIFC,DIFA,ZERO          
      TVAL = DIFC*DV + DIFA*DV*DV +ZERO
      RETURN
      END                  
c
c**********************************************************************************
c
C        FUNCTION TO CALCULATE INCIDENT SPECTRUM
      REAL FUNCTION FINSPEC(JDS,TOFV)
      INCLUDE 'param.inc'
      REAL TOFV,T1,T2
      INTEGER JDS
      COMMON/CTOF/A(MAXDS,9),PALP(2),PBET(2)
      FINSPEC = 0.0
      IF (TOFV.NE.0) THEN
          T1 = TOFV*0.001                                                     
          T2 = T1*T1
          FINSPEC = A(JDS,1) + A(JDS,2)*EXP(-A(JDS,3)/T2)/(T1*T2*T2) + 
     &              A(JDS,4)*EXP(-A(JDS,5)*T2) +
     &              A(JDS,6)*EXP(-A(JDS,7)*T1*T2) +
     &              A(JDS,8)*EXP(-A(JDS,9)*T2*T2)
      ENDIF
      RETURN
      END
c
c**********************************************************************************
c
C             INTERPOLATE THE INPUT FORM FACTORS
      REAL FUNCTION FFINT(Q,J)
      INCLUDE 'param.inc'
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      INTEGER I,J
      REAL Q
      LOGICAL FOUND               
      FOUND = .FALSE.
      DO 1010 I=2,MFCO-1
          IF (Q.NE.0) THEN
          IF((POSI(I-1,J).LE.Q).AND.(POSI(I,J).GT.Q)) THEN
              FFINT = SCAT(I-1,J)+(SCAT(I,J)-SCAT(I-1,J))/
     *                (POSI(I,J)-POSI(I-1,J))*(Q - POSI(I-1,J))
              FOUND = .TRUE.
          ENDIF   
          ELSE
              FFINT = SCAT(1,J)                                               !if q = 0
          ENDIF 
 1010 CONTINUE
      IF (.NOT.FOUND) FFINT = 0.0                                             !if q not within the limits
      RETURN
      END
c
c**********************************************************************************
c
C           MAGNETIC FORM FACTOR
      REAL FUNCTION FFMAG(Q,J)
      REAL Q
      INTEGER J
      Q = 1
	  J = 1
	  FFMAG = 1.0
      RETURN
      END
C